<%@ page language="java" pageEncoding="UTF-8" contentType="text/html; charset=UTF-8"%>
<%@ page import="com.lombardisoftware.servlet.exceptions.LswTagException,
                 com.lombardisoftware.core.config.TWConfiguration" %>
<%@ page import="java.net.URLEncoder" %>
<%@ include file="html/common/prolog.jsp" %>
<%@ include file="html/msgs-init.jsp" %>
<html>
<head>
    <title><bean:message key="process_server.autoLogin.title" /></title>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <script type="text/javascript" src="/portal/js/dojo/1.6.1/dojo/dojo.js"></script>
    <link rel="stylesheet" href="<%= com.lombardisoftware.core.PortalSkinUtilities.getPortalSkinPath(request) %>/login.css" TYPE="text/css">
    <link rel="stylesheet" href="<%= com.lombardisoftware.core.PortalSkinUtilities.getPortalSkinPath(request) %>/login_console.css" TYPE="text/css">
<%
    String successPage = request.getParameter("sp");
    if (successPage == null) {
        successPage = "/teamworks/cs_main.lsw";
    }
%>
    <script type="text/javascript">
    dojo.require("dijit._base.sniff");

AutoLogin.prototype = {
    init : function() {
        <%-- Auto-login only works with IE - with firefox, it'll challenge for a username and password, and then get
        into an infinite redirect/re-request loop.  Since NTLM and Kerberos are only supported on IE anyway, we skip
        the auto-login request on non-IE browsers, and simply redirect to the login page. --%>
        if (dojo.isIE) {
            dojo.xhrGet({
                url: "/teamworks/autoLogin.2.lsw",
                handleAs: "xml",
                load: dojo.hitch(this, function(data) {
                    this.loginSucceeded();
                }),
                error: dojo.hitch(this, function(error) {
                    this.loginFailed();
                })
            });
        } else {
            this.loginFailed();
        }
    },

    loginSucceeded : function() {
        document.location = "<%= successPage %>";
    },

    loginFailed : function() {
        <%                    
        	// we need to add this cookie for correct redirect after manual login
        	response.addCookie(new Cookie("TWforwardPage", successPage));     
  		%>  
        document.location = "/teamworks/login.jsp?<%= URLEncoder.encode(request.getQueryString()) %>";
    }
}
function AutoLogin() {}

var autologin = new AutoLogin();
    </script>
</head>
<body onLoad="autologin.init()">
<div id="login-header">
        <div class="logo"></div>
</div>

<lsw:IncludeFile zFile="login-mod.inc"/>

<table cellpadding="0" cellspacing="0" width="100%">
    <tr>
        <td>&nbsp;</td>
        <td width="500">
            <div id="login-content">
                <table id="content-header" cellspacing="0" cellpadding="0">
                    <tr>
                        <td id="content-header-left"></td>
                        <td id="content-header-right"></td>
                    </tr>
                </table>
                <p><bean:message key="process_server.autoLogin.desc" /></p>
                <p><a href="/portal/login.jsp"><bean:message key="process_server.autoLogin.login" /></a></p>
                <div id="login-copyright"><bean:message key="process_server.copyright" /></div>
                <table id="content-footer" cellspacing="0" cellpadding="0">
                    <tr>
                        <td id="content-footer-left"></td>
                        <td id="content-footer-right"></td>
                    </tr>
                </table>
            </div>
        </td>
        <td>&nbsp;</td>
    </tr>
</table>
</html>
