<%@ page language="java" pageEncoding="UTF-8" contentType="text/html; charset=UTF-8"%>
<jsp:useBean id="content" class="java.lang.String" scope="request" />
<!DOCTYPE html>
<html>
<head>
<!-- GENERATION: All resources (including individual control external resources) loading start -->

<link rel="stylesheet" type="text/css" href="/portal/js/dojo/1.6.1/dijit/themes/soria/soria.css">
<script type="text/javascript" src="/portal/js/dojo/1.6.1/dojo/dojo.js" 
     djConfig="parseOnLoad:true"></script>

<script type="text/javascript" src="../../script/coachNG.js"></script>
<link rel="stylesheet" type="text/css" href="../common/coach_ng.css">

<!-- GENERATION: All resources loading end -->

<script type="text/javascript">
	// GENERATION: View scope class starts here
	// TextFieldView
	dojo.provide("com.ibm.bpm.coach.snapshotId.TextFieldView");
	com.ibm.bpm.coach.snapshotId.TextFieldView.prototype = new com.ibm.bpm.coach.CoachView;
	com.ibm.bpm.coach.snapshotId.TextFieldView.prototype.constructor = com.ibm.bpm.coach.snapshotId.TextFieldView;
	com.ibm.bpm.coach.snapshotId.TextFieldView = function (element, binding, options, readOnly) {
		com.ibm.bpm.coach.CoachView.apply(this, [element, binding, options, readOnly]);
		
		this.view = function() {
			// Override super-class lifeCycle onView method
			// Sample JS code:  Populate the input text by the binding object initial value
			if (!!this.context.binding){
				this.context.element.getElementsByTagName("input")[0].value = this.context.binding.get("value");
			}
			
		};
    		this.change = function(event) {
							// Override super-class change method
							
							//event has the following properties:
							// type = binding/config
							// property = (for complex types) the property that was changed
							// oldVal = (for simple types) previous value
							// newVal = new value
							// insertedInto = (for arrays) index where the object was added to the list
							// removedFrom = (for arrays) index where the object was removed from the list
							// optionName = (for config changes) the name of the option that has changed
							if (event.type == "config"){
							   console.debug("config change " + event.property + " " + event.newVal);
							   if (event.property == "_metadata.visibility"){
							        console.debug(this.context.options._metadata.visibility);
							   }
							} else {
								this.context.element.getElementsByTagName("input")[0].value = event.newVal;
							}
    		};
    		this.load = function() {
    			var viewElement = this.context.element.getElementsByTagName("input")[0]; 
    			dojo.connect(viewElement, "onchange", this, function() {this.context.binding.set("value", viewElement.value);});
    		};
	};

    // ButtonView
    dojo.provide("com.ibm.bpm.coach.snapshotId.ButtonView");
	com.ibm.bpm.coach.snapshotId.ButtonView.prototype = new com.ibm.bpm.coach.CoachView;
	com.ibm.bpm.coach.snapshotId.ButtonView.prototype.constructor = com.ibm.bpm.coach.snapshotId.ButtonView;
	com.ibm.bpm.coach.snapshotId.ButtonView = function (element, binding, options, readOnly) {
		com.ibm.bpm.coach.CoachView.apply(this, [element, binding, options, readOnly]);
		
		this.view = function() {
			// Super-class lifeCycle onView method
			// Sample JS code:  Populate the input text by the binding object initial value
			if(!!this.context.options && this.context.options._metadata){
				this.context.element.getElementsByTagName("input")[0].value = this.context.options._metadata.label;
			}
		
	    	this.context.element.getElementsByTagName("input")[0].onclick = function() {
	    		alert("button is clicked");
	    	};
		};
	};

	// LabelView
	dojo.provide("com.ibm.bpm.coach.snapshotId.LabelView");
	com.ibm.bpm.coach.snapshotId.LabelView.prototype = new com.ibm.bpm.coach.CoachView;
	com.ibm.bpm.coach.snapshotId.LabelView.prototype.constructor = com.ibm.bpm.coach.snapshotId.LabelView;
	com.ibm.bpm.coach.snapshotId.LabelView = function (element, binding, options, readOnly) {
		com.ibm.bpm.coach.CoachView.apply(this, [element, binding, options, readOnly]);
		
		this.view = function() {
			// Override super-class lifeCycle onView method
			// Sample JS code:  Populate the input text by the binding object initial value
			this.context.element.firstChild.innerHTML = this.context.binding.get("value");
			
		};
    		this.change = function(event) {
							// Override super-class change method
    							console.debug("subclass change detected");
								this.context.element.firstChild.innerHTML = event.newVal;
    						};	        
	};

	// SectionView
	dojo.provide("com.ibm.bpm.coach.snapshotId.SectionView");
	com.ibm.bpm.coach.snapshotId.SectionView.prototype = new com.ibm.bpm.coach.CoachView;
	com.ibm.bpm.coach.snapshotId.SectionView.prototype.constructor = com.ibm.bpm.coach.snapshotId.SectionView;
	com.ibm.bpm.coach.snapshotId.SectionView = function (element, binding, options, readOnly) {
		com.ibm.bpm.coach.CoachView.apply(this, [element, binding, options, readOnly]);				
	};	
	
    // TableView
	dojo.provide("com.ibm.bpm.coach.snapshotId.TableView");
	com.ibm.bpm.coach.snapshotId. TableView.prototype = new com.ibm.bpm.coach.CoachView;
	com.ibm.bpm.coach.snapshotId. TableView.prototype.constructor = com.ibm.bpm.coach.snapshotId. TableView;
	com.ibm.bpm.coach.snapshotId. TableView = function (element, binding, options, readOnly) {
		com.ibm.bpm.coach.CoachView.apply(this, [element, binding, options, readOnly]);
		
		this.rowTemplate = null;
		this.tableElement = null;
		
		this.load = function() {

			// Register listener for List changes
			this.context.binding.get("value").bindAll(dojo.hitch(this, this.listUpdated));

			this.tableElement = document.createElement("table");
			this.tableElement.setAttribute("style", "width: 60%");

			this.context.element.appendChild(this.tableElement);
			
			var immediateContentBoxList = dojo.query('> .ContentBox', this.context.element);
			if(immediateContentBoxList.length == 0) {
				// no child
				return;
			}
			// Suppose only one ContentBox under the tableView
			var contentBoxDiv = immediateContentBoxList[0];
			
			// need to repeat the contentBox based on the data-binding
			var immediateSubViewList = dojo.query('> .view', contentBoxDiv);
			dojo.forEach(immediateSubViewList, function(item, index) {
				// wrap the subView in the ContentBox with "td"
				var tdElement = document.createElement("td");
				tdElement.appendChild(item);
				contentBoxDiv.appendChild(tdElement);
			});				
		
			// dynamically add a 'td' that contains delete button
			var tdForButtons = document.createElement("td");				
			var buttonnode= document.createElement('input');
			buttonnode.setAttribute('type','button');
			buttonnode.setAttribute('name','DeleteButton');
			buttonnode.setAttribute('value','Delete');
			buttonnode.setAttribute('Class','DeleteRowButton');
			tdForButtons.appendChild(buttonnode);
			contentBoxDiv.appendChild(tdForButtons);		
			
			// save the template in my own viewScope for the future use
			this.context.element.removeChild(contentBoxDiv);
			this.rowTemplate = contentBoxDiv;				
			
			// create table rows
			for(var k=0; k<this.context.binding.get("value").length(); k++) {
				this.createOneTR(k);
			}
		};
		
		this.view = function() {
		
			var bindingObj = this.context.binding;
			var tableNode = this.tableElement;
			
			var allDeleteRowButtons = dojo.query(' .DeleteRowButton', this.context.element);
			dojo.forEach(allDeleteRowButtons, function(oneButton) {
				if(!oneButton.onclick) {
					oneButton.onclick = function(event) {						
						var parentNode = oneButton.parentNode;
						while(!isContentBox(parentNode)) {					
							parentNode = parentNode.parentNode;
						}
						
						// now parentNode is ContentBox we need.
						var contenBoxNode = parentNode;
		
						var contentBoxList = shallowQueryContentBox(tableNode);
						dojo.forEach(contentBoxList,  function(item, index) {
							if(item.id == contenBoxNode.id) {
			    				bindingObj.get("value").remove(index);
			    				// alert("going to remove " + index + " on " + contenBoxNode.id);
							}
						});
					};
				}
			}, this);
		
		};
		
		// following helper methods can be in the way of in-line function
		this.createOneTR = function(k) {
			var trElement = document.createElement("tr");
		
			var oneDiv = this.rowTemplate.cloneNode(true);
			trElement.appendChild(oneDiv);
			this.tableElement.appendChild(trElement);
			this.context.createView(oneDiv, k);
		}

    	this.listUpdated = function(changeEvent) {
			console.debug("list change detected, object: ", changeEvent.object, 
			"removedFrom: ",changeEvent.removedFrom, 
			"insertedInto: ",changeEvent.insertedInto);
				
			if(changeEvent.removedFrom >= 0) {
	    		var viewScopeToWork = this;
				var immediateContentBoxList = shallowQueryContentBox(this.context.element);
				
	    		var contentBoxNode = immediateContentBoxList[changeEvent.removedFrom];
	    		viewScopeToWork.context.deleteView(contentBoxNode);
	    		// contentBoxNode.parentNode is tr node
	    		this.tableElement.removeChild(contentBoxNode.parentNode);
			}
			
			if(changeEvent.insertedInto >= 0) {
				this.createOneTR(changeEvent.insertedInto);
			}
			
			this.view();		
    	};
    	// once find a node who is contentBox, won't go deeper on that node. So the nodes in the return array don't have direct or indirect containship.
		shallowQueryContentBox = function(node) {
			var deepQueryResults = dojo.query(' .ContentBox', node);
			var shallowQueryResults = new Array();
			dojo.forEach(deepQueryResults, function(oneNode) {
				var parentNode = oneNode.parentNode;
				while(parentNode != node) {
					var classAttribute = parentNode.getAttribute("Class");
					if(!!classAttribute && classAttribute.indexOf("ContentBox") != -1) {
						return;
					}
					parentNode = parentNode.parentNode;
				}
				shallowQueryResults[shallowQueryResults.length] = oneNode;
			});
			return shallowQueryResults;
		};
		isContentBox = function(node) {
			if(!!node) {
				var classAttribute = node.getAttribute("Class");
				if(!!classAttribute) {
					return classAttribute.indexOf("ContentBox") != -1;
				}
			}
			return false;
		};	       
  	};
  	
  	
  	// ButtonView_AddOneTableRow
    dojo.provide("com.ibm.bpm.coach.snapshotId.ButtonView_AddOneTableRow");
	com.ibm.bpm.coach.snapshotId.ButtonView_AddOneTableRow.prototype = new com.ibm.bpm.coach.CoachView;
	com.ibm.bpm.coach.snapshotId.ButtonView_AddOneTableRow.prototype.constructor = com.ibm.bpm.coach.snapshotId.ButtonView_AddOneTableRow;
	com.ibm.bpm.coach.snapshotId.ButtonView_AddOneTableRow = function (element, binding, options, readOnly) {
		com.ibm.bpm.coach.CoachView.apply(this, [element, binding, options, readOnly]);
		
		this.view = function() {
			var bindingObj = this.context.binding;

			this.context.element.getElementsByTagName("input")[0].value = "Add a row";
	    	this.context.element.getElementsByTagName("input")[0].onclick = function(event) {	    	
		    	var blankPerson =	{
										name: 		"LastName, FirstName",
										address:	[
													{	street: "",
														city:	"",
														type:	"Home"
													},
													{	street: "",
														city:	"",
														type:	"Business"
													}
												],
										birthdate:	{	day:	"",
													month: "",
													year:	""
												},
										phoneNumber:	""
									}
		    	bindingObj.get("value").add(blankPerson);
	    	};
		};
	};
  		
	// GENERATION: View scope class ends here	
	// PublisherView
	dojo.provide("com.ibm.bpm.coach.snapshotId.PublisherView");
	com.ibm.bpm.coach.snapshotId.PublisherView.prototype = new com.ibm.bpm.coach.CoachView;
	com.ibm.bpm.coach.snapshotId.PublisherView.prototype.constructor = com.ibm.bpm.coach.snapshotId.PublisherView;
	com.ibm.bpm.coach.snapshotId.PublisherView = function (element, binding, options, readOnly) {
		com.ibm.bpm.coach.CoachView.apply(this, [element, binding, options, readOnly]);

    		this.change = function(changeEvent) {
			              debugger;
							// Override super-class change method
    							console.debug("subclass change detected: " + changeEvent.property);
    		};
    						
			this.load = function() {
			  
				var binding = this.context.binding.get("value");
				binding.bindAll(function(e) {console.debug("custom bindAll: " + e.property + " = " +e.newVal);});
				binding.bind("prop.prop2.prop3", function(e) {console.debug("custom bind prop.prop2.prop3 changed: " + e.newVal);});
			};    						
		
	};
	
	// ComplexView
	dojo.provide("com.ibm.bpm.coach.snapshotId.ComplexView");
	com.ibm.bpm.coach.snapshotId.ComplexView.prototype = new com.ibm.bpm.coach.CoachView;
	com.ibm.bpm.coach.snapshotId.ComplexView.prototype.constructor = com.ibm.bpm.coach.snapshotId.ComplexView;
	com.ibm.bpm.coach.snapshotId.ComplexView = function (element, binding, options, readOnly) {
		com.ibm.bpm.coach.CoachView.apply(this, [element, binding, options, readOnly]);

    		this.change = function(changeEvent) {
							// Override super-class change method
    							console.debug("subclass change detected: " + changeEvent.property);
    						};
    						
			this.load = function() {
			};    						
		
	};

</script>

<script type="text/javascript">
	com.ibm.bpm.coach.initData = function() {
		//##DataBinding begin
		//sample object definition
		this.local = {phoneBook: {
				publishData: 	{	year: "2011",
							publisher: "Mellow-Yellow",
							edition: "1.1",
							prop: {prop1: "val1", prop2: {prop3: "val3"}}
					     	},
				person:		[	
							{
								name: 		"Doe, John",
								address:	[
											{	street: "123 Town Street",
												city:	"Peasantville",
												type:	"Home"
											},
											{	street: "456 Baker Street",
												city:	"Peasantville",
												type:	"Business"	
											}
										],
								birthdate:	{	day:	"31",
											month: "January",
											year:	"1921"
										},
								phoneNumber:	"987-654-321"
							},
							{
								name: 		"Doe, Jane",
								address:	[
											{	street: "123 River Road",
												city:	"Peasantville",
												type:	"Home"
											},
											{	street: "456 Market Square",
												city:	"Peasantville",
												type:	"Business"
											}
										],
								birthdate:	{	day:	"1",
											month: "March",
											year:	"1925"
										},
								phoneNumber:	"987-555-5555"
							}
						],
				test:"test1",		
				title:	"People Pages"
			      }
			}; //local definition
			
			this.local.dataObject01 = 'Default value of binding data object 01';
			this.local.dataObject02 = 'Default value of binding data object 02';
			
			//system data
			this.system.user_fullName = "Mr. Jones";

		//##DataBinding end (sample data)	
	}; //initData
	
	com.ibm.bpm.coach.initConfig = function() {
			/*
			 * options/configuration data 
			 * Keyed by the div id for the view
			*/
			var configId = "config1";
            this.options[configId] = {refOption: com.ibm.bpm.coach.resolveOptionValue.call(this, configId, "refOption", "local.dataObject01"),
                         valOption: "test",
                         _metadata: {label: "",
                                   help: "",
                                   id: "",
                                   visibility: com.ibm.bpm.coach.resolveOptionValue.call(this, configId, "_metadata.visibility", "local.dataObject02"),
                                   className: "",
                                   attributes: [{attr1: ""}, {attr2: ""}]
                                  }
                       };
			configId = "config2";
            this.options[configId] = {refOption: com.ibm.bpm.coach.resolveOptionValue.call(this, configId, "refOption", "local.dataObject01"),
                         valOption: "test",
                         _metadata: {label: "",
                                   help: "",
                                   id: "",
                                   visibility: com.ibm.bpm.coach.resolveOptionValue.call(this, configId, "_metadata.visibility", "local.dataObject02"),
                                   className: "",
                                   attributes: [{attr1: ""}, {attr2: ""}]
                                  }
                       };
			configId = "config3";
            this.options[configId] = {refOption: com.ibm.bpm.coach.resolveOptionValue.call(this, configId, "refOption", "local.dataObject01"),
                         valOption: "test",
                         _metadata: {label: "Submit",
                                   help: "",
                                   id: "",
                                   visibility: com.ibm.bpm.coach.resolveOptionValue.call(this, configId, "_metadata.visibility", "local.dataObject02"),
                                   className: "",
                                   attributes: [{attr1: ""}, {attr2: ""}]
                                  }
                       };
	};
	
</script>
<script type="text/javascript">
    //For testing purpose only, no code gen needed
    //onClick handler to buttons for triggering data set
	setData = function(objectPath, property){
		        var newP = 	{
								name: 		"alice",
								address:	[
											{	street: "streetalice",
												city:	"Peasantville",
												type:	"Home"
											},
											{	street: "456 Market Square",
												city:	"Peasantville",
												type:	"Business"
											}
										],
								birthdate:	{	day:	"1",
											month: "March",
											year:	"1925"
										},
								phoneNumber:	"phone"
							};
				var person = []; 
				person.push(newP);		
				var newP2 = 	{
								name: 		"2",
								address:	[
											{	street: "street2",
												city:	"Peasantville",
												type:	"Home"
											},
											{	street: "456 Market Square",
												city:	"Peasantville",
												type:	"Business"
											}
										],
								birthdate:	{	day:	"1",
											month: "March",
											year:	"1925"
										},
								phoneNumber:	"phone2"
							};
                							
			
				person.push(newP2);
				//Note that the new value is a simple array, ie, not coach.List
				//com.ibm.bpm.coach.GlobalAssets.local.get("phoneBook").set("person", person);
				
				var publishData = 	{	year: "updatedYear",
							publisher: "newPublisher",
							edition: "0.1",
							prop: {prop1: "newVal1", prop2: {prop3: "newProp3"}}
					     	};
							
				var temp = {
					phoneBook : {
						publishData : publishData,
						person : person
					}
				
				};
				
				var refArray = objectPath.split(".");
				var parentObject;
				var tempParent;
				var prop;
				if (refArray[0] == "local") {		
					parentObject = com.ibm.bpm.coach.GlobalAssets.local;
					tempParent = temp;
					for (var i=1; i<refArray.length; i++) {
					    prop = refArray[i];
						
						//local.person[0]
						var subMatch = refArray[i].match(/\[.*\]/);
						var index = null;
						if (subMatch != null) {
							debugger;
							index = subMatch[0].substring(1, subMatch[0].length-1);
							prop = refArray[i].substring(0, refArray[i].indexOf("["));
							parentObject = parentObject.get(prop);
							tempParent = tempParent[prop];
							parentObject = parentObject.get(index);
							tempParent = tempParent[index];
						}
						else{
							parentObject = parentObject.get(prop);
							tempParent = tempParent[prop];
						}
					}
				}
				parentObject.set(property, tempParent[property]);
	}
</script>

</head>
<body class=" soria ">
	<div class="body" id="mainBody">
		<h1>Welcome to Coach NG POC!!!</h1>
	    <h2>Simple views </h2>
	    First simple view of type TextFieldView
	    <!-- Generation: view starts -->
		<div id="div_01" class="TextFieldView view topLevel" data-type="com.ibm.bpm.coach.snapshotId.TextFieldView" data-binding="local.dataObject01"  data-config="config1" data-viewid="view01" style="border: solid #8d0ee6 2px;">
			<div id="div_01_01" class="customHTML" data-binding="">
				<input type="text" name="inputName" size='100' value='default'/>
			</div>
		</div>
		<!-- Generation: view ends -->
		
	    <br/>
	    Second simple view of type TextFieldView
	   	<!-- Generation: view starts -->
	    <div id="div_02" class="TextFieldView view topLevel" data-type="com.ibm.bpm.coach.snapshotId.TextFieldView" data-binding="local.dataObject02" data-config="config2" data-viewid="view02">
	    	<div id="div_02_01" class="customHTML" data-binding="">
				<input type="text" name="inputName" size='100' value='default'/>
			</div>
		</div>
		<!-- Generation: view ends -->
		
	    <br/>
	    Third simple view of type ButtonView
		<!-- Generation: view starts -->
	    <div id="div_03" class="ButtonView view topLevel" data-type="com.ibm.bpm.coach.snapshotId.ButtonView" data-binding="" data-config="config3" data-viewid="view03">
	    	<div id="div_03_01" class="customHTML" data-binding="">
				<input type="button" name="btnName" value="default"></input>
			</div>
		</div>
		<!-- Generation: view ends -->
	
	    <h2>Complex views using ContentBox</h2>
		<h3>Section - by Framework Managed ContentBox</h3>
	    <!-- Generation: view starts -->
	    <div id="div_30" class="SectionView view topLevel" data-type="com.ibm.bpm.coach.snapshotId.SectionView" data-binding="local.phoneBook.publishData" data-viewid="view_30">
			<div id="div_30_contentBox" class="ContentBox" data-view-managed=false>
			    <div id="div_30_01" class="TextFieldView view" data-type="com.ibm.bpm.coach.snapshotId.TextFieldView" data-binding="local.phoneBook.publishData.publisher" data-viewid="view_30_01">
					<div id="div_30_01_01" class="customHTML" data-binding="">
						<input type="text" name="inputName" size='100' value='default' />
					</div>
				</div>
			    <br/>
			    <div id="div_30_02" class="TextFieldView view" data-type="com.ibm.bpm.coach.snapshotId.TextFieldView" data-binding="local.phoneBook.publishData.year" data-viewid="view_30_02">
					<div id="div_30_02_01" class="customHTML" data-binding="">
						<input type="text" name="inputName" size='100' value='default' />
					</div>
				</div>
			    <br/>
			    <div id="div_30_03" class="TextFieldView view" data-type="com.ibm.bpm.coach.snapshotId.TextFieldView" data-binding="local.phoneBook.publishData.edition" data-viewid="view_30_03">
					<div id="div_30_03_01" class="customHTML" data-binding="">
						<input type="text" name="inputName" size='100' value='default' />
					</div>
				</div>
			    <br/>
			</div>
		</div>
		<!-- Generation: view ends -->
	    
	    <h3>Repeatable Section - by Framework managed ContentBox</h3>	
	    <!-- Generation: view starts -->
	    <div id="div_31" class="SectionView view topLevel" data-type="com.ibm.bpm.coach.snapshotId.SectionView" data-binding="local.phoneBook.person[]" data-viewid="view_31">
			<div id="div_31_ContentBox" class="ContentBox" data-view-managed=false>
			    <div id="div_31_01" class="TextFieldView view" data-type="com.ibm.bpm.coach.snapshotId.TextFieldView" data-binding="local.phoneBook.person[].name" data-viewid="view_31_01">
					<div id="div_31_01_01" class="customHTML" data-binding="">
						<input type="text" name="inputName" size='100' value='default'/>
					</div>
				</div>
			    <div id="div_31_04" class="TextFieldView view" data-type="com.ibm.bpm.coach.snapshotId.TextFieldView" data-binding="local.phoneBook.person[].phoneNumber" data-viewid="view_31_04">
					<div id="div_31_04_01" class="customHTML" data-binding="">
						<input type="text" name="inputName" size='100' value='default'/>
					</div>
				</div>
				<br/>
			</div>
	    </div>
		<!-- Generation: view ends -->
	    <br/>
	    <h3>Table - by View managed ContentBox</h3>
	    <!-- Generation: view starts -->
	    <div id="div_26" class="TableView view topLevel" data-type="com.ibm.bpm.coach.snapshotId.TableView" data-binding="local.phoneBook.person[]" data-viewid="view_26">
			<div id="div_26_ContentBox" class="ContentBox" data-view-managed=true>
			    <div id="div_26_01" class="TextFieldView view" data-type="com.ibm.bpm.coach.snapshotId.TextFieldView" data-binding="local.phoneBook.person[].name" data-viewid="view_26_01">
					<div id="div_26_01_01" class="customHTML" data-binding="">
						<input type="text" name="inputName" size='20' value='default'/>
					</div>
				</div>
			    <div id="div_26_02" class="TextFieldView view" data-type="com.ibm.bpm.coach.snapshotId.TextFieldView" data-binding="local.phoneBook.person[].phoneNumber" data-viewid="view_26_02">
					<div id="div_26_02_01" class="customHTML" data-binding="">
						<input type="text" name="inputName" size='20' value='default'/>
					</div>
				</div>
			    <div id="div_26_03" class="SectionView view" data-type="com.ibm.bpm.coach.snapshotId.SectionView" data-binding="" data-viewid="view_26_03">
					<div id="div_26_03_ContentBox" class="ContentBox" data-view-managed=false>
					    <div id="div_26_03_01" class="TextFieldView view" data-type="com.ibm.bpm.coach.snapshotId.TextFieldView" data-binding="local.phoneBook.person[].birthdate.month" data-viewid="view_26_03_01">
							<div id="div_26_01_01" class="customHTML" data-binding="">
								<input type="text" name="inputName" size='10' value='default'/>
							</div>
						</div>
					    <div id="div_26_03_02" class="TextFieldView view" data-type="com.ibm.bpm.coach.snapshotId.TextFieldView" data-binding="local.phoneBook.person[].birthdate.day" data-viewid="view_26_03_02">
							<div id="div_26_03_02_01" class="customHTML" data-binding="">
								<input type="text" name="inputName" size='10' value='default'/>
							</div>
						</div>
					    <div id="div_26_03_03" class="TextFieldView view" data-type="com.ibm.bpm.coach.snapshotId.TextFieldView" data-binding="local.phoneBook.person[].birthdate.year" data-viewid="view_26_03_03">
							<div id="div_26_03_03_01" class="customHTML" data-binding="">
								<input type="text" name="inputName" size='10' value='default'/>
							</div>
						</div>
					</div>
				</div>
			    <div id="div_26_04" class="TableView view" data-type="com.ibm.bpm.coach.snapshotId.TableView" data-binding="local.phoneBook.person[].address[]" data-viewid="view_26_04">
					<div id="div_26_04_ContentBox" class="ContentBox" data-view-managed=true>
					    <div id="div_26_04_01" class="TextFieldView view" data-type="com.ibm.bpm.coach.snapshotId.TextFieldView" data-binding="local.phoneBook.person[].address[].street" data-viewid="view_26_04_01">
							<div id="div_26_04_01_01" class="customHTML" data-binding="">
								<input type="text" name="inputName" size='20' value='default'/>
							</div>
						</div>
					    <div id="div_26_04_02" class="TextFieldView view" data-type="com.ibm.bpm.coach.snapshotId.TextFieldView" data-binding="local.phoneBook.person[].address[].city" data-viewid="view_26_04_02">
							<div id="div_26_04_02_01" class="customHTML" data-binding="">
								<input type="text" name="inputName" size='10' value='default'/>
							</div>
						</div>
					    <div id="div_26_04_03" class="TextFieldView view" data-type="com.ibm.bpm.coach.snapshotId.TextFieldView" data-binding="local.phoneBook.person[].address[].type" data-viewid="view_26_04_03">
							<div id="div_26_04_03_01" class="customHTML" data-binding="">
								<input type="text" name="inputName" size='10' value='default'/>
							</div>
						</div>
					</div>
				</div>
		    </div>
		</div>
	    <div id="div_27" class="ButtonView_AddOneTableRow view topLevel" data-type="com.ibm.bpm.coach.snapshotId.ButtonView_AddOneTableRow" data-binding="local.phoneBook.person" data-viewid="view_27">
			<div id="div_27_1" class="customHTML" data-binding="">
				<input type="button" name="btnName" value='default'/>
			</div>
		</div>
		
		<h3> Buttons for triggering 'set' method on stateful object</h3>	
            <input id="testSetBtn" type="button" name="inputName" size='100' value='set phoneBook' onClick="setData('local', 'phoneBook')"/>		
			<input type="button" name="inputName" size='100' value='set phoneBook.person' onClick="setData('local.phoneBook', 'person')"/>
			<input type="button" name="inputName" size='100' value='set phoneBook.person[0].name' onClick="setData('local.phoneBook.person[0]', 'name')"/>
			<input type="button" name="inputName" size='100' value='set phoneBook.publishData' onClick="setData('local.phoneBook', 'publishData')"/>
			<input type="button" name="inputName" size='100' value='set phoneBook.publishData.prop.prop2' onClick="setData('local.phoneBook.publishData.prop.prop2', 'prop3')"/>
			
        
	    <br/>
		<div id="div_20" class="PublisherView view topLevel" data-type="com.ibm.bpm.coach.snapshotId.PublisherView" data-binding="local.phoneBook.publishData" data-viewid="view_20">
			
			<div id="div_20_contentBox" class="ContentBox" data-view-managed=false>
				<div id="div_20_01" class="TextFieldView view" data-type="com.ibm.bpm.coach.snapshotId.TextFieldView" data-binding="local.phoneBook.publishData.publisher" data-viewid="view_20_01">
					
						<input type="text" name="inputName" size='100' value='default' />
				
				</div>
			  
			    <div id="div_20_02" class="TextFieldView view" data-type="com.ibm.bpm.coach.snapshotId.TextFieldView" data-binding="local.phoneBook.publishData.year" data-viewid="view_20_02">
					
						<input type="text" name="inputName" size='100' value='default' />
				
				</div>
				  <br/>
				 <div id="div_20_04" class="ComplexView view" data-type="com.ibm.bpm.coach.snapshotId.ComplexView" data-binding="local.phoneBook.publishData.prop" data-viewid="view_20_04">
				 <div id="div_20_04_contentBox" class="ContentBox" data-view-managed=false>
					<div id="div_20_04_01" class="TextFieldView view" data-type="com.ibm.bpm.coach.snapshotId.TextFieldView" data-binding="local.phoneBook.publishData.prop.prop1" data-viewid="view_20_04_01">
						
							<input type="text" name="inputName" size='100' value='default' />
						
					</div>
					<div id="div_20_04_02" class="TextFieldView view" data-type="com.ibm.bpm.coach.snapshotId.TextFieldView" data-binding="local.phoneBook.publishData.prop.prop2.prop3" data-viewid="view_20_04_02">

							<input type="text" name="inputName" size='100' value='default' />
						
					</div>
				</div>
				</div>
			    <br/>
			</div>
		</div>
		
	    <br/><br/><br/><br/><br/><br/><br/><br/><br/>	    
</body>