<%@ page language="java" pageEncoding="UTF-8" contentType="text/html; charset=UTF-8"%>
<jsp:useBean id="content" class="java.lang.String" scope="request" />
<!DOCTYPE html>
<html>
<head>

<script>
	var dojoConfig = {
		async: true,
		parseOnLoad: true,
		baseUrl: '../../script/coachNG',
		packages: [
			{name: 'dojo',
			 location: '/teamworks/script/coachNG/dojo/1.7.1/dojo'},
			{name: 'dijit',
			 location: '/teamworks/script/coachNG/dojo/1.7.1/dijit'},
			{name: 'dojox',
			 location: '/teamworks/script/coachNG/dojo/1.7.1/dojox'},
 			{name: 'com.ibm.bpm.coach',
			 location: '/teamworks/script/coachNG/com/ibm/bpm/coach',
			 packageMap: {dojo: "dojo", dijit: "dijit", dojox: "dojox"}},
			{name: 'com.ibm.bpm.social.portal.util',
			 location: '/portal/js',
			 packageMap: {dojo: "dojo", dijit: "dijit", dojox: "dojox"}}
		]
	}; 

</script>

<!-- GENERATION: All resources (including individual control external resources) loading start -->

<link rel="stylesheet" type="text/css" href="/teamworks/script/coachNG/dojo/1.7.1/dijit/themes/claro/claro.css">
<script type="text/javascript" data-dojo-config="async:1" src="/teamworks/script/coachNG/dojo/1.7.1/dojo/dojo.js" ></script>

<link rel="stylesheet" type="text/css" href="/teamworks/html/common/coach_ng.css">

<!-- GENERATION: All resources loading end -->

<!-- Generation of inline script start -->
<!-- Sample of how customer can add this snippet into their inline script to specify a different version of dojo -->
<!-- script>
	require({
		packages: [
			{name: 'dojo',
			 location: '/teamworks/webasset/2064.9c04317f-d610-495a-9e63-2e225dd71d06/W/customerDojo.zip/dojo-release-1.7.0b6-src/dojo'},
			{name: 'dijit',
			 location: '/teamworks/webasset/2064.9c04317f-d610-495a-9e63-2e225dd71d06/W/customerDojo.zip/dojo-release-1.7.0b6-src/dijit'},
			{name: 'dojox',
			 location: '/teamworks/webasset/2064.9c04317f-d610-495a-9e63-2e225dd71d06/W/customerDojo.zip/dojo-release-1.7.0b6-src/dojox'}
		]
	});
</script -->
<!-- Generation of inline script end-->

<!-- Generation of view scope class start -->
<script type="text/javascript">

	// GENERATION: View scope class starts here
	// TextFieldView
	define("com.ibm.bpm.coach.snapshotId.TextFieldView", ["com.ibm.bpm.coach/engine", "com.ibm.bpm.coach/CoachView", "require"], function(engine, CoachView, require) {
		var subclass = function (element, binding, options, readOnly) {
			CoachView.apply(this, [element, binding, options, readOnly]);

			this.view = function() {
				// Override super-class lifeCycle onView method
				// Sample JS code:  Populate the input text by the binding object initial value
				if (!!this.context.binding){
					this.context.element.getElementsByTagName("input")[0].value = this.context.binding.get("value");
				}
				
			};
    		this.change = function(event) {
							// Override super-class change method
							
							//event has the following properties:
							// type = binding/config
							// property = (for complex types) the property that was changed
							// oldVal = (for simple types) previous value
							// newVal = new value
							// insertedInto = (for arrays) index where the object was added to the list
							// removedFrom = (for arrays) index where the object was removed from the list
							// optionName = (for config changes) the name of the option that has changed
							if (event.type == "config"){
							   console.debug("config change " + event.property + " " + event.newVal);
							   if (event.property == "_metadata.visibility"){
							        console.debug(this.context.options._metadata.visibility.get("value"));
							   }
							} else {
								this.context.element.getElementsByTagName("input")[0].value = event.newVal;
							}
    		};
    		this.load = function() {
    			var _this = this;
    			require(["dojo/_base/connect"], function(connect) {
	    			var viewElement = _this.context.element.getElementsByTagName("input")[0]; 
	    			connect.connect(viewElement, "onchange", _this, function() {_this.context.binding.set("value", viewElement.value);});
	    		}); 
    		};
	    };
	    subclass.prototype = new CoachView;
		subclass.prototype.constructor = subclass;		
		engine.GlobalAssets.scopeClasses["com.ibm.bpm.coach.snapshotId.TextFieldView"] = subclass;		
		return subclass;
	});

    // ButtonView
	define("com.ibm.bpm.coach.snapshotId.ButtonView", ["com.ibm.bpm.coach/engine", "com.ibm.bpm.coach/CoachView"], function(engine, CoachView) {
		var subclass = function (element, binding, options, readOnly) {
			CoachView.apply(this, [element, binding, options, readOnly]);
		
			this.view = function() {
				// Super-class lifeCycle onView method
				// Sample JS code:  Populate the input text by the binding object initial value
				if(!!this.context.options && this.context.options._metadata){
					this.context.element.getElementsByTagName("input")[0].value = this.context.options._metadata.label.get("value");
				}
			
		    	this.context.element.getElementsByTagName("input")[0].onclick = function() {
		    		alert("button is clicked");
		    	};
			};
		};
		subclass.prototype = new CoachView;
		subclass.prototype.constructor = subclass;
		engine.GlobalAssets.scopeClasses["com.ibm.bpm.coach.snapshotId.ButtonView"] = subclass;		
		return subclass;
	});

	// LabelView
	define("com.ibm.bpm.coach.snapshotId.LabelView", ["com.ibm.bpm.coach/engine", "com.ibm.bpm.coach/CoachView"], function(engine, CoachView) {
		var subclass = function (element, binding, options, readOnly) {
			CoachView.apply(this, [element, binding, options, readOnly]);
		
			this.view = function() {
				// Override super-class lifeCycle onView method
				// Sample JS code:  Populate the input text by the binding object initial value
				this.context.element.firstChild.innerHTML = this.context.binding.get("value");
				
			};
	    		this.change = function(event) {
								// Override super-class change method
	    							console.debug("subclass change detected");
									this.context.element.firstChild.innerHTML = event.newVal;
	    	};	        
		};
		subclass.prototype = new CoachView;
		subclass.prototype.constructor = subclass;
		engine.GlobalAssets.scopeClasses["com.ibm.bpm.coach.snapshotId.LabelView"] = subclass;		
		return subclass;
	});		

	// SectionView
	define("com.ibm.bpm.coach.snapshotId.SectionView", ["com.ibm.bpm.coach/engine", "com.ibm.bpm.coach/CoachView"], function(engine, CoachView) {
		var subclass = function (element, binding, options, readOnly) {
			CoachView.apply(this, [element, binding, options, readOnly]);
		};
		subclass.prototype = new CoachView;
		subclass.prototype.constructor = subclass;
		engine.GlobalAssets.scopeClasses["com.ibm.bpm.coach.snapshotId.SectionView"] = subclass;		
		return subclass;
	});		
	
    // TableView
    define("com.ibm.bpm.coach.snapshotId.TableView", ["com.ibm.bpm.coach/engine", "com.ibm.bpm.coach/CoachView"], function(engine, CoachView) {
		var subclass = function (element, binding, options, readOnly) {
			CoachView.apply(this, [element, binding, options, readOnly]);
		
			this.rowTemplate = null;
			this.tableElement = null;
		
			this.load = function() {
				var _this = this;
				require(["dojo/_base/array", "dojo/query"], function(array, query) {
					// Register listener for List changes
					var h1 = _this.context.binding.get("value").bindAll(dojo.hitch(_this, _this.listUpdated));
					
		           var  h2 = _this.context.binding.get("value").bind("listSelectedIndex", dojo.hitch(_this, function(event){	
						console.debug("listSelectedIndex is changed");
					}));
					
					_this.tableElement = document.createElement("table");
					_this.tableElement.setAttribute("style", "width: 60%");
		
					_this.context.element.appendChild(_this.tableElement);
					
					var immediateContentBoxList = query('> .ContentBox', _this.context.element);
					if(immediateContentBoxList.length == 0) {
						// no child
						return;
					}
					// Suppose only one ContentBox under the tableView
					var contentBoxDiv = immediateContentBoxList[0];
					
					// need to repeat the contentBox based on the data-binding
					var immediateSubViewList = query('> .view', contentBoxDiv);
					array.forEach(immediateSubViewList, function(item, index) {
						// wrap the subView in the ContentBox with "td"
						var tdElement = document.createElement("td");
						tdElement.appendChild(item);
						contentBoxDiv.appendChild(tdElement);
					});				
				
					// dynamically add a 'td' that contains delete button
					var tdForButtons = document.createElement("td");				
					var buttonnode= document.createElement('input');
					buttonnode.setAttribute('type','button');
					buttonnode.setAttribute('name','DeleteButton');
					buttonnode.setAttribute('value','Delete');
					buttonnode.setAttribute('Class','DeleteRowButton');
					tdForButtons.appendChild(buttonnode);
					contentBoxDiv.appendChild(tdForButtons);		
					
					// save the template in my own viewScope for the future use
					_this.context.element.removeChild(contentBoxDiv);
					_this.rowTemplate = contentBoxDiv;				
					
					// create table rows
					for(var k=0; k<_this.context.binding.get("value").length(); k++) {
						_this.createOneTR(k);
					}
				});
			};
			
			this.view = function() {
				var _this = this;
				require(["dojo/_base/array", "dojo/query"], function(array, query) {
					var bindingObj = _this.context.binding;
					var tableNode = _this.tableElement;
					
					var allDeleteRowButtons = query(' .DeleteRowButton', _this.context.element);
					array.forEach(allDeleteRowButtons, function(oneButton) {
						if(!oneButton.onclick) {
							oneButton.onclick = function(event) {						
								var parentNode = oneButton.parentNode;
								while(!isContentBox(parentNode)) {					
									parentNode = parentNode.parentNode;
								}
								
								// now parentNode is ContentBox we need.
								var contenBoxNode = parentNode;
				
								var contentBoxList = shallowQueryContentBox(tableNode);
								array.forEach(contentBoxList,  function(item, index) {
									if(item.id == contenBoxNode.id) {
					    				bindingObj.get("value").remove(index);
					    				// alert("going to remove " + index + " on " + contenBoxNode.id);
									}
								});
							};
						}
					}, _this);
				});
			};
			
			// following helper methods can be in the way of in-line function
			this.createOneTR = function(k) {
				var trElement = document.createElement("tr");
			
				var oneDiv = this.rowTemplate.cloneNode(true);
				trElement.appendChild(oneDiv);
				this.tableElement.appendChild(trElement);
				this.context.createView(oneDiv, k);
			}
	
	    	this.listUpdated = function(changeEvent) {		   
				
				var lastIndex = this.context.binding.get('value').length() - 1;
				this.context.binding.get('value').set("listAllSelectedIndices", [lastIndex]);
				console.debug( engine.GlobalAssets.local.toJson());
			
				console.debug("list change detected, object: ", changeEvent.object, 
				"removedFrom: ",changeEvent.removedFrom, 
				"insertedInto: ",changeEvent.insertedInto);
					
				if(changeEvent.removedFrom >= 0) {
		    		var viewScopeToWork = this;
					var immediateContentBoxList = shallowQueryContentBox(this.context.element);
					
		    		var contentBoxNode = immediateContentBoxList[changeEvent.removedFrom];
		    		viewScopeToWork.context.deleteView(contentBoxNode);
		    		// contentBoxNode.parentNode is tr node
		    		this.tableElement.removeChild(contentBoxNode.parentNode);
				}
				
				if(changeEvent.insertedInto >= 0) {
					this.createOneTR(changeEvent.insertedInto);
				}
				
				this.view();		
	    	};
	    	// once find a node who is contentBox, won't go deeper on that node. So the nodes in the return array don't have direct or indirect containship.
			shallowQueryContentBox = function(node) {
				var shallowQueryResults = new Array();
				require(["dojo/_base/array", "dojo/query"], function(array, query) {
					var deepQueryResults = query(' .ContentBox', node);
					// var shallowQueryResults = new Array();
					array.forEach(deepQueryResults, function(oneNode) {
						var parentNode = oneNode.parentNode;
						while(parentNode != node) {
							var classAttribute = parentNode.getAttribute("Class");
							if(!!classAttribute && classAttribute.indexOf("ContentBox") != -1) {
								return;
							}
							parentNode = parentNode.parentNode;
						}
						shallowQueryResults[shallowQueryResults.length] = oneNode;
					});
				});
				return shallowQueryResults;
			};
			isContentBox = function(node) {
				if(!!node) {
					var classAttribute = node.getAttribute("Class");
					if(!!classAttribute) {
						return classAttribute.indexOf("ContentBox") != -1;
					}
				}
				return false;
			};
		};
		subclass.prototype = new CoachView;
		subclass.prototype.constructor = subclass;
		engine.GlobalAssets.scopeClasses["com.ibm.bpm.coach.snapshotId.TableView"] = subclass;		
		return subclass;
	});		
  	
  	
  	// ButtonView_AddOneTableRow
	define("com.ibm.bpm.coach.snapshotId.ButtonView_AddOneTableRow", ["com.ibm.bpm.coach/engine", "com.ibm.bpm.coach/CoachView"], function(engine, CoachView) {
		var subclass = function (element, binding, options, readOnly) {
			CoachView.apply(this, [element, binding, options, readOnly]);
		
			this.view = function() {
				var bindingObj = this.context.binding;
	
				this.context.element.getElementsByTagName("input")[0].value = "Add a row";
		    	this.context.element.getElementsByTagName("input")[0].onclick = function(event) {	    	
			    	var blankPerson =	{
											name: 		"LastName, FirstName",
											address:	
												{
													items : [
														{	street: "street h",
															city:	"",
															type:	"Home"
														},
														{	street: "stree b",
															city:	"",
															type:	"Business"
														}
													],
													listAllSelectedIndices : [0]
												},
											birthdate:	{	day:	"day",
														month: "",
														year:	""
													},
											phoneNumber:	"phone"
										}
			    	bindingObj.get("value").add(blankPerson);
		    	};
			};
		};
		subclass.prototype = new CoachView;
		subclass.prototype.constructor = subclass;
		engine.GlobalAssets.scopeClasses["com.ibm.bpm.coach.snapshotId.ButtonView_AddOneTableRow"] = subclass;		
		return subclass;
	});		
  		
	// GENERATION: View scope class ends here	
	// PublisherView
   	define("com.ibm.bpm.coach.snapshotId.PublisherView", ["com.ibm.bpm.coach/engine", "com.ibm.bpm.coach/CoachView"], function(engine, CoachView) {
		var subclass = function (element, binding, options, readOnly) {
			CoachView.apply(this, [element, binding, options, readOnly]);

    		this.change = function(changeEvent) {
				// Override super-class change method
				console.debug("subclass change detected: " + changeEvent.property);
    		};
    						
			this.load = function() {
				var binding = this.context.binding.get("value");
				binding.bindAll(function(e) {console.debug("custom bindAll: " + e.property + " = " +e.newVal);});
				binding.bind("prop.prop2.prop3", function(e) {console.debug("custom bind prop.prop2.prop3 changed: " + e.newVal);});
			};    						
		};
		subclass.prototype = new CoachView;
		subclass.prototype.constructor = subclass;
		engine.GlobalAssets.scopeClasses["com.ibm.bpm.coach.snapshotId.PublisherView"] = subclass;		
		return subclass;
	});		
	
	// ComplexView
   	define("com.ibm.bpm.coach.snapshotId.ComplexView", ["com.ibm.bpm.coach/engine", "com.ibm.bpm.coach/CoachView"], function(engine, CoachView) {
		var subclass = function (element, binding, options, readOnly) {
			CoachView.apply(this, [element, binding, options, readOnly]);

    		this.change = function(changeEvent) {
							// Override super-class change method
    							console.debug("subclass change detected: " + changeEvent.property);
    						};
    						
			this.load = function() {
			};    						
		};
		subclass.prototype = new CoachView;
		subclass.prototype.constructor = subclass;
		engine.GlobalAssets.scopeClasses["com.ibm.bpm.coach.snapshotId.ComplexView"] = subclass;		
		return subclass;
	});		

	
	// Need to include all subclass from the following require so that the subclass is actually being loaded even it is inline
	// Otherwise, error will be shown saying subclass is not a constructor in the class creation in engine
	// Cannot just use require on the moduleId because it will throw an exception
	require(["dojo/ready", "dojo/parser", "com.ibm.bpm.coach/engine", "com.ibm.bpm.coach/controller", "com.ibm.bpm.coach/disableBack",
	"com.ibm.bpm.coach.snapshotId.TextFieldView", "com.ibm.bpm.coach.snapshotId.ButtonView", "com.ibm.bpm.coach.snapshotId.LabelView", 
	"com.ibm.bpm.coach.snapshotId.SectionView", "com.ibm.bpm.coach.snapshotId.TableView", "com.ibm.bpm.coach.snapshotId.ButtonView_AddOneTableRow",
	"com.ibm.bpm.coach.snapshotId.PublisherView", "com.ibm.bpm.coach.snapshotId.ComplexView"], 
	function(ready, parser, engine, controller, disableBack) {
	
		engine.initData = function() {
			this.systemData = {zComponentId : "3028.8f575cec-df6b-4a33-990d-19070231ea59",
					zComponentName : "CoachNG",
					zTaskId : "p1",
					applicationId :	"2",
					applicationInstanceId : "guid:ba6a45eb7e023af7:24b78fac:1356376e396:-7ffe",
					zWorkflowState : "3",
					zDbg : "0",
					boundaryEventInformation : [
					{
					boundaryEventID : "boundaryEvent_1",
					endStateID : "a5a3ed4b-85c4-4783-842b-e47fda50f683"
					}
					]
					}
			console.log("initData call started");
			//##DataBinding begin
			//sample object definition
			this.local = {phoneBook: {
					publishData: 	{	year: "2011",
								publisher: "Mellow-Yellow",
								edition: "1.1",
								prop: {prop1: "val1", prop2: {prop3: "val3"}}
						     	},
					person:	{
							items:	[	
								{
									name: 		"Doe, John",
									address:{
											items : [
												{	street: "123 Town Street",
													city:	"Peasantville",
													type:	"Home"
												},
												{	street: "456 Baker Street",
													city:	"Peasantville",
													type:	"Business"	
												}
											],
											listAllSelectedIndices : [0, 1]
									},
									birthdate:	{	day:	"31",
												month: "January",
												year:	"1921"
											},
									phoneNumber:	"987-654-321"
								},
								{
									name: 		"Doe, Jane",
									address: 
										{
										items: [
												{	street: "123 River Road",
													city:	"Peasantville",
													type:	"Home"
												},
												{	street: "456 Market Square",
													city:	"Peasantville",
													type:	"Business"
												}
											],
											listAllSelectedIndices : [0, 1]
					                    },
									birthdate:	{	day:	"1",
												month: "March",
												year:	"1925"
											},
									phoneNumber:	"987-555-5555"
								}
							],
							listAllSelectedIndices : [1] //set to the last index
					    },
					test:"test1",		
					title:	"People Pages"
				      }
				}; //local definition
				
				this.local.dataObject01 = 'Default value of binding data object 01';
				this.local.dataObject02 = 'Default value of binding data object 02';
				
				//system data
				this.system.user_fullName = "Mr. Jones";
	
			//##DataBinding end (sample data)	
			console.log("initData call ended");	
		}; //initData
		
		engine.initConfig = function() {
			console.log("initConfig call started");
			/*
			 * options/configuration data 
			 * Keyed by the div id for the view
			*/
			var configId = "config1";
            this.options[configId] = {refOption: engine.resolveOptionValue.call(this, configId, "refOption", "local.dataObject01"),
                         valOption: engine.resolveStaticOptionValue.call(this, configId, "valOption", "test"),
                         _metadata: {label: engine.resolveStaticOptionValue.call(this, configId, "_metadata.label", ""),
                                   help: engine.resolveStaticOptionValue.call(this, configId, "_metadata.help", ""),
                                   id: "",
                                   visibility: engine.resolveOptionValue.call(this, configId, "_metadata.visibility", "local.dataObject02"),
                                   className: "",
                                   attributes: [{attr1: ""}, {attr2: ""}]
                                  }
                       };
			configId = "config2";
            this.options[configId] = {refOption: engine.resolveOptionValue.call(this, configId, "refOption", "local.dataObject01"),
                         valOption: engine.resolveStaticOptionValue.call(this, configId, "valOption", "test"),
                         _metadata: {label: engine.resolveStaticOptionValue.call(this, configId, "_metadata.label", ""),
                                   help: engine.resolveStaticOptionValue.call(this, configId, "_metadata.help", ""),
                                   id: "",
                                   visibility: engine.resolveOptionValue.call(this, configId, "_metadata.visibility", "local.dataObject02"),
                                   className: "",
                                   attributes: [{attr1: ""}, {attr2: ""}]
                                  }
                       };
			configId = "config3";
            this.options[configId] = {refOption: engine.resolveOptionValue.call(this, configId, "refOption", "local.dataObject01"),
                         valOption: engine.resolveStaticOptionValue.call(this, configId, "valOption", "test"),
                         _metadata: {label: engine.resolveStaticOptionValue.call(this, configId, "_metadata.label", "Submit"),
                                   help: engine.resolveStaticOptionValue.call(this, configId, "_metadata.help", ""),
                                   id: "",
                                   visibility: engine.resolveOptionValue.call(this, configId, "_metadata.visibility", "local.dataObject02"),
                                   className: "",
                                   attributes: [{attr1: ""}, {attr2: ""}]
                                  }
                       };
			configId = "config4";
            this.options[configId] = {
			                         valOptionP : engine.resolveStaticOptionValue.call(this, configId, "valOptionP", "testValue"),
                         _metadata: {
						          
                                   visibility: engine.resolveStaticOptionValue.call(this, configId, "_metadata.visibility", "aaaaaa"),
                                  
                                  }
                       };
					   
			configId = "config5";
            this.options[configId] = {
			  undefOne : undefined,
						 valOption : engine.resolveOptionValue.call(this, configId, "valOption", "config.config4.valOptionP"),
                         _metadata: {
                                   visibility: engine.resolveStaticOptionValue.call(this, configId, "_metadata.visibility", "default"),
                                  
                                  }
            };
			console.log("initConfig call ended");
		};
		
			    //For testing purpose only, no code gen needed
	    //onClick handler to buttons for triggering data set
		setData = function(objectPath, property){
	        var newP = 	{
							name: 		"alice",
							address:{items:	[
										{	street: "streetalice",
											city:	"Peasantville",
											type:	"Home"
										},
										{	street: "456 Market Square",
											city:	"Peasantville",
											type:	"Business"
										}
									],
									listAllSelectedIndices : [0]
									},
							birthdate:	{	day:	"1",
										month: "March",
										year:	"1925"
									},
							phoneNumber:	"phone"
						};
			var person = {}; 
			var items = [];
			person.items = items;
			person.listAllSelectedIndices = [1];
			items.push(newP);		
			var newP2 = 	{
							name: 		"2",
							address:{items:
									[
										{	street: "street2",
											city:	"Peasantville",
											type:	"Home"
										},
										{	street: "456 Market Square",
											city:	"Peasantville",
											type:	"Business"
										}
									],
									listAllSelectedIndices : [0]
									},
							birthdate:	{	day:	"1",
										month: "March",
										year:	"1925"
									},
							phoneNumber:	"phone2"
						};
            							
		
			items.push(newP2);

			//Note that the new value is a simple array, ie, not coach.List
			//com.ibm.bpm.coach.GlobalAssets.local.get("phoneBook").set("person", person);
			
			var publishData = 	{	year: "updatedYear",
						publisher: "newPublisher",
						edition: "0.1",
						prop: {prop1: "newVal1", prop2: {prop3: "newProp3"}}
				     	};
						
			var temp = {
				phoneBook : {
					publishData : publishData,
					person : person
				}
			
			};
			
			var refArray = objectPath.split(".");
			var parentObject;
			var tempParent;
			var prop;
			if (refArray[0] == "local") {		
				parentObject = engine.GlobalAssets.local;
				tempParent = temp;
				for (var i=1; i<refArray.length; i++) {
				    prop = refArray[i];
					
					//local.person[0]
					var subMatch = refArray[i].match(/\[.*\]/);
					var index = null;
					if (subMatch != null) {
						debugger;
						index = subMatch[0].substring(1, subMatch[0].length-1);
						prop = refArray[i].substring(0, refArray[i].indexOf("["));
						parentObject = parentObject.get(prop);
						tempParent = tempParent[prop];
						parentObject = parentObject.get(index);
						tempParent = tempParent.items[index];
					}
					else{
						parentObject = parentObject.get(prop);
						tempParent = tempParent[prop];
					}
				}
			}
			parentObject.set(property, tempParent[property]);
		}
		
		//For testing purpose only, no code gen needed
		setReadyonly = function() {
			engine.setReadonly(true);
			setTimeout(function() {
				engine.setReadonly(false);
			}, 10000);
		}
		
		ready(function() {
			console.log("ready call started");
			if(window == window.parent) { // not in iFrame				
				disableBack.init();
			}
			engine.initLocalizedMessage();
			engine.initData.call(engine.GlobalAssets);
			engine.initConfig.call(engine.GlobalAssets);
			controller.init();
			engine.initViews.call(engine.GlobalAssets);
			engine.prepareView.call(engine.GlobalAssets);
			engine.completeInitialization();
			window.onbeforeunload = engine.onWindowClose;
			console.log("ready call ended");
		});
	}); 

</script>

</head>
<body class=" claro ">
	<script type="text/javascript">
		if(window == window.parent) { // not in iFrame	
			// work-around solution
			var src = "/teamworks/script/coachNG/dojo/1.7.1/dojo/resources/iframe_history.html";
			document.write('<iframe style="border:0;width:1px;height:1px;position:absolute;visibility:hidden;bottom:0;right:0;" name="dj_history" id="dj_history" src="' + src + '"></iframe>');
			/*
			// dojo.back has problem on AMD mode at this moment (dojo defect link: http://trac.dojotoolkit.org/ticket/14613)
			// once this problem is resolved in the future dojo release, we can use following code to replace the work-around above
			require(["dojo/back"], function(back){
				back.init();
			});
			*/
		}
	</script>
	<div class="body" id="mainBody">
		<h1>Welcome to Coach NG POC!!!</h1>
	    <h2>Simple views </h2>
	    First simple view of type TextFieldView
	    <!-- Generation: view starts -->
		<div id="div_01" class="TextFieldView view topLevel" data-type="com.ibm.bpm.coach.snapshotId.TextFieldView" data-binding="local.dataObject01"  data-config="config1" data-viewid="view01" style="border: solid #8d0ee6 2px;">
			<div id="div_01_01" class="customHTML" data-binding="">
				<input type="text" name="inputName" size='100' value='default'/>
			</div>
		</div>
		<!-- Generation: view ends -->
		
	    <br/>
	    Second simple view of type TextFieldView
	   	<!-- Generation: view starts -->
	    <div id="div_02" class="TextFieldView view topLevel" data-type="com.ibm.bpm.coach.snapshotId.TextFieldView" data-binding="local.dataObject02" data-config="config2" data-viewid="view02" style="outline: solid green 1px;">
	    	<div id="div_02_01" class="customHTML" data-binding="">
				<input type="text" name="inputName" size='100' value='default'/>
			</div>
		</div>
		<!-- Generation: view ends -->
		
	    <br/>
	    Third simple view of type ButtonView
		<!-- Generation: view starts -->
	    <div id="div_03" class="ButtonView view topLevel" data-type="com.ibm.bpm.coach.snapshotId.ButtonView" data-binding="" data-config="config3" data-viewid="view03">
	    	<div id="div_03_01" class="customHTML" data-binding="">
				<input type="button" name="btnName" value="default"></input>
			</div>
		</div>
		<!-- Generation: view ends -->
	
	    <h2>Complex views using ContentBox</h2>
		<h3>Section - by Framework Managed ContentBox</h3>
	    <!-- Generation: view starts -->
	    <div id="div_30" class="SectionView view topLevel" data-type="com.ibm.bpm.coach.snapshotId.SectionView" data-binding="local.phoneBook.publishData" data-viewid="view_30">
			<div id="div_30_contentBox" class="ContentBox" data-view-managed=false>
			    <div id="div_30_01" class="TextFieldView view" data-type="com.ibm.bpm.coach.snapshotId.TextFieldView" data-binding="local.phoneBook.publishData.publisher" data-viewid="view_30_01">
					<div id="div_30_01_01" class="customHTML" data-binding="">
						<input type="text" name="inputName" size='100' value='default' />
					</div>
				</div>
			    <br/>
			    <div id="div_30_02" class="TextFieldView view" data-type="com.ibm.bpm.coach.snapshotId.TextFieldView" data-binding="local.phoneBook.publishData.year" data-viewid="view_30_02">
					<div id="div_30_02_01" class="customHTML" data-binding="">
						<input type="text" name="inputName" size='100' value='default' />
					</div>
				</div>
			    <br/>
			    <div id="div_30_03" class="TextFieldView view" data-type="com.ibm.bpm.coach.snapshotId.TextFieldView" data-binding="local.phoneBook.publishData.edition" data-viewid="view_30_03">
					<div id="div_30_03_01" class="customHTML" data-binding="">
						<input type="text" name="inputName" size='100' value='default' />
					</div>
				</div>
			    <br/>
			</div>
		</div>
		<!-- Generation: view ends -->
	    
	    <h3>Repeatable Section - by Framework managed ContentBox</h3>	
	    <!-- Generation: view starts -->
	    <div id="div_31" class="SectionView view topLevel" data-type="com.ibm.bpm.coach.snapshotId.SectionView" data-binding="local.phoneBook.person[]" data-viewid="view_31">
			<div id="div_31_ContentBox" class="ContentBox" data-view-managed=false>
			    <div id="div_31_01" class="TextFieldView view" data-type="com.ibm.bpm.coach.snapshotId.TextFieldView" data-binding="local.phoneBook.person[].name" data-viewid="view_31_01">
					<div id="div_31_01_01" class="customHTML" data-binding="">
						<input type="text" name="inputName" size='100' value='default'/>
					</div>
				</div>
			    <div id="div_31_04" class="TextFieldView view" data-type="com.ibm.bpm.coach.snapshotId.TextFieldView" data-binding="local.phoneBook.person[].phoneNumber" data-viewid="view_31_04">
					<div id="div_31_04_01" class="customHTML" data-binding="">
						<input type="text" name="inputName" size='100' value='default'/>
					</div>
				</div>
				<br/>
			</div>
	    </div>
		<!-- Generation: view ends -->
	    <br/>
	  
	    <div id="div_27" class="ButtonView_AddOneTableRow view topLevel" data-type="com.ibm.bpm.coach.snapshotId.ButtonView_AddOneTableRow" data-binding="local.phoneBook.person" data-viewid="view_27">
			<div id="div_27_1" class="customHTML" data-binding="">
				<input type="button" name="btnName" value='default'/>
			</div>
		</div>
		
		<h3> Buttons for triggering 'set' method on stateful object</h3>	
            <input id="testSetBtn" type="button" name="inputName" size='100' value='set phoneBook' onClick="setData('local', 'phoneBook')"/>		
			<input type="button" name="inputName" size='100' value='set phoneBook.person' onClick="setData('local.phoneBook', 'person')"/>
			<input type="button" name="inputName" size='100' value='set phoneBook.person[0].name' onClick="setData('local.phoneBook.person[0]', 'name')"/>
			<input type="button" name="inputName" size='100' value='set phoneBook.publishData' onClick="setData('local.phoneBook', 'publishData')"/>
			<input type="button" name="inputName" size='100' value='set phoneBook.publishData.prop.prop2' onClick="setData('local.phoneBook.publishData.prop.prop2', 'prop3')"/>
			
        
	    <br/>
		<div id="div_20" class="PublisherView view topLevel" data-type="com.ibm.bpm.coach.snapshotId.PublisherView" data-binding="local.phoneBook.publishData" data-viewid="view_20">
			
			<div id="div_20_contentBox" class="ContentBox" data-view-managed=false>
				<div id="div_20_01" class="TextFieldView view" data-type="com.ibm.bpm.coach.snapshotId.TextFieldView" data-binding="local.phoneBook.publishData.publisher" data-viewid="view_20_01">
					
						<input type="text" name="inputName" size='100' value='default' />
				
				</div>
			  
			    <div id="div_20_02" class="TextFieldView view" data-type="com.ibm.bpm.coach.snapshotId.TextFieldView" data-binding="local.phoneBook.publishData.year" data-viewid="view_20_02">
					
						<input type="text" name="inputName" size='100' value='default' />
				
				</div>
				  <br/>
				 <div id="div_20_04" class="ComplexView view" data-type="com.ibm.bpm.coach.snapshotId.ComplexView" data-binding="local.phoneBook.publishData.prop" data-viewid="view_20_04">
				 <div id="div_20_04_contentBox" class="ContentBox" data-view-managed=false>
					<div id="div_20_04_01" class="TextFieldView view" data-type="com.ibm.bpm.coach.snapshotId.TextFieldView" data-binding="local.phoneBook.publishData.prop.prop1" data-viewid="view_20_04_01">
						
							<input type="text" name="inputName" size='100' value='default' />
						
					</div>
					<div id="div_20_04_02" class="TextFieldView view" data-type="com.ibm.bpm.coach.snapshotId.TextFieldView" data-binding="local.phoneBook.publishData.prop.prop2.prop3" data-viewid="view_20_04_02">

							<input type="text" name="inputName" size='100' value='default' />
						
					</div>
				</div>
				</div>
			    <br/>
			</div>
		</div>
		</br>
		<h4>View for displaying the value of listSelectedIndex</h4>
	   	<!-- Generation: view starts -->
	    <div id="div_21" class="TextFieldView view topLevel" data-type="com.ibm.bpm.coach.snapshotId.TextFieldView" data-binding="local.phoneBook.person.listSelectedIndex" data-config="config2" data-viewid="view21">
	    	<div id="div_21_01" class="customHTML" data-binding="">
				<input type="text" name="inputName" size='100' value='default'/>
			</div>
		</div>

		<h4> View to test using data-config as binding, visibility</h4>
		<div id="div_22" class="TextFieldView view topLevel" data-type="com.ibm.bpm.coach.snapshotId.TextFieldView" data-binding="config.config4._metadata.visibility"  data-viewid="view22">
	    	<div id="div_22_01" class="customHTML" data-binding="">
				<input type="text" name="inputName" size='100' value='default'/>
			</div>
		</div>  	 
		
		 <div id="div_23" class="TextFieldView view topLevel" data-type="com.ibm.bpm.coach.snapshotId.TextFieldView" data-binding="config.config5._metadata.visibility"  data-viewid="view23">
	    	<div id="div_23_01" class="customHTML" data-binding="">
				<input type="text" name="inputName" size='100' value='default'/>
			</div>
		</div> 
		
		<div id="div_24" class="TextFieldView view topLevel" data-type="com.ibm.bpm.coach.snapshotId.TextFieldView" data-binding="config.config4._metadata.visibility" data-config="config4" data-viewid="view24">
	    	<div id="div_24_01" class="customHTML" data-binding="">
				<input type="text" name="inputName" size='100' value='default'/>
			</div>
		</div>
		
		<div id="div_25" class="TextFieldView view topLevel" data-type="com.ibm.bpm.coach.snapshotId.TextFieldView" data-binding="config.config4.valOptionP" data-config="config5" data-viewid="view25">
	    	<div id="div_25_01" class="customHTML" data-binding="">
				<input type="text" name="inputName" size='100' value='default'/>
			</div>
		</div>
		<!-- Generation: view ends -->
		
	<h3> Test read-only capability - click following button to make the entire coach window in read-only mode for 10 seconds</h3>	
        <input id="t" type="button" name="inputName" size='100' value='Set Coach Read-only' onClick="setReadyonly()"/>		
		
	    <br/><br/><br/><br/><br/><br/><br/><br/><br/>	    
</body>