<%@ page language="java" pageEncoding="UTF-8" contentType="text/html; charset=UTF-8"%>
<%@ include file="/html/msgs-init.jsp" %>
<%@ include file="/html/common/prolog.jsp" %>
<html>
<head>
	<title><bean:message key="cs_assume_user.title" /></title>
	<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
	<script src="<lsw:ImagePrefix/>script/javascript.js" type="text/javascript"></script>

<script>


function AssumeEntry(userId, userName, fullName, fromDate, toDate) {
  this.userId = userId;
  this.userName = userName;
  this.fullName = fullName;

  if (fromDate != "")
    this.fromDate = new Date(fromDate);
  else
    this.fromDate = new Date();
  if (toDate != "")
    this.toDate = new Date(toDate);
  else
    this.toDate = "";
}

var arrayA = new Array();

<lsw:AssumeUserList>
arrayA[arrayA.length] = new AssumeEntry(<lsw:UserId/>, "<lsw:UserName zJS="true"/>", "<lsw:UserFullName zJS="true"/>", "<lsw:AssumeUserDate zDateFormat="MM/dd/yyyy HH:mm:ss" zDateType="from"/>", "<lsw:AssumeUserDate zDateFormat="MM/dd/yyyy HH:mm:ss" zDateType="to"/>");
</lsw:AssumeUserList>

function doOnLoad() {
  if (parent.doTMRefresh) {
    parent.document.location.reload(true);
  } else {
    var aObj = document.assumeform.assumeselect;
    for(i = 0; i < arrayA.length; i++) {
      var ae = arrayA[i];
      aObj.options[i] = new Option(ae.userName + " (" + ae.fullName + ")", i);
    }
//    document.assumeform.zAssume.focus();
  }
}

function doChange(obj) {
  var info = document.getElementById("info");
  if (info != null) {
    var ae = arrayA[obj.options[obj.selectedIndex].value];
    var msg = "";
    if (ae.toDate != "") {
    	msg = '<bean:message key="cs_assume_user.doChange.to" />';
    	msg = msg.replace("{0}", ae.fromDate);
    	msg = msg.replace("{1}", ae.toDate);
    } else {
    	msg = '<bean:message key="cs_assume_user.doChange.from" />';
    	msg = msg.replace("{0}", ae.fromDate);
    }
    info.childNodes.item(0).data = msg;
  }
}

function doOK() {
  var obj = document.assumeform.assumeselect;
  var idx = obj.selectedIndex;
  if (idx >= 0) {
    var ae = arrayA[obj.options[idx].value];
    document.assumeform.zAssumeName.value = ae.userName;
    return doRefresh();
  } else
    return false;
}

function doRefresh() {
  parent.doTMRefresh = true;
  return true;
}

function doSub() {
  var okRet = doOK();
  if (okRet == true) {
     document.assumeform.
     document.assumeform.submit();
  }
}

</script>
</head>
<LINK REL="stylesheet" HREF="<%= com.lombardisoftware.core.PortalSkinUtilities.getPortalSkinPath(request) %>/tw_console.css" TYPE="text/css">
<body class="cswelcomebody" onload='doOnLoad();'>
<table width="100%" valign="top" cellpadding="2" cellspacing="0" border="0" style="margin-top:0px">
<tr><td id="content"><div class="heading"><h1><bean:message key="cs_assume_user.title" /></h1></div>
</tr><tr><td>
<form name="assumeform" method="GET" action="cs_assume_user.lsw">
<input type="hidden" name="zObject" value="User">
<input type="hidden" name="zActivity" value="Assume">
<%-- Set zPost to 1 to tell the ControllerServlet to hand the parameters to the --%>
<%-- RequestManager for it to process. Set to anything else for no processing. --%>
<input type="hidden" name="zPost" value="1">
<%-- The url for this screen. This is passed to the attach screen so that it can --%>
<%-- get back here --%>
<input type="hidden" name="zFromPage" value="<%= request.getContextPath() %>/cs_assume_user.lsw">
<input type="hidden" name="zNextPage" value="cs_top_main.lsw">
<input type="hidden" name="zAssumeName" value="">

<tr><td>
<table cellpadding="0" cellspacing="0" border="0" style="margin:5">
<tr>
<td valign="top"><div class="cslabel"><bean:message key="cs_assume_user.select_user_id" /><br></div>
<select name="assumeselect" size="14" style="width:300" onChange="doChange(this);" ondblClick="doSub();"></select>
</div>
</td><td width="6"></td>
<td width="200"><center><div class="cslabel"><bean:message key="cs_assume_user.current_user" /></div></center><br>
<center><div class="info1">
<lsw:User><lsw:UserName/> (<lsw:UserFullName/>)</lsw:User>
<lsw:HasAssumed><lsw:True><bean:message key="cs_assume_user.assumedBy" /><lsw:AssumeUser><lsw:UserName/> &lt;<lsw:UserFullName/>&gt;</lsw:AssumeUser></lsw:True></lsw:HasAssumed>
</div></center>
</td>
<tr>
<td><br><input type="submit" value="<bean:message key="cs_assume_user.button_assume" />" class="button" style="width:200" name="zAssume" onClick="return doOK();"></td>
<td width="6"></td><td><div class="info1">
<lsw:AssumeUser><br><input type="submit" value="<bean:message key="cs_assume_user.button_resetTo" /><lsw:UserName/>" class="button" style="width:230" name="zUnassume" onClick="return doRefresh();">&nbsp;</lsw:AssumeUser></div>
</td></center></tr>
</table>
<lsw:ErrorMessage>
 <lsw:True><div class="errortype">&nbsp;<bean:message key="cs_assume_user.error.desc" /><span class="errmsg">&nbsp;&nbsp;<lsw:Text/></span></div><br></lsw:True>
 <lsw:False><BR></lsw:False>
</lsw:ErrorMessage>

<br><br><br>
<table class="cshlp" cellpadding="2" cellspacing="0">
<tr><td class="cshlp"><div class="lbl"><bean:message key="cs_assume_user.assumingAnotherUserID" /></div></td></tr>
<tr><td class="cshlptxt"><div class="info1"><bean:message key="cs_assume_user.info1" />
<li><bean:message key="cs_assume_user.info1.li1" /></li>
<li><bean:message key="cs_assume_user.info1.li2" /></li>
</div></td></tr>
</table>
</td></tr>
</table>
</form>
</body>
</html>
