<%@ page language="java" pageEncoding="UTF-8" contentType="text/html; charset=UTF-8"%>
<%@ include file="/html/msgs-init.jsp" %>
<%@ include file="common/prolog.jsp" %>
<%@ page errorPage="tm_error.jsp" %>
<html>
<head>
<script src="<lsw:ImagePrefix/>script/javascript.js" type="text/javascript"></script>
<script src="<lsw:ImagePrefix/>script/epv.js" type="text/javascript"></script>
<script>
var currentDate = <lsw:ServerDate zDateFormat="epoch"/>;
var epvRow         = <% if (request.getParameter("zEpvRow") != null) { %>"<%= request.getParameter("zEpvRow") %>"<% } else { %>""<% } %>;
var epvVarRow      = <% if (request.getParameter("zEpvVarRow") != null) { %>"<%= request.getParameter("zEpvVarRow") %>"<% } else { %>""<% } %>;
var epvVarValueRow = <% if (request.getParameter("zEpvVarValueRow") != null) { %>"<%= request.getParameter("zEpvVarValueRow") %>"<% } else { %>""<% } %>;
var snapshotRow    = <% if (request.getParameter("zSnapshotRow") != null) { %>"<%= request.getParameter("zSnapshotRow") %>"<% } else { %>""<% } %>;
var context        = <% if (request.getParameter("zContext") != null) { %>"<%= request.getParameter("zContext") %>"<% } else { %>""<% } %>;
var reportId       = <% if (request.getParameter("zReportId") != null) { %>"<%= request.getParameter("zReportId") %>"<% } else { %>""<% } %>;

function doOnLoad() {
  try {
	  obj = document.getElementById("snapshotlist");
	  obj.selectedIndex = 0;
      for(i = (obj.options.length - 1); i >= 0; i--) {
 	    if (obj.options[i].value == snapshotRow)
            obj.options[i].selected = true;
      }

      obj = document.getElementById("epvlist");
	  obj.selectedIndex = 0;
      for(i = (obj.options.length - 1); i >= 0; i--) {
 	    if (obj.options[i].value == epvRow)
            obj.options[i].selected = true;
      }
	  if (document.getElementById(epvVarRow) != null)
	    SelectRow(epvVarRow, epvVarRow);
	  else {
	    // Try and select first row
	    var table = document.getElementById("epvvarlist");
	    var row = table.rows[0].getAttribute("id");
	  	epvVarSelectRow(row);
	  }
	  if (document.getElementById(epvVarValueRow) != null)
	    SelectRow(epvVarValueRow, epvVarValueRow);
	  else {
	    // Try and select first row
	    var table = document.getElementById("epvvarvaluelist");
	    var row = table.rows[0].getAttribute("id");
	  	epvVarValueSelectRow(row);
	  }
  } catch (e) {
  }
  if (document.epvForm.zAdd != null) document.epvForm.zAdd.disabled = false;
  if (document.epvForm.zEdit != null) document.epvForm.zEdit.disabled = true;
  if (document.epvForm.zRemove != null) document.epvForm.zRemove.disabled = true;
}

function setIds(epvRef, epvVarId, epvVarValueId, contextId) {
    document.epvForm.zReportId.value = reportId;
    document.epvForm.zEpvRef.value = epvRef;
    document.epvForm.zEpvVarId.value = epvVarId;
    document.epvForm.zEpvVarValueId.value = epvVarValueId;
    document.epvForm.zContext.value = contextId;
}

var disableEPVSelectRow = false;
var disableSnapshotSelectRow = false;

function snapshotSelectRow(rowId) {
	  if (disableSnapshotSelectRow) {
	     return;
	  }

	  clearErrorMsg();
	  try {
	  	  oldBgColor = "white";
		  snapshotRow = SelectRow(snapshotRow, rowId);

		  if (snapshotRow != "") {
			document.epvForm.zSnapshotRow.value = snapshotRow;
	        setIds("", "", "", snapshotRow.substring(8));
			document.epvForm.submit();
		  }
	  } catch (e) {
	  }
}

function epvSelectRow(rowId) {
  if (disableEPVSelectRow) {
     return;
  }

  clearErrorMsg();
  try {
  	  oldBgColor = "white";
	  epvRow = SelectRow(epvRow, rowId);

	  if (epvRow != "") {
	 	document.epvForm.zSnapshotRow.value = snapshotRow;
		document.epvForm.zEpvRow.value = epvRow;
        setIds(epvRow.substring(4), "", "", snapshotRow.substring(8));
		document.epvForm.submit();
	  }
  } catch (e) {
  }
}

function epvVarSelectRow(rowId) {
  clearErrorMsg();
  try {
  	  oldBgColor = "white";
	  epvVarRow = SelectRow(epvVarRow, rowId);

	  if (epvVarRow != "") {
	 	document.epvForm.zSnapshotRow.value = snapshotRow;
		document.epvForm.zEpvRow.value = epvRow;
		document.epvForm.zEpvVarRow.value = epvVarRow;
        setIds(epvRow.substring(4), epvVarRow.substring(7), "", snapshotRow.substring(8));
		document.epvForm.submit();
	  }
  } catch (e) {
  }
}

function epvVarValueSelectRow(rowId, effDate) {
  clearErrorMsg();
  try {
	  epvVarValueRow = SelectRow(epvVarValueRow, rowId);
	  if (epvVarValueRow != "") {
	 	document.epvForm.zSnapshotRow.value = snapshotRow;
		document.epvForm.zEpvRow.value = epvRow;
		document.epvForm.zEpvVarRow.value = epvVarRow;
		document.epvForm.zEpvVarValueRow.value = epvVarValueRow;
        setIds(epvRow.substring(4), epvVarRow.substring(7), epvVarValueRow.substring(12), snapshotRow.substring(8));
	  }

	  if (effDate < currentDate) {
		  document.epvForm.zAdd.disabled = false;
		  document.epvForm.zEdit.disabled = true;
		  document.epvForm.zRemove.disabled = true;
	  } else {
		  document.epvForm.zAdd.disabled = false;
		  document.epvForm.zEdit.disabled = false;
		  document.epvForm.zRemove.disabled = false;
	  }
  } catch (e) {
  }
}

function doValue(mode) {
  var url = "epv_variable_value.lsw?zMode="+mode+"&zEpvRef="+epvRow.substring(4)+"&zEpvVarId="+epvVarRow.substring(7)+"&zContext="+context;
  if (mode != "A")
    url = url + "&zEpvVarValueId="+epvVarValueRow.substring(12);

  window.open(url,"epv_manage","toolbar=no,width=630,height=350,resizable=yes");

  return false;
}

function doRemove() {
  if (confirm("<bean:message key="cs_epv.doRemove.confirm.message" />")) {
    document.epvForm.zPost.value = 1;
    return true;
  } else
    return false;
}

</script>
<% if (request.getParameter("zReportId") != null && !request.getParameter("zReportId").isEmpty()) { %>
<title><bean:message key="cs_epv.title1" /></title>
<% } else { %>
<title><bean:message key="cs_epv.title2" /></title>
<% } %>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
</head>
<link rel="stylesheet" type="text/css" href="./html/common/tw_console.css" />
<body id="csbody" onLoad="doOnLoad();">
<form action="cs_epv.lsw" method="POST" name="epvForm">
<input type=hidden name=zSnapshotRow>
<input type=hidden name=zSaveParam value=zSnapshotRow>
<input type=hidden name=zEpvRow>
<input type=hidden name=zSaveParam value=zEpvRow>
<input type=hidden name=zEpvVarRow>
<input type=hidden name=zSaveParam value=zEpvVarRow>
<input type=hidden name=zEpvVarValueRow>
<input type=hidden name=zSaveParam value=zEpvVarValueRow>
<input type=hidden name=zEpvRef>
<input type=hidden name=zSaveParam value=zEpvRef>
<input type=hidden name=zEpvVarId>
<input type=hidden name=zSaveParam value=zEpvVarId>
<input type=hidden name=zEpvVarValueId>
<input type=hidden name=zSaveParam value=zEpvVarValueId>
<input type=hidden name=zReportId>
<input type=hidden name=zSaveParam value=zReportId>
<input type=hidden name=zContext>
<input type=hidden name=zSaveParam value=zContext>
<input type="hidden" name="zObject" value="Epv">
<input type="hidden" name="zActivity" value="Manage">
<input type=hidden name=zPost value=0>
<table cellspacing="0" cellpadding="0" border="0" id="layout">
<tr valign="top"><td id="content" colspan=2><div class="heading">
    <div class="heading-right"></div>
    <h1><bean:message key="cs_epv.title2" /></h1>
</div>
<div class="body">
<table class="content-table" width="95%" cellpadding="0" style="border:0px;" cellspacing="0" border="0">
<thead>
<tr>
<% if (request.getParameter("zReportId") != null && !request.getParameter("zReportId").isEmpty()) { %>
<td><b>&nbsp;<bean:message key="cs_epv.exposedProcessValuesFor" /> <lsw:Report> &nbsp; <lsw:ReportName/></lsw:Report></b>
<% } else { %>
<td><b>&nbsp;<bean:message key="cs_epv.exposedProcessValues" /></b>
<% } %>
</td><td align="right" valisgn="top"><bean:message key="cs_epv.feedback" /><a href="mailto:<lsw:Epv><lsw:EpvFeedback/></lsw:Epv>"><img src="<lsw:ImagePrefix />images/mail.gif" border="0" align="middle"></a></td></tr>
</thead>
</table>
<p/>
<table class="content-table" cellpadding="0" cellspacing="1px" width="95%" border="0">
<tr><td width=170 valign=top class="lbl"><bean:message key="cs_epv.snapshot" /></td>
<td><select onChange='snapshotSelectRow(this.options[this.selectedIndex].value)' style="width:331" id="snapshotlist">
 <option value=''><bean:message key="cs_epv.select_snapshot" /></option>
  <lsw:SnapshotList>
 <option id="snapshot_names_<lsw:ContextId/>" name="snapshot_names_<lsw:ContextId/>" value='context_<lsw:ContextId/>'><lsw:SnapshotName/></option>
  </lsw:SnapshotList>
</select>
<br/>&nbsp;</td>
</tr>
<tr><td width=170 valign=top class="lbl"><bean:message key="cs_epv.name" /></td>
<td><select onChange='epvSelectRow(this.options[this.selectedIndex].value)' style="width:331" id="epvlist">
 <option value=''><bean:message key="cs_epv.select_epv" /></option>
  <lsw:EpvList>
 <option id="epv_names_<lsw:EpvRef/>" name="epv_names_<lsw:EpvRef/>" value='epv_<lsw:EpvRef/>'><lsw:EpvName/></option>
  </lsw:EpvList>
</select>
<br/>&nbsp;</td>
</tr>
<tr>
<lsw:Epv>
<td width=170 valign=top class="lbl"><bean:message key="cs_epv.description" /></td>
<td valign=top><div id="epvDescription" class="multiline-display"><lsw:EpvExtDescription/></div></td>
<script>
 disableEPVSelectRow = true;
 if (document.getElementById("epv_names_<lsw:EpvRef/>") != null) {
     document.getElementById("epv_names_<lsw:EpvRef/>").selected=true;
     disableEPVSelectRow = false;
 }
</script>
</lsw:Epv>
</tr>
</table>


<lsw:Epv>
<table id="epvvarlist" class="content-table" cellpadding="0" cellspacing="0" border="0">
<thead>
<tr><th colspan=3><bean:message key="cs_epv.variableList" /></th></tr>
<tr>
  <td class="header" ><a class="epv" href="#">&nbsp;<bean:message key="cs_epv.var_name" /></a></td>
  <td class="header"><a class="epv" href="#">&nbsp;<bean:message key="cs_epv.var_description" /></a></td>
  <td class="header" ><a class="epv" href="#">&nbsp;<bean:message key="cs_epv.var_currentvalue" /></a></td>
 </tr>
</thead>
 <tbody>
<lsw:EpvVarList>
<tr height=20 bgcolor="white" id="epvvar_<lsw:EpvVarId/>" onClick='epvVarSelectRow("epvvar_<lsw:EpvVarId/>")'>
<td class="epvfield1" width="169">&nbsp;<lsw:EpvVarName/>&nbsp;</td>
<td class="epvfield1">&nbsp;<lsw:EpvVarExtDescription/>&nbsp;</td>
<td class="epvfield1" width="170">&nbsp;<lsw:EpvVarCurrentValue/>&nbsp;</td>
</tr>
</lsw:EpvVarList>
</tbody>
</table>

<lsw:EpvVar>

<table class="content-table" cellpadding="0" cellspacing="0" border="0">
<thead>
<tr><th colspan=4>&nbsp;<bean:message key="cs_epv.schedule.change_details" /></th></tr>
<tr>
 <td class="header" width="140"><a class="epv" href="#">&nbsp;<bean:message key="cs_epv.schedule.change_details.effectiveDate" /></a></td>
 <td class="header" width="330"><a class="epv" href="#">&nbsp;<bean:message key="cs_epv.schedule.change_details.value" /></a></td>
 <td class="header" width="140"><a class="epv" href="#">&nbsp;<bean:message key="cs_epv.schedule.change_details.modifiedBy" /></a></td>
 <td class="header"><a class="epv" href="#">&nbsp;<bean:message key="cs_epv.schedule.change_details.modifiedDate" /></a></td>
</tr>
</thead>
<tbody>
<lsw:EpvVarValueList>
<tr height="20" bgcolor="<lsw:EpvVarValueInFuture><lsw:True>white</lsw:True><lsw:False>silver</lsw:False></lsw:EpvVarValueInFuture>" id="epvvarvalue_<lsw:EpvVarValueId/>" onclick='epvVarValueSelectRow("epvvarvalue_<lsw:EpvVarValueId/>", <lsw:EpvVarValueEffectiveOn zDateFormat="epoch"/>)'>
<td class="epvfield1" width="141">&nbsp;<lsw:EpvVarValueEffectiveOn zDateStyle="medium" zTimeStyle="medium"/>&nbsp;</td>
<td class="epvfield1" width="330">&nbsp;<lsw:EpvVarValueValue/>&nbsp;</td>
<td class="epvfield1" width="140">&nbsp;<lsw:EpvVarValueLastModifiedBy/>&nbsp;</td>
<td class="epvfield1">&nbsp;<lsw:EpvVarValueLastModified zDateStyle="medium" zTimeStyle="medium"/>&nbsp;</td>
</tr>
</lsw:EpvVarValueList>
</tbody>
</table>
<table cellspacing=3 cellpadding=0 width=95%>
 <tr><td align=right><input class="button" type=button value='<bean:message key="cs_epv.button_new" />' name=zAdd onClick="doValue('A');">&nbsp;<input class="button" type=button value='<bean:message key="cs_epv.button_edit" />' name=zEdit onClick="doValue('E');">&nbsp;<input class="button" type=submit value='<bean:message key="cs_epv.button_delete" />' name=zRemove onClick="return doRemove();"></td></tr>
</table>
&nbsp;<br>
</lsw:EpvVar>
</lsw:Epv>
</div>
</td></tr>

</table>
<table id="content-footer" cellspacing="0" cellpadding="0">
<tr>
    <td id="content-footer-left"></td>
    <td id="content-footer-right"></td>
</tr>


</table>
</form></body></html>