<%@ page language="java" pageEncoding="UTF-8" contentType="text/html; charset=UTF-8"%>
<%@ include file="/html/msgs-init.jsp" %>
<%--
-@+@-
<pageInfo>
<schema>
<simpleType name="date">
 <restriction base="Date">
  <format value="MM/dd/yyyy"/>
 </restriction>
</simpleType>
<simpleType name="time">
 <restriction base="Time">
  <format value="HH:mm"/>
 </restriction>
</simpleType>
</schema>
<fields>
<field name="zFromDate" type="date" required="true">
 <description>From Date</description>
</field>
<field name="zFromTime" type="time" required="true">
 <description>From Time</description>
</field>
<field name="zToDate" type="date" required="true">
 <description>To Date</description>
</field>
<field name="zToTime" type="time" required="true">
 <description>To Time</description>
</field>
</fields>
</pageInfo>
-@+@-
--%> 
<%@ include file="common/prolog.jsp" %>
<%@ include file="/html/common/validation.jsp" %>
<script src="<lsw:ImagePrefix/>script/javascript.js" type="text/javascript"></script>

<html>
<head>
<title><bean:message key="cs_grant_access.title" /></title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<script language="JavaScript">
<!--

function to2Digits(theValue) {
 var retValue = theValue;
 if (retValue < 10) retValue = "0" + retValue;
 return(retValue);
}

// IE Javascript will return a two digit year for anything less than year 2000. Netscape always needs 1900 added
function fixYear(year) {

 if ((year < 100) || (navigator.appName == "Netscape"))
  return(1900 + year);
 else
  return(year);
}

// Our object for the grant access list entries
function GrantAccessEntry(userId, userName, fromDate, toDate) {
 this.userId = userId;
 this.userName = userName;
 if (fromDate != "") {
  aDate = new Date(fromDate);
  dateStr = to2Digits(aDate.getMonth() + 1) + "/" + to2Digits(aDate.getDate()) + "/" + fixYear(aDate.getYear());
  timeStr = to2Digits(aDate.getHours()) + ":" + to2Digits(aDate.getMinutes());
  this.fromDate = dateStr;
  this.fromTime = timeStr;
 } else {
  this.fromDate = "";
  this.fromTime = "";
 }
 if (toDate != "") {
  aDate = new Date(toDate);
  dateStr = to2Digits(aDate.getMonth() + 1) + "/" + to2Digits(aDate.getDate()) + "/" + fixYear(aDate.getYear());
  timeStr = to2Digits(aDate.getHours()) + ":" + to2Digits(aDate.getMinutes());
  this.toDate = dateStr;
  this.toTime = timeStr;
 } else {
  this.toDate = "";
  this.toTime = "";
 }
}

function compareEntry(a, b) {
  var na = a.userName.toLowerCase();
  var nb = b.userName.toLowerCase();
  if (na < nb)
    return -1;
  else if (na > nb)
    return 1
  else
    return 0;
}

var arrayGA = new Array();

<lsw:GrantAccessUserList>
arrayGA[arrayGA.length] = new GrantAccessEntry(<lsw:UserId/>, "<lsw:UserName/>", "<lsw:AssumeUserDate zDateFormat="MM/dd/yyyy HH:mm" zDateType="from"/>", "<lsw:AssumeUserDate zDateFormat="MM/dd/yyyy HH:mm" zDateType="to"/>");
</lsw:GrantAccessUserList>

function clearOptions(obj) {
  if (obj.options == null) return;

  for(i = (obj.options.length - 1); i >= 0; i--)
    obj.options[i] = "";
}

function loadGrantAccessSelect() {
 var gaObj = document.grantaccessform.grantaccessselect;
 document.grantaccessform.zAdd.disabled = true;
 document.grantaccessform.zDelete.disabled = true;
 document.grantaccessform.zUpdate.disabled = true;
 clearOptions(gaObj);
 for(i = 0; i < arrayGA.length; i++) {
  var gae = arrayGA[i];
  var fromDate = gae.fromDate + " " + gae.fromTime;
  var toDate = gae.toDate + " " + gae.toTime;
  gaObj.options[i] = new Option(gae.userName + " (" + fromDate + " - " + toDate + ")", i);
 }
 // Removing the current user from the list
<lsw:User>
 var uid = "<lsw:UserId/>";
</lsw:User>
 var usrList = document.grantaccessform.zUser;
 if (usrList.options != undefined) {
     for (i = 0 ; i < usrList.options.length ; i++ ) {
      if (usrList.options[i].value == uid) {
       usrList.options[i] = null;
      }
     }
 }
 
 var zUserId = <%=request.getParameter("zUser")%>   
<% if(request.getParameter("zMessage") != null) { %>    
    <%if(request.getParameter("zAction").equals("Update")) {%>	
    document.grantaccessform.zAdd.disabled = true;
    document.grantaccessform.zDelete.disabled = false;
    document.grantaccessform.zUpdate.disabled = false;  
  <%}else{%>
    document.grantaccessform.zAdd.disabled = false;
    document.grantaccessform.zDelete.disabled = true;
    document.grantaccessform.zUpdate.disabled = true;    
  <%}%>
  
   for(i = 0; i < document.grantaccessform.grantaccessselect.options.length; i++) {          
    if (document.grantaccessform.grantaccessselect.options[i].value == zUserId) {    
    document.grantaccessform.grantaccessselect.options[i].selected = true;
    break;
    }   
   }      

  

<%}else{%>
  document.grantaccessform.zToDate.value = "";
  document.grantaccessform.zToTime.value = "";
  document.grantaccessform.zFromDate.value = "";
  document.grantaccessform.zFromTime.value = "";
  document.grantaccessform.grantaccessselect.selectedIndex = -1;
  document.grantaccessform.zUser.selectedIndex = -1;
  document.grantaccessform.zAdd.disabled = true;
  document.grantaccessform.zDelete.disabled = true;
  document.grantaccessform.zUpdate.disabled = true;  
<%}%>
 
  document.grantaccessform.zFilter.focus();
 
}

function doGrantAccess(obj) {
 var idx = obj.options[obj.selectedIndex].value;
 var gae = arrayGA[idx];
 document.grantaccessform.zFromDate.value = gae.fromDate;
 document.grantaccessform.zFromTime.value = gae.fromTime;
 document.grantaccessform.zToDate.value = gae.toDate;
 document.grantaccessform.zToTime.value = gae.toTime;
 document.grantaccessform.zUser.value = gae.userId;
 document.grantaccessform.user_select.value = gae.userId;
 document.grantaccessform.zAdd.disabled = true;
 document.grantaccessform.zDelete.disabled = false;
 document.grantaccessform.zUpdate.disabled = false;
 document.getElementById('error').style.visibility = "hidden";
}

function doDelete() {
 var obj = document.grantaccessform.grantaccessselect;
 if (obj.selectedIndex >= 0) {
  var idx = obj.options[obj.selectedIndex].value;
  var gae = arrayGA[idx];
  document.grantaccessform.zDeleteId.value = gae.userId;
  document.getElementById('error').style.visibility = "hidden";
  return true;
 }
 return false;
}

function doUserSelect(obj) {
 // We need to find out if this selection is already defined in the grant access
 // selection and if so, we will just be updating, otherwise this is a new entry
 var found = false;
 var value = obj.options[obj.selectedIndex].value;
 document.grantaccessform.zUser.value = value;

 for(i = 0; i < arrayGA.length; i++) {
  var gae = arrayGA[i];
  if (value == gae.userId) {
   found = true;
   break;
  }
  
 }
 document.getElementById('error').style.visibility = "hidden";
 if (found) {
  document.grantaccessform.grantaccessselect.value = i;
  document.grantaccessform.grantaccessselect.selectedIndex = i;
  doGrantAccess(document.grantaccessform.grantaccessselect);
 } else {
  document.grantaccessform.grantaccessselect.value = -1;//Does not work with Netscape.
  document.grantaccessform.grantaccessselect.selectedIndex = -1; //Requires selectedIndex instead of value.
  setFromDate();
  document.grantaccessform.zToDate.value = "";
  document.grantaccessform.zToTime.value = "";
  document.grantaccessform.zAdd.disabled = false;
  document.grantaccessform.zDelete.disabled = true;
  document.grantaccessform.zUpdate.disabled = true;
 }
}

function setFromDate() {
 var today = new Date();
 dateStr = to2Digits(today.getMonth() + 1) + "/" + to2Digits(today.getDate()) + "/" + fixYear(today.getYear());
 timeStr = "00:00";
 document.grantaccessform.zFromDate.value = dateStr;
 document.grantaccessform.zFromTime.value = timeStr;
}

function doRet() {
    document.location.href = "cs_grant_access.lsw?zRetDone=1&zFilter=" + 
        escape(document.grantaccessform.zFilter.value);
    return false;
}

function doProfile() {
  // document.grantaccessform.retB.focus();
}

function checkEnter(e){ //e is event object passed from function invocation
  var characterCode;
  if (e && e.which){ //if which property of event object is supported (NN4)
    e = e;
	characterCode = e.which //character code is contained in NN4's which property
  } else {
	e = event;
	characterCode = e.keyCode; //character code is contained in IE's keyCode property
  }

  if (characterCode == 13){ //if generated character code is equal to ascii 13 (if enter key)
	return doRet(); // Retrieve data
  } else {
	return true;
  }
}

-->
</script>

</head>
<LINK REL="stylesheet" HREF="<%= com.lombardisoftware.core.PortalSkinUtilities.getPortalSkinPath(request) %>/tw_console.css" TYPE="text/css">
<body class="cswelcomebody" onload='loadGrantAccessSelect();'>
<table width="100%" valign="top" cellpadding="2" cellspacing="0" border="0" style="margin-top:0px">
<tr><td id="content"><div class="heading"><h1><bean:message key="cs_grant_access.title" /></h1></div>
</tr>
<tr><td>
<form action="cs_grant_access.lsw" name="grantaccessform">
<input type="hidden" name="zObject" value="User">
<input type="hidden" name="zActivity" value="Assume">
<input type="hidden" name="zRetDone" value="<%= request.getParameter("zRetDone") %>">
<input type="hidden" name="zUser" value="<%= request.getParameter("zUser") %>">
<%-- Set zPost to 1 to tell the ControllerServlet to hand the parameters to the --%>
<%-- RequestManager for it to process. Set to anything else for no processing. --%>
<input type="hidden" name="zPost" value="1">
<%-- The url for this screen. This is passed to the attach screen so that it can --%>
<%-- get back here --%>
<input type="hidden" name="zFromPage" value="<%= request.getContextPath() %>/cs_grant_access.lsw">
<input type="hidden" name="zDeleteId" value="">
<table cellpadding="2" cellspacing="0" border="0" style="margin:5">
<tr><td valign="bottom" height="25"><div class="cslabel">&nbsp;<bean:message key="cs_grant_access.retrieveProfile" /></div><tr>
<tr><td valign="bottom"><input style="width:158" type="text" name="zFilter" value='<%= (request.getParameter("zFilter") == null ? "" : request.getParameter("zFilter")) %>' onblur="return  doProfile();" onKeyPress="return checkEnter(event);"></TD><tr>
<tr>
<td valign="top"><div class="cslabel">&nbsp;<bean:message key="cs_grant_access.availableUsers" /><br></div>
<select size=16 style="width:350;margin-right:0" name="user_select" onChange="doUserSelect(this);">
<% if ((request.getParameter("zRetDone") != null) && (request.getParameter("zFilter") != null) &&
       !(request.getParameter("zFilter").equals(""))) {
       
    
%>
<SCRIPT>
<lsw:User>
 var zUserId = "<lsw:UserId/>";
</lsw:User>

<lsw:FilterUserList zFilter='<%= request.getParameter("zFilter") %>'>
if (zUserId != <lsw:UserId/>) {
   document.write("<option value=\"<lsw:UserId/>\"><lsw:IsDisabledBoolean><lsw:True>* </lsw:True></lsw:IsDisabledBoolean><lsw:UserName zJS="true"/> (<lsw:UserFullName zJS="true"/>)</option>");
}
</lsw:FilterUserList>
</SCRIPT>
</select>
<script>
 var zUserId = "<%=request.getParameter("zUser")%>";
   for(i = 0; i < document.grantaccessform.user_select.options.length; i++) {   
   // alert(document.grantaccessform.user_select.options[i].value + "==" + zUserId);
    if (document.grantaccessform.user_select.options[i].value == zUserId) {    
    document.grantaccessform.user_select.options[i].selected = true;
    break;
    }   
   }         

</script>
<%
    }
%>

</div></td>
<td valign="top"><br><br><br>
<input type="submit" class="button" value='<bean:message key="cs_grant_access.button_add" /> &gt' name="zAdd">
<br><br>
<input type="submit" name="zDelete" class="button" value='&lt; <bean:message key="cs_grant_access.button_remove" />' onClick="return doDelete();">
</td>
<td valign="top"><div class="cslabel">&nbsp;<bean:message key="cs_grant_access.access_granted.users" /><br></div>
<select name="grantaccessselect" size=16 style="width:350;margin-right:0" onChange="doGrantAccess(this);">
</select>
</div></td>
<table>
 <tr>
  <td>
   <img src="<lsw:ImagePrefix />images/sp.gif" width="420" height="2">
   <input name="zUpdate" class="button" disabled=true type="submit" value='<bean:message key="cs_grant_access.button_update" />'>
  </td>
 </tr>
</table>
</td></tr></table>
<table cellpadding="2" cellspacing="0" border="0"><tr>
<td width="347"></td><td width="98"><div class="cslabel"><bean:message key="cs_grant_access.grantFrom" /></div></td>
<% if(request.getParameter("zFromDate") == null) {%>
<td><input style="width:80" type="text" id="zFromDate" name="zFromDate" value="" size="11">
<%} else {%>
<td><input style="width:80" type="text" id="zFromDate" name="zFromDate" value="<%= request.getParameter("zFromDate") %>" size="11">
<%}%>&nbsp;
<SCRIPT TYPE="text/javascript">
      Calendar.setup({
        align : "BL",
        singleClick : true,
        weekNumbers : false,
        inputField : "zFromDate",
        eventName : "dblclick",
        ifFormat : "%m/%d/%Y"
      });
</SCRIPT>
<% if(request.getParameter("zFromTime") == null) {%>
<input style="width:48"type="text" value="" name="zFromTime" size="6">
<%} else {%>
<input style="width:48"type="text" value="<%= request.getParameter("zFromTime") %>" name="zFromTime" size="6">
<%}%>
<lsw:Validation zFormName="grantaccessform" zFieldName="zFromDate"/>
<lsw:Validation zFormName="grantaccessform" zFieldName="zFromTime"/></td></tr>
<tr><td></td><td><div class="cslabel"><bean:message key="cs_grant_access.grantTo" /></div></td>
<td>
<% if(request.getParameter("zToDate") == null) {%>
<input style="width:80" type="text" id="zToDate" name="zToDate" value="" size="11">
<%} else {%>
<input style="width:80" type="text" id="zToDate" name="zToDate" value="<%= request.getParameter("zToDate") %>" size="11">
<%}%>
&nbsp;
<SCRIPT TYPE="text/javascript">
      Calendar.setup({
        align : "BL",
        singleClick : true,
        weekNumbers : false,
        inputField : "zToDate",
        eventName : "dblclick",
        ifFormat : "%m/%d/%Y"
      });
</SCRIPT>
<% if(request.getParameter("zToTime") == null) {%>
<input style="width:48"type="text" value="" name="zToTime" size="6">&nbsp;
<%} else {%>
<input style="width:48"type="text" value="<%= request.getParameter("zToTime") %>" name="zToTime" size="6">&nbsp;
<%}%>
<lsw:Validation zFormName="grantaccessform" zFieldName="zToDate"/>
<lsw:Validation zFormName="grantaccessform" zFieldName="zToTime"/></td>

<lsw:ErrorMessage><lsw:True><div id="error" class="errortype">&nbsp;<bean:message key="process_server.error.desc" /><span class="errmsg">&nbsp;&nbsp;<lsw:Text/></span></div></lsw:True><lsw:False><div id="error"></div><BR></div></lsw:False></lsw:ErrorMessage>
</tr>
</table>
</div>
<table class="cshlp" cellpadding="2" cellspacing="0">
<br>
<tr><td class="cshlp"><div class="lbl"><bean:message key="cs_grant_access.grantAccessOthers" /></div></td></tr>
<tr><td class="cshlptxt"><div class="info1">
<bean:message key="cs_grant_access.info_desc" /><br>
<li><bean:message key="cs_grant_access.info_li1" /></li>
<li><bean:message key="cs_grant_access.info_li2" /></li>
<li><bean:message key="cs_grant_access.info_li3" /></li>
<li><bean:message key="cs_grant_access.info_li4" /></li>
</div></td></tr>
</table>

</td></tr>
</table>
<div style="position:absolute;left:170px;top:58px"><input name="retB" class="button" type="button" value='<bean:message key="cs_grant_access.button_retrieve" />' onClick="doRet()"></div>
</form>
</body></html>
