<%@page language="java" pageEncoding="UTF-8" contentType="text/html; charset=UTF-8"%>
<%@page import="java.util.Collection"%>
<%@page import="java.util.List"%>
<%@page import="java.util.ArrayList"%>
<%@page import="java.util.Map"%>
<%@page import="java.math.BigDecimal"%>
<%@page import="javax.servlet.jsp.JspWriter"%>
<%@page import="com.lombardisoftware.server.processmonitor.data.Process"%>
<%@page import="com.lombardisoftware.server.processmonitor.data.Service"%>
<%@page import="com.lombardisoftware.server.processmonitor.data.WorkflowUnit"%>
<%@page import="com.lombardisoftware.server.processmonitor.jsp.ProcessMonitorHelper"%>
<%@page import="com.lombardisoftware.server.processmonitor.jsp.FormatHelper"%>
<%@page import="com.lombardisoftware.server.processmonitor.jsp.AbstractProcessEntry"%>
<%@page import="com.lombardisoftware.server.processmonitor.jsp.ProcessEntry"%>
<%@page import="com.lombardisoftware.server.processmonitor.jsp.ServiceEntry"%>
<%@page import="com.lombardisoftware.server.processmonitor.jsp.WorkflowUnitEntry"%>
<%@page import="com.lombardisoftware.server.processmonitor.jsp.bean.TableState"%>
<%@page import="com.lombardisoftware.server.processmonitor.tuple.Tuples"%>
<%@page import="com.lombardisoftware.server.processmonitor.tuple.TupleComparator"%>
<%@page import="org.apache.struts.util.MessageResources" %>
<%@page import="org.apache.struts.Globals" %>
<%@page import="org.apache.struts.taglib.TagUtils" %>
<%@ include file="/html/msgs-init.jsp" %>
<jsp:include page="header.jsp"/>
<%
ProcessMonitorHelper pmHelper = ProcessMonitorHelper.getInstance();

String errorCode = (String)pageContext.getSession().getAttribute("process.detail.error.code");
pageContext.getSession().removeAttribute("process.detail.error.code");

String procId = request.getParameter("id");
if (procId == null) {
    %>
    <p class="failureMessage">
    <bean:message key="cs_processmonitor.processDetail.fail_procID" />
    </p>
</body>
</html>
	<%
    return;
}

BigDecimal processId = new BigDecimal(procId);

Process p = pmHelper.getProcess(processId);
if (p == null) {
    %>
    <p class="failureMessage">
    <bean:message key="cs_processmonitor.processDetail.fail_process" />
    </p>
</body>
</html>
    <%
    return;
}

FormatHelper formatHelper = new FormatHelper();

ProcessEntry entry = pmHelper.getProcessEntry(p);
%>
	<div class="details">
	<%
	if ("haltTimedOut".equals(errorCode)) {
	    %>
	    <div class="message">
	    <p class="failureMessage">
        <bean:message key="cs_processmonitor.processDetail.fail_haltTimeOut" />
	    </p>
	    </div>
	    <%
	}
	%>
	<h2 class="title"><bean:message key="cs_processmonitor.processDetail.processDetails" arg0="<%=entry.getDiagramName()%>" /></h2>
	</div>
	<div class="tablediv">
	<table class="name-value" width="100%">
		<tbody>
		<tr>
			<th width="200"><bean:message key="cs_processmonitor.processDetail.bpdName" /></th>
			<td>
				<%=entry.getDiagramName()%>
			</td>
		</tr>
		<tr>
			<th width="200"><bean:message key="cs_processmonitor.processDetail.processApp" /></th>
			<td>
				<%=entry.getProcessAppName()%>
			</td>
		</tr>
		<tr>
			<th><bean:message key="cs_processmonitor.processDetail.instanceID" /></th>
			<td>
				<%=entry.getProcessId()%>
			</td>
		</tr>
		<%
		if (entry.getState() == AbstractProcessEntry.STATE_ACTIVE) {
		%>
		<tr>
			<th><bean:message key="cs_processmonitor.processDetail.enterTime" /></th>
			<td>
				<%=formatHelper.formatTimestamp((Long)entry.getLastEnterTimestamp())%>
			</td>
		</tr>
		<tr>
			<th><bean:message key="cs_processmonitor.processDetail.duration" /></th>
			<td>
				<%=formatHelper.formatDuration(
						(Long)(System.currentTimeMillis() - entry.getLastEnterTimestamp()))%>
			</td>
		</tr>
		<% } else { %>
		<tr>
			<th><bean:message key="cs_processmonitor.processDetail.lastEnterTime" /></th>
			<td>
				<%=formatHelper.formatTimestamp((Long)p.getLastEnterTimestamp())%>
			</td>
		</tr>
		<tr>
			<th><bean:message key="cs_processmonitor.processDetail.lastDuration" /></th>
			<td>
				<%=formatHelper.formatDuration((Long)entry.getLastDuration())%>
			</td>
		</tr>
		<% } %>
		<tr>
			<th><bean:message key="cs_processmonitor.processDetail.state" /></th>
			<td>
				<%
				if (entry.getState() == AbstractProcessEntry.STATE_ACTIVE) {
				%>
				<bean:message key="cs_processmonitor.processDetail.activeCurrentlyExecuting" />
				<%	    
				} else {
				    if (entry.getState() == AbstractProcessEntry.STATE_INACTIVE) {
			        %>
					<bean:message key="cs_processmonitor.processDetail.activeNotCurrentlyExecuting" />
					<%    
				    } else {
			        %>
					<bean:message key="cs_processmonitor.processDetail.completed" />
					<%
				    }
				}
				%>
			</td>
		</tr>
		<tr>
			<th><bean:message key="cs_processmonitor.processDetail.totalStepsCompleted" /></th>
			<td>
				<%=formatHelper.formatInteger(entry.getWorkflowUnitTotalCount())%>
			</td>
		</tr>
		</tbody>
	</table>
	<%
	if (entry.getState() == AbstractProcessEntry.STATE_ACTIVE) {
	%>
	<p>
	<form action="processHalt.lsw">
		<input type="hidden" name="id" value="<%=entry.getProcessId()%>"/>
		<input type="submit" value='<bean:message key="cs_processmonitor.processDetail.button_haltProcess" />'/>
	</form>
	</p>
	<% } %>
	</div>
	<p/>
	<hr width="100%"/>
	<%
	int expensiveStepMaxTheshold = 5000;

	if (entry.getActiveWorkflowUnitGuid() != null) {
		String guid = entry.getActiveWorkflowUnitGuid();
		WorkflowUnitEntry wfuEntry = entry.getWorkflowUnits().get(guid);
	%>
		<div class="tablediv">
		<h2><bean:message key="cs_processmonitor.processDetail.activeStep" /></h2>
		<table class="sortable" id="activeUnits">
			<thead>
				<tr>
					<th class="name" width="10%"><bean:message key="cs_processmonitor.processDetail.processApp" /></th>
					<th class="name" width="30%"><bean:message key="cs_processmonitor.processDetail.sub_processName" /></th>
					<th class="name" width="30%"><bean:message key="cs_processmonitor.processDetail.startTimestamp" /></th>
					<th class="date-time" width="15%"><bean:message key="cs_processmonitor.processDetail.stepName" /></th>
					<th class="duration" width="15%"><bean:message key="cs_processmonitor.processDetail.duration" /></th>
				</tr>
			</thead>
			<tbody>
				<tr class="<%=(wfuEntry.getDuration() > expensiveStepMaxTheshold ? "flag" : "normal")%>">
					<td class="name">
						<%=wfuEntry.getProcessAppName()%>
					</td>
					<td class="name">
						<%=(!entry.getDiagramId().getId().equals(wfuEntry.getDiagramId().getId())) ? wfuEntry.getDiagramName() : ""%>
					</td>
					<td class="name">
						<%=wfuEntry.getName() != null ? wfuEntry.getName() : ""%>
					</td>
					<td class="date-time">
						<%=formatHelper.formatTimestamp((Long)wfuEntry.getLastEnterTimestamp())%>
					</td>
					<td class="duration">
						<%=formatHelper.formatDuration((Long)wfuEntry.getDuration())%>
					</td>
				</tr>
			</tbody>
		</table>
		</div>
	<% } %>
	
	<div class="tablediv">
	<h2><bean:message key="cs_processmonitor.processDetail.completedSteps" /></h2>
	
	<%
	TableState inactiveWorkflowUnitsTable = (TableState)pageContext.getSession().getAttribute(
			"process.detail.inactiveWorkflowUnitsTable");
	if (inactiveWorkflowUnitsTable == null) {
		inactiveWorkflowUnitsTable = new TableState();
		inactiveWorkflowUnitsTable.setParamPrefix("inactiveWorkflowUnits.");
		inactiveWorkflowUnitsTable.setSortFieldKey("lastEnterTimestamp");
		inactiveWorkflowUnitsTable.setSortOrder(false);
		pageContext.getSession().setAttribute(
				"process.detail.inactiveWorkflowUnitsTable", inactiveWorkflowUnitsTable);
	}
	
	// Sorting should be applied before generation of table columns
	inactiveWorkflowUnitsTable.applySortingFromParams(request.getParameterMap());
	%>
	
	<table class="sortable" id="completedUnits">
		<thead>
			<tr>
				<th class="name sortheader" width="10%">
					<% renderTableSortHeaderCell(out, processId, inactiveWorkflowUnitsTable,
							TagUtils.getInstance().message(pageContext, null, Globals.LOCALE_KEY,"cs_processmonitor.processDetail.processApp"), "processAppName"); %>
				</th>
				<th class="name sortheader" width="25%">
					<% renderTableSortHeaderCell(out, processId, inactiveWorkflowUnitsTable,
					        TagUtils.getInstance().message(pageContext, null, Globals.LOCALE_KEY,"cs_processmonitor.processDetail.sub_processName"), "diagramName"); %>
				</th>
				<th class="name sortheader" width="20%">
					<% renderTableSortHeaderCell(out, processId, inactiveWorkflowUnitsTable,
					        TagUtils.getInstance().message(pageContext, null, Globals.LOCALE_KEY,"cs_processmonitor.processDetail.stepName"), "name"); %>
				</th>
				<th class="date-time sortheader" width="15%">
					<% renderTableSortHeaderCell(out, processId, inactiveWorkflowUnitsTable,
					        TagUtils.getInstance().message(pageContext, null, Globals.LOCALE_KEY,"cs_processmonitor.processDetail.lastEnterTime"), "lastEnterTimestamp"); %>
				</th>
				<th class="duration sortheader" width="15%">
					<% renderTableSortHeaderCell(out, processId, inactiveWorkflowUnitsTable,
					        TagUtils.getInstance().message(pageContext, null, Globals.LOCALE_KEY,"cs_processmonitor.processDetail.totalDuration"), "totalDuration"); %>
				</th>
				<th class="number sortheader" width="15%">
					<% renderTableSortHeaderCell(out, processId, inactiveWorkflowUnitsTable,
					        TagUtils.getInstance().message(pageContext, null, Globals.LOCALE_KEY,"cs_processmonitor.processDetail.totalInstances"), "count"); %>
				</th>
			</tr>
		</thead>
		<tbody>
		<%
		Map<String, WorkflowUnitEntry<ProcessEntry>> wfuEntries = entry.getWorkflowUnits();
		if (wfuEntries != null) {
			List<WorkflowUnitEntry<ProcessEntry>> records =
				new ArrayList<WorkflowUnitEntry<ProcessEntry>>(wfuEntries.values());

			records = Tuples.sort(records, new TupleComparator(
					inactiveWorkflowUnitsTable.getSortFieldKey(),
					inactiveWorkflowUnitsTable.getSortOrder()));

			String paramInactiveWorkflowUnitsPageIndex = request.getParameter(
					inactiveWorkflowUnitsTable.getParamPrefix() + "pageIndex");

			int inactiveWorkflowUnitsPageIndex = (paramInactiveWorkflowUnitsPageIndex != null ?
					Integer.parseInt(paramInactiveWorkflowUnitsPageIndex) : 0);
			int inactiveWorkflowUnitsPageCount = pmHelper.getPageCount(records,
					inactiveWorkflowUnitsTable.getPageSize());

			records = pmHelper.getPage(records,
					inactiveWorkflowUnitsTable.getPageSize(), inactiveWorkflowUnitsPageIndex);
			
			for (WorkflowUnitEntry<ProcessEntry> wfuEntry : records) { %>
			<tr>
				<td class="name">
					<%=wfuEntry.getProcessAppName()%>
				</td>
				<td>
					<%=(!entry.getDiagramId().getId().equals(wfuEntry.getDiagramId().getId())) ? wfuEntry.getDiagramName() : ""%>
				</td>
				<td>
					<%=wfuEntry.getName() != null ? wfuEntry.getName() : ""%>
				</td>
				<td class="date-time">
					<%=formatHelper.formatTimestamp((Long)wfuEntry.getLastEnterTimestamp())%>
				</td>
				<td class="duration">
					<%=formatHelper.formatDuration((Long)wfuEntry.getTotalDuration())%>
				</td>
				<td class="number">
					<%=formatHelper.formatInteger(wfuEntry.getCount())%>
				</td>
			</tr>
		<% }
		} %>
		</tbody>
	</table>
	</div>

	<%
	Collection<Service> allServices = pmHelper.getServices();
	Collection<Service> processServices = pmHelper.getProcessServices(allServices, p);

	if (processServices.size() > 0) {
		Map<String, ServiceEntry> serviceEntryMap = pmHelper.getServiceEntries(processServices);
		%>

		<%
		List<ServiceEntry> activeServices = Tuples.select(serviceEntryMap.values(),
				new ProcessMonitorHelper.ProcessByExecutionStatePredicate<ServiceEntry>(
						AbstractProcessEntry.STATE_ACTIVE), -1);

		TableState activeServicesTable = (TableState)pageContext.getSession().getAttribute(
			"process.detail.activeServicesTable");
		if (activeServicesTable == null) {
			activeServicesTable = new TableState();
			activeServicesTable.setParamPrefix("activeServices.");
			activeServicesTable.setSortFieldKey("lastEnterTimestamp");
			activeServicesTable.setSortOrder(false);
			pageContext.getSession().setAttribute(
					"process.detail.activeServicesTable", activeServicesTable);
		}
		
		// Sorting should be applied before generation of table columns
		activeServicesTable.applySortingFromParams(request.getParameterMap());
		%>
		
		<div class="tablediv">
		<h2><bean:message key="cs_processmonitor.processDetail.activeServices" /></h2>
		<table class="sortable" id="activeServices">
		<thead>
			<tr>
				<th class="name sortheader" width="10%">
					<% renderTableSortHeaderCell(out, processId, activeServicesTable,
					        TagUtils.getInstance().message(pageContext, null, Globals.LOCALE_KEY,"cs_processmonitor.processDetail.processApp"), "processAppName"); %>
				</th>
				<th class="name sortheader" width="50%">
					<% renderTableSortHeaderCell(out, processId, activeServicesTable,
					        TagUtils.getInstance().message(pageContext, null, Globals.LOCALE_KEY,"cs_processmonitor.processDetail.serviceName"), "diagramName"); %>
				</th>
				<th class="date-time sortheader" width="15%">
					<% renderTableSortHeaderCell(out, processId, activeServicesTable,
							TagUtils.getInstance().message(pageContext, null, Globals.LOCALE_KEY,"cs_processmonitor.processDetail.enterTime"), "lastEnterTimestamp"); %>
				</th>
				<th class="duration sortheader" width="15%">
					<% renderTableSortHeaderCell(out, processId, activeServicesTable,
							TagUtils.getInstance().message(pageContext, null, Globals.LOCALE_KEY,"cs_processmonitor.processDetail.duration"), "duration"); %>
				</th>
				<th class="number sortheader" width="10%">
					<% renderTableSortHeaderCell(out, processId, activeServicesTable,
							TagUtils.getInstance().message(pageContext, null, Globals.LOCALE_KEY,"cs_processmonitor.processDetail.totalSteps"), "workflowUnitTotalCount"); %>
				</th>
			</tr>
		</thead>			
		<tbody>
		<%
			String paramActiveServicesPageIndex = request.getParameter(
					activeServicesTable.getParamPrefix() + "pageIndex");
			int activeServicesPageIndex = (paramActiveServicesPageIndex != null ?
					Integer.parseInt(paramActiveServicesPageIndex) : 0);
			int activeServicesPageCount = pmHelper.getPageCount(activeServices,
					activeServicesTable.getPageSize());

			if (activeServices.size() > 0) {
				List<ServiceEntry> records = new ArrayList<ServiceEntry>(activeServices);

				records = Tuples.sort(records, new TupleComparator(
						activeServicesTable.getSortFieldKey(),
						activeServicesTable.getSortOrder()));

				records = pmHelper.getPage(records,
						activeServicesTable.getPageSize(), activeServicesPageIndex);
				
				for (ServiceEntry s : records) {
				%>
				<tr>
					<td class="name">
						<%=s.getProcessAppName()%>
					</td>
					<td>
						<a href="serviceDetail.lsw?id=<%=s.getContextGuid()%>"><%=s.getDiagramName()%></a>
					</td>
					<td class="date-time">
						<%=formatHelper.formatTimestamp((Long)s.getLastEnterTimestamp())%>
					</td>
					<td class="duration">
						<%=formatHelper.formatDuration((Long)s.getDuration())%>										
					</td>
					<td class="number">
						<%=formatHelper.formatInteger(s.getWorkflowUnitTotalCount())%>
					</td>
				</tr>
				<% } %>
			<% } else { %>
				<tr>
					<td colspan="5"><bean:message key="cs_processmonitor.processDetail.noActiveService" /></td>
				</tr>
			<% } %>
		</tbody>
		</table>
		<% renderTablePaginationBar(out, processId, activeServicesTable,
				activeServicesPageCount, activeServicesPageIndex); %>
		</div>
		
		<%
		List<ServiceEntry> inactiveServices = Tuples.select(serviceEntryMap.values(),
				new ProcessMonitorHelper.ProcessByExecutionStatePredicate<ServiceEntry>(
						AbstractProcessEntry.STATE_INACTIVE), -1);

		TableState inactiveServicesTable = (TableState)pageContext.getSession().getAttribute(
			"process.detail.inactiveServicesTable");
		if (inactiveServicesTable == null) {
			inactiveServicesTable = new TableState();
			inactiveServicesTable.setParamPrefix("inactiveServices.");
			inactiveServicesTable.setSortFieldKey("lastEnterTimestamp");
			inactiveServicesTable.setSortOrder(false);
			pageContext.getSession().setAttribute(
					"process.detail.inactiveServicesTable", inactiveServicesTable);
		}
		
		// Sorting should be applied before generation of table columns
		inactiveServicesTable.applySortingFromParams(request.getParameterMap());
		%>
		
		<div class="tablediv">
		<h2><bean:message key="cs_processmonitor.processDetail.activeService_notExcuting" /></h2>
		<table  class="sortable" id="inactiveServices">
		<thead>
			<tr>
				<th class="name sortheader" width="10%">
					<%
					renderTableSortHeaderCell(out, processId, inactiveServicesTable,
					        TagUtils.getInstance().message(pageContext, null, Globals.LOCALE_KEY,"cs_processmonitor.processDetail.processApp"), "processAppName"); %>
				</th>
				<th class="name sortheader" width="40%">
					<% renderTableSortHeaderCell(out, processId, inactiveServicesTable,
					        TagUtils.getInstance().message(pageContext, null, Globals.LOCALE_KEY,"cs_processmonitor.processDetail.serviceName"), "diagramName"); %>
				</th>
				<th class="date-time sortheader" width="15%">
					<% renderTableSortHeaderCell(out, processId, inactiveServicesTable,
					        TagUtils.getInstance().message(pageContext, null, Globals.LOCALE_KEY,"cs_processmonitor.processDetail.lastEnterTime"), "lastEnterTimestamp"); %>
				</th>
				<th class="duration sortheader" width="15%">
					<% renderTableSortHeaderCell(out, processId, inactiveServicesTable,
					        TagUtils.getInstance().message(pageContext, null, Globals.LOCALE_KEY,"cs_processmonitor.processDetail.lastDuration"), "lastDuration"); %>
				</th>
				<th class="duration sortheader" width="10%">
					<% renderTableSortHeaderCell(out, processId, inactiveServicesTable,
					        TagUtils.getInstance().message(pageContext, null, Globals.LOCALE_KEY,"cs_processmonitor.processDetail.totalDuration"), "totalDuration"); %>
				</th>
				<th class="number sortheader" width="10%">
					<% renderTableSortHeaderCell(out, processId, inactiveServicesTable,
					        TagUtils.getInstance().message(pageContext, null, Globals.LOCALE_KEY,"cs_processmonitor.processDetail.totalSteps"), "workflowUnitTotalCount"); %>
				</th>
			</tr>
		</thead>
		<tbody>
		<%
			String paramInactiveServicesPageIndex = request.getParameter(
					inactiveServicesTable.getParamPrefix() + "pageIndex");
	
			int inactiveServicesPageIndex = (paramInactiveServicesPageIndex != null ?
					Integer.parseInt(paramInactiveServicesPageIndex) : 0);
			int inactiveServicesPageCount = pmHelper.getPageCount(inactiveServices,
					inactiveServicesTable.getPageSize());
	
			if (inactiveServices.size() > 0) {
				List<ServiceEntry> records = new ArrayList<ServiceEntry>(inactiveServices);

				records = Tuples.sort(records, new TupleComparator(
						inactiveServicesTable.getSortFieldKey(), inactiveServicesTable.getSortOrder()));

				records = pmHelper.getPage(records,
						inactiveServicesTable.getPageSize(), inactiveServicesPageIndex);
				
				for (ServiceEntry s : records) {
				%>
				<tr>
					<td class="name">
						<%=s.getProcessAppName()%>
					</td>
					<td>
						<a href="serviceDetail.lsw?id=<%=s.getContextGuid()%>"><%=s.getDiagramName()%></a>
					</td>
					<td class="date-time">
						<%=formatHelper.formatTimestamp((Long)s.getLastEnterTimestamp())%>
					</td>
					<td class="duration">
						<%=formatHelper.formatDuration((Long)s.getLastDuration())%>
					</td>
					<td class="duration">
						<%=formatHelper.formatDuration((Long)s.getTotalDuration())%>
					</td>
					<td class="number">
						<%=formatHelper.formatInteger(s.getWorkflowUnitTotalCount())%>
					</td>
				</tr>
				<% } %>
			<% } else { %>
				<tr>
					<td colspan="6"><bean:message key="cs_processmonitor.processDetail.noCompletedSerivces" /></td>
				</tr>
			<% } %>
		</tbody>
		</table>
		<% renderTablePaginationBar(out, processId, inactiveServicesTable,
				inactiveServicesPageCount, inactiveServicesPageIndex); %>
		</div>
	<% } %>
</body>
</html>

<%!
private void renderTableSortHeaderCell(JspWriter out, BigDecimal processId,
		TableState table, String text, String key) throws java.io.IOException {
	com.ibm.bpm.crconfig.BPMContextRootConfigService ctxRootService = com.ibm.bpm.crconfig.BPMContextRootConfigServiceFactory.getInstance().getContextRootConfigService();
	boolean order = table.getSortOrder();
	if (!key.equals(table.getSortFieldKey())) {
		order = true;
	} else {
		order = !order;
	}
	out.print("<a class='sortheader' href='processDetail.lsw?id=" + processId);
	out.print("&" + table.getParamPrefix() + "sort.key=" + key);
	out.print("&" + table.getParamPrefix() + "sort.order=" + order);
	out.print("'>");
	out.print(text);
	if (key.equals(table.getSortFieldKey())) {
		out.print("<img src='"+ctxRootService.getContextRoot(com.ibm.bpm.crconfig.BPMContextRootConfigService.BPM_WARNAME_TEAMWORKS)+"/images/" +
				(table.getSortOrder() ? "sort_asc.gif" : "sort_desc.gif") + "' alt='' border='0'/>");
	}
	out.print("</a>");
}

private void renderTablePaginationBar(JspWriter out, BigDecimal processId,
		TableState table, int pageCount, int pageIndex) throws java.io.IOException {
 	if (pageCount > 1) {
		out.println("<p>");
 		for (int i = 0; i < pageCount; i++) {
 			out.print("<a href='processDetail.lsw?id=" + processId);
 			out.print("&" + table.getParamPrefix() + "pageIndex=" + i + "' ");
 			out.print("class='" + (i == pageIndex ? "curr-page-number" : "page-number") + "'>");
 			out.print(i + 1);
 			out.print("</a>");
 		}
		out.println("</p>");
 	}
}
%>