<%@ page language="java" pageEncoding="UTF-8" contentType="text/html; charset=UTF-8"%>
<%--
-@+@-
<pageInfo>
<schema>
<simpleType name="date">
<restriction base="Date">
<format value="MM/dd/yyyy"/>
</restriction>
</simpleType>
<simpleType name="time">
<restriction base="Time">
<format value="HH:mm:ss"/>
</restriction>
</simpleType>
</schema>
<fields>
<field name="zEffDate" type="date" required="true">
<description>Effective Date</description>
<errorMessage>Value entered is not a valid Effective Date (MM/dd/yyyy)</errorMessage>
</field>
<field name="zEffTime" type="time" required="true">
<description>Effective Time</description>
<errorMessage>Value entered is not a valid Effective Time (HH:mm:ss)</errorMessage>
</field>
</fields>
</pageInfo>
-@+@-
--%>
<%@ include file="/html/msgs-init.jsp" %>
<%@ include file="common/prolog.jsp" %>
<html>
<head>
<%
    // Norwegian in "no" in Java but "nb" in Dojo.
    String language = ((Locale) session.getAttribute(Globals.LOCALE_KEY)).toString();
    if (language.equals("no")) {
        language = "nb";
    }else{
        language = language.toLowerCase().replace('_', '-');
    }
%>
<link rel="stylesheet" type="text/css" href="<lsw:ContextRoot zWebAppName='<%=com.ibm.bpm.crconfig.BPMContextRootConfigService.BPM_WARNAME_PROCESSPORTALSUPPORT%>'/>/js/dojo/1.6.1/dijit/themes/soria/soria.css">
<script type="text/javascript" src="<lsw:ContextRoot zWebAppName='<%=com.ibm.bpm.crconfig.BPMContextRootConfigService.BPM_WARNAME_PROCESSPORTALSUPPORT%>'/>/js/dojo/1.6.1/dojo/dojo.js"
        djConfig="parseOnLoad:true, locale:'<%= language%>'"></script>
		
<script type="text/javascript" src="<lsw:ImagePrefix/>script/coach_designer.js"></script>
<script type="text/javascript" src="<lsw:ImagePrefix/>script/javascript.js"></script>
<script type="text/javascript" src="<lsw:ImagePrefix/>script/validation.js"></script>
<script type="text/javascript" src="<lsw:ImagePrefix/>script/epv.js"></script>
<script type="text/javascript" src="<lsw:ImagePrefix/>script/formatting/lombardi-format.js"></script>
<script type="text/javascript">
    dojo.require("dijit.form.DateTextBox");
    dojo.require("dojo.date.locale");

    dojo.addOnLoad(function(){

        // Setup calendar drop-down style.
        dojo.addClass(dojo.body(), "soria");

        // Copy values from JSP fields to dojo widgets.
        zEffDateWidget.setValue(parseDate(dojo.byId("zEffDate").value));

        // Copy dates from widgets to JSP fields.
        zEffDateWidget.onChange = function(){
            dojo.byId("zEffDate").value = dateToString(zEffDateWidget.getValue());
        };
    });

    function /*Date*/ parseDate(/*String*/ stringDate) {
        return dojo.date.locale.parse(stringDate, {datePattern: "MM/dd/yyyy", selector: "date"});
    }

    function /*String*/ dateToString(/*Date*/ date) {
        return dojo.date.locale.format(date, {datePattern: "MM/dd/yyyy", selector: "date"});
    }
</script>

<lsw:Epv>
<lsw:EpvVar>
<lsw:EpvVarValue>
<title><bean:message key="epv_variable_value.title" /></title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
</head>
<link rel="stylesheet" type="text/css" href="./html/common/tw_rep.css" media="screen, projection" />
<LINK REL="stylesheet" HREF="./html/common/tw_epv.css" TYPE="text/css">
<body>
<form action="epv_variable_value.lsw" method="POST" name="epvForm">
<input type="hidden" name="zObject" value="Epv">
<input type="hidden" name="zActivity" value="Manage">
<input type=hidden name=zPost value=1>
<input type=hidden name=zEpvRef value="<lsw:EpvRef/>">
<input type=hidden name=zEpvVarId value="<lsw:EpvVarId/>">
<input type=hidden name=zEpvVarValueId value="<lsw:EpvVarValueId/>">
<input type=hidden name=zContext value="<%= request.getParameter("zContext") %>">
<input type=hidden name=zMode value="<%= request.getParameter("zMode") %>">
<input type=hidden name=zSaveParam value=zReason>
<table cellspacing="0" cellpadding="0" border="0" id="layout">
<tr valign="top"><td id="content"><div class="heading">
    <div class="heading-right"></div>
    <h1><bean:message key="epv_variable_value.title" /></h1>
</div>
<div class="body">
	<table class="content-table-nb" cellpadding="0" cellspacing="0">
	<tr>
	<td class="epvfield1" width="30%" class="lbl"><bean:message key="epv_variable_value.varName" /></td>
	<td class="epvfield1" align=left><lsw:EpvVarName/></td>
	</tr>
	<tr>
	<td class="epvfield1" valign="top" class="lbl"><bean:message key="epv_variable_value.reason" /></td>
	<td class="epvfield1" align=left><textarea rows=4 cols=65 name="zReason"><% if (!request.getParameter("zMode").equals("A")) { %><lsw:EpvVarValueReason/><% } else if (request.getParameter("zReason") != null) { %><%= request.getParameter("zReason") %><% } %></textarea></td>
	</tr>
	<tr>
	<td class="epvfield1" class="lbl"><bean:message key="epv_variable_value.value" /></td>
	<td class="epvfield1" align=left><lsw:WebWidget zFormName="epvForm" zFieldName="zValue" zOptional="false" zLabel="Value" zStyle="width:410" zInitialValue="sdfsf"/></td>
	</tr>
	<tr>
	<td class="epvfield1" width="30%" valign="top" class="lbl"><bean:message key="epv_variable_value.scheduleToInterval" /></td>
	<td class="epvfield1" align=left>

    <input dojoType="dijit.form.DateTextBox" jsId="zEffDateWidget" style="width:8em; font-size: 2em; height: 25px;">
	<input type="hidden" size=28 name="zEffDate" id="zEffDate" value=<% if (request.getParameter("zMode").equals("A")) { %>"<lsw:ServerDate zDateFormat="MM/dd/yyyy"/>"<% } else { %>"<lsw:EpvVarValueEffectiveOn zDateFormat="MM/dd/yyyy"/>"<% } %> onChange="vldFld(this);">

	<input class="dijitTextBox" type="text" size=26 name="zEffTime" value=<% if (request.getParameter("zMode").equals("A")) { %>"<lsw:ServerDate zDateFormat="HH:mm:ss"/>"<% } else { %>"<lsw:EpvVarValueEffectiveOn zDateFormat="HH:mm:ss"/>"<% } %> onChange="vldFld(this);">
	<lsw:Validation zFormName="epvForm" zFieldName="zEffDate"/>
	<lsw:Validation zFormName="epvForm" zFieldName="zEffTime"/>

	</td>
	</tr>
<%--	<tr>--%>
<%--	<td class="epvfield1" valign="top" class="lbl"Reason:</td>--%>
<%--	<td class="epvfield1" align=left>--%>
<%--	<textarea rows=4 cols=32 name="zReason"><% if (!request.getParameter("zMode").equals("A")) { %><lsw:EpvVarValueReason/><% } %></textarea>--%>
<%--	</td>--%>
<%--	</tr>--%>
	<% if (!request.getParameter("zMode").equals("A")) { %>
	<tr>
	<td class="epvfield1" class="lbl"><bean:message key="epv_variable_value.lastModifiedBy" /></td>
	<td class="epvfield1" align=left><div class="singleline-display"><lsw:EpvVarValueLastModifiedBy/></div></td>
	</tr>
	<tr>
	<td class="epvfield1" class="lbl"><bean:message key="epv_variable_value.lastModifiedDate" /></td>
	<td class="epvfield1" align=left><div class="singleline-display"><lsw:EpvVarValueLastModified/></div></td>
	</tr>
	<% } %>
	<tr><td>&nbsp;<br></td></tr>
	</td></tr>
	</table>
<p>
<input class="button" type=submit name=zOK value='<bean:message key="epv_variable_value.button_ok" />' onClick="return vldForm(this.form);">
&nbsp;<input class="button" type=button name=zCancel value='<bean:message key="epv_variable_value.button_cancel" />' onClick="window.close();">
<br>
<div id="ErrorMsg" class="errortype"><lsw:ErrorMessage><lsw:True><bean:message key="process_server.error.desc" />&nbsp;&nbsp;<lsw:Text zLength='80'/></lsw:True></lsw:ErrorMessage></div>
</form>
</table>
<table id="content-footer" cellspacing="0" cellpadding="0">
<tr>
    <td id="content-footer-left"></td>
    <td id="content-footer-right"></td>
</tr>


</table>
</body>
</lsw:EpvVarValue>
</lsw:EpvVar>
</lsw:Epv>
</html>
