<%@ taglib uri="/WEB-INF/tlds/struts-bean.tld" prefix="bean" %>
<%@ page import="java.util.Locale" %>
<%@ page import="com.lombardisoftware.client.delegate.SecurityDelegate" %>
<%@ page import="com.lombardisoftware.client.delegate.SecurityDelegateFactory" %>
<%@ page import="com.lombardisoftware.core.UserLocalePreferences" %>
<%@ page import="com.lombardisoftware.core.UtilityAllCore" %>
<%@ page import="com.lombardisoftware.utility.i18n.LocaleUtils" %>
<%@ page import="org.apache.struts.config.*" %>
<%@ page import="org.apache.struts.Globals" %>
<%@ page import="org.apache.struts.util.MessageResources" %>
<%@ page import="com.lombardisoftware.client.persistence.common.POType" %>
<%@ page import="com.lombardisoftware.client.persistence.common.ID" %>
<%
	if (pageContext.getAttribute(Globals.MESSAGES_KEY, PageContext.APPLICATION_SCOPE) == null) {
		ModuleConfigFactory factoryObject = ModuleConfigFactory.createFactory();
		ModuleConfig moduleConfig = factoryObject.createModuleConfig("");
		pageContext.getServletContext().setAttribute(Globals.MODULE_KEY , moduleConfig);
	
		MessageResources bundle = MessageResources.getMessageResources("com.lombardisoftware.server.core.ProcessAdminMessages");
		pageContext.setAttribute(Globals.MESSAGES_KEY, bundle, PageContext.APPLICATION_SCOPE);
	}

    Locale locale = LocaleUtils.getLocaleFromCookies(request);
    if (locale == null) { 
		SecurityDelegate securityDelegate = SecurityDelegateFactory.getInstance().newInstance();
        ID<POType.User> currentUserId = securityDelegate.getCurrentUserId(null);
		if (currentUserId != null) {
            UserLocalePreferences userLocalePrefs = securityDelegate.getUserLocalePreferences(currentUserId);
            if (userLocalePrefs.isFallback()) {
                locale = LocaleUtils.findMatching(securityDelegate.getInstalledLocales(), request.getLocales());
                userLocalePrefs.setLocale(locale.toString());
                securityDelegate.setUserLocalePreferences(currentUserId, userLocalePrefs);
            } else {
                locale = UtilityAllCore.parseLocale(userLocalePrefs.getLocale());
            }
            LocaleUtils.saveLocaleToCookies(locale, response);
		}
    }
    if(!LocaleUtils.isLocaleSupportedInHeritageUIs(locale)){
    	locale = LocaleUtils.FALLBACK_LOCALE;
    }
    if (locale != null) {
        request.getSession().setAttribute(Globals.LOCALE_KEY, locale);
    }
%>