<%@ page language="java" pageEncoding="UTF-8" contentType="text/html; charset=UTF-8"%>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<%@ include file="/html/msgs-init.jsp" %>
<%@ include file="common/prolog.jsp" %>
<%@ page errorPage="tm_error.jsp" %>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<lsw:Report>
<html><head>
<title><bean:message key="report_detail.title" /></title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />

<script src="<lsw:ImagePrefix/>script/javascript.js" type="text/javascript"></script>
<script src="<lsw:ImagePrefix/>script/chart-tooltip.js" type="text/javascript"></script>
<%@ include file="/script/toolbar.jsp" %>
<script src="<lsw:ImagePrefix/>script/images.js" type="text/javascript"></script>
<script src="<lsw:ImagePrefix/>script/calendar.js" type="text/javascript"></script>

<LINK REL="stylesheet" HREF="/portal/js/dojo/1.6.1/dijit/themes/soria/soria.css" TYPE="text/css">
<LINK REL="stylesheet" HREF="html/common/smallcal.css" TYPE="text/css">

<link rel="stylesheet" type="text/css" href="<%= com.lombardisoftware.core.PortalSkinUtilities.getPortalSkinPath(request) %>/application.css" media="screen, projection" />

<script type="text/javascript" src="/portal/js/dojo/1.6.1/dojo/dojo.js"
    djConfig="parseOnLoad:true"></script>
    
<SCRIPT type="text/javascript" src="script/coach_designer.js"></SCRIPT>
<SCRIPT type="text/javascript" src="script/javascript.js"></SCRIPT>
<SCRIPT type="text/javascript" src="script/validation.js"></SCRIPT>
<SCRIPT type="text/javascript" src="script/formatting/number-functions.js"></SCRIPT>
<SCRIPT type="text/javascript" src="script/formatting/lombardi-format.js"></SCRIPT>

<SCRIPT type="text/javascript" src="script/DateTimePicker.js"></SCRIPT>    
<script type="text/javascript">
    dojo.require("DateTimePicker");
    dojo.require("dojo.date.locale");
</script>   
</head>



<body id=csbody class=soria>
<script>
    var _report_heading_prefix = "<bean:message key="report_detail.reportDetails.desc" />";
    var _report_detail_bookmark_title_prefix = "<bean:message key="report_detail.reportDetails" />";
    var _report_detail_bookmark_title = _report_detail_bookmark_title_prefix + " - <lsw:ReportName/> - <lsw:ReportPageName/>";

    function launchEPVList() {
        window.open("cs_epv.lsw?zReportId=<%=request.getParameter("zReportId")%>&zContext=<%= request.getParameter("zContext") %>&zTip=<%= request.getParameter("zTip") %>", "epv", "toolbar=no,width=800,height=700,resizable=yes");
    }
    var firstFilter = true;

    function addUserFilter(label, html) {
        var div = document.createElement("SPAN");
        var id = document.getElementById("nav");

        var txt = "";
        txt += "<div id='nav_filter'>" +
        	  	 "<div class='divider'>&nbsp;</div>\n" +
        			"<div id='nav_header_filter'>" +
      					"<div class='heading'>" +
    	      	     		"<h1>" + label + "</h1>" +
   	          	      "</div>" +
   	               "</div>" +
   	           "</div>"+
               "<div class='body'><ul><li style='height:auto;'>" + html + "</li></ul></div>";

  
        div.innerHTML = txt;
        id.appendChild(div);
    }
    
    function displayDateFilter(fName, initialValue) {
        var nameAttribute = fName;
        var valueAttribute=initialValue;
        var elementId = fName;
        var dpattern = document.getElementById("dateWrap-" + elementId).getAttribute("datePattern");

        var dateWidget = new DateTimePicker({
            id: elementId,
            name: elementId,
            dateTimePattern: dpattern,
            boundToDate: true
        });
        dateWidget.attr("value", valueAttribute);

        document.getElementById("dateWrap-" + elementId).appendChild(dateWidget.domNode);
        dateWidget.startup();
        var element = dojo.byId(elementId);

        dojo.attr(element, "name", nameAttribute);
        dojo.attr(element, "value", valueAttribute);
    }

    function drilldownClick(label, serie, data, chart) {
        return true;
    }

    function addExportData(csvTable) {
        if (document.forms.exportData == null || document.forms.exportData.data == null) {
            return;
        }
        document.forms.exportData.data.value = "\uFEFF" + document.forms.exportData.data.value +
                                               "\n\n" + csvTable;
    }

    function addToTitleBar(html, align) {
        var td = document.createElement("TD");
        td.className = "rptoolbar-inner-text";
        var id = document.getElementById("_" + align.toLowerCase() + "_title_tr");
        td.innerHTML = html;
        if (align == "right") {
            var curBtn = document.getElementById("_right_title_epvb");
            id.insertBefore(td, curBtn);
        } else {
            id.appendChild(td);
        }
    }

    function doSaveSettings() {
		if (document.all) {
			window.external.AddFavorite(location.href, _report_detail_bookmark_title);
		} else if (window.sidebar) {
			window.sidebar.addPanel(_report_detail_bookmark_title , location.href,  "");
		}        
    }

    function doSubmitRefresh() {
        document.forms["refreshData"].submit();
    }

    function doSubmitExport() {
        document.forms["exportData"].submit();
    }

    function changeReportHeading(reportName, pageName) {
        var heading = reportName + " - " + pageName;
        var el = document.getElementById("report-heading");
        if (el) {
            el.innerHTML = _report_heading_prefix + " " + heading;
        }
       _report_detail_bookmark_title = _report_detail_bookmark_title_prefix + " - " + heading;
    }
</script>

<form name="exportData" method="post" target="_new" action="data-redirect.jsp">
<input type="hidden" name="data" value="">
<input type="hidden" name="fileName" value="filename=reportData.csv">
</form>

<form name="refreshData" method="post" action="reportDetails.lsw" >
<input type="hidden" name="zReportId" value="<%= request.getParameter("zReportId") %>">
<input type="hidden" name="zContext" value="<%= request.getParameter("zContext") %>">
<input type="hidden" name="zTip" value="<%= request.getParameter("zTip") %>">
<% if(request.getParameter("zSkipExposeCheck") != null) { %> <input type="hidden" name="zSkipExposeCheck" value="<%= request.getParameter("zSkipExposeCheck") %>"> <% } %>
<% if(request.getParameter("zPageId") != null) {%>  <input type="hidden" name="zPageId" value="<%= request.getParameter("zPageId") %>"> <% } %>
<input type="hidden" name="zSaveAllParams" value="1">

<table cellspacing=0 cellpadding=0 border=0 id="layout">
<tr valign=top>
<td id=nav>
<div id=nav_header>
 <div class=heading><h1><bean:message key="report_detail.reportFilters" /></h1></div>
</div>
</td>
<td id="content">
<div class="heading">
<div class="heading-right"></div><h1 id="report-heading"><bean:message key="report_detail.reportDetails.desc" /> <lsw:ReportName/> - <lsw:ReportPageName/></h1></div>
<div id="toolbar">
<table border="0" cellspacing="0" cellpadding="0">
<tr valign="top">
<td class="button" nowrap><a href="javascript:doSaveSettings();"><img src="/portal/jsp/images/reporting/enabled/save_16x16.gif" align="left"><bean:message key="report_detail.save" /></a>
<td class="divider">&nbsp;|&nbsp;</td>
<td class="button" nowrap><a href="javascript:launchEPVList()"><img src="/portal/jsp/images/reporting/enabled/epv_16x16.gif" align="left"><bean:message key="report_detail.manageExposedProcessValues" /></li></a>
<td class="divider">&nbsp;|&nbsp;</td>
<td class="button" nowrap>
<a href="javascript:doSubmitExport()"><img src="/portal/jsp/images/reporting/enabled/export_16x16.gif" align="left"><bean:message key="report_detail.export" /></a>
<td class="divider">&nbsp;|&nbsp;</td>
<td class="button" nowrap><a href="javascript:doSubmitRefresh();"><img src="/portal/jsp/images/reporting/enabled/refresh_16x16.gif" align="left"><bean:message key="report_detail.refresh" /></a>
</td></tr>
</table>
</div>
<div class="body">
<lsw:True><lsw:ReportBody/></lsw:True>
<lsw:False><p><bean:message key="report_detail.warn.no_access" /></p></lsw:False>
</div>
</table>
</form>
</lsw:Report>
