<%@ page language="java" pageEncoding="UTF-8" contentType="text/html; charset=UTF-8"%>
<%@ include file="/html/msgs-init.jsp" %>
<%@ include file="common/prolog.jsp" %>
<html>
<%! String selectedScoreboardId = null; %>
<%! String selectedScoreboardName = null; %>
<lsw:Scoreboard>
<% selectedScoreboardId = scoreboardId; %>
<% selectedScoreboardName = scoreboardName; %>
<head>
<script src="<lsw:ImagePrefix/>script/javascript.js" type="text/javascript"></script>
<script src="<lsw:ImagePrefix/>script/chart-tooltip.js" type="text/javascript"></script>
<%@ include file="/script/toolbar.jsp" %>
<script src="<lsw:ImagePrefix/>script/images.js" type="text/javascript"></script>
<script type="text/javascript">
<%-- This code uses jsp expressions so must remain in the .jsp page --%>
function doOnLoad() {
 top.toolbarLoaded = true;
 if (top.taskStatus) {
  doConfigureButtons();
 }
}

function doConfigureButtons() {
 configureButtons(top.taskStatus);
}

var imagePrefix = "<lsw:ImagePrefix/>";
MM_reloadPage(true);
</script>
<SCRIPT LANGUAGE="JavaScript">
function launch(URL, Name, Features, orgName) {
var remote = open(URL, Name, Features);
if (remote.opener == null)
 remote.opener = window;
 remote.opener.name = orgName;
 return remote;
}

function launchAbout() {
Remote = launch("./about.html", "Remote","menubar=0,resizable=0,scrollbars=0,status=0,titlebar=0,toolbar=0,z-lock=0", "AboutWindow");
}

function launchSupport() {
Remote = launch("./support.html", "Remote","menubar=0,resizable=0,scrollbars=0,status=0,titlebar=0,toolbar=0,z-lock=0", "SupportWindow");
}

function doScbdLogout() {
if (confirm('<bean:message key="scbd_main.doScbdLogout.confirm" />'))
 parent.location.href='tm_logout.lsw?zObject=Session&zActivity=Logout&zPost=1';
}
<%-- Copied from report_detail.jsp --%>
function addUserFilter(label, html) {

   var div = document.createElement("DIV");

   var id = document.getElementById("addFilterTag");



   div.innerHTML =

     "<table border='0' width='100%' cellpadding=0 cellspacing=0>" +

     "<tr><td class='rpfilterhd'>" + label + "</td></tr>" +

     "<tr><td class='rpfilterbd'>" + html + "</td></tr></table><BR>";

   if (id) {
     id.appendChild(div);
   }

}



function addExportData(csvTable) {

}
</script>
<script src="<lsw:ImagePrefix/>script/javascript.js" type="text/javascript"></script>
<%@ include file="/script/scoreboard.jsp" %>
<script src="<lsw:ImagePrefix/>script/alertlist.js" type="text/javascript"></script>
<link rel="stylesheet" href="<lsw:ImagePrefix/>html/common/scoreboard.css" type="text/css">
<link rel="stylesheet" href="<lsw:ImagePrefix/>html/common/tw.css" type="text/css">
<link rel="stylesheet" href="<lsw:ImagePrefix/>html/common/tw_alert.css" type="text/css">
<% if (!scoreboardCss.equals("")) { %>
<link rel="stylesheet" href="<lsw:ImagePrefix/><lsw:ScoreboardCSS/>" type="text/css">
<% } %>
<title><bean:message key="scbd_main.title" />(<lsw:User><lsw:UserName/> &lt;<lsw:UserFullName/>&gt;</lsw:User>
<lsw:HasAssumed>
<lsw:True>
 <bean:message key="scbd_main.assumedBy" /><lsw:AssumeUser><lsw:UserName/> &lt;<lsw:UserFullName/>&gt;</lsw:AssumeUser>)
</lsw:True>
<lsw:False>
)
</lsw:False>
</lsw:HasAssumed>
</title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
</head>
<body>
<table cellpadding="0" cellspacing="0" width="100%"><tr>
<td class='cslogo-scbd' width='194'>&nbsp;</td>
<td class="cshdr1"><div class="cshdrtitle">&nbsp;<bean:message key="scbd_main.lombardi_scoreBoard" /><br><%= scoreboardTitle %></div><%@ include file="common/menu_portal.jsp" %></td>
<td class="cshdr2-scbd"><div class="twlogo"><bean:message key="scbd_main.lombardi" />&reg;&nbsp;</div><br>
<!-- <div class="info1"><A HREF="javascript:launchAbout()">About WebSphere Business Process Manager&reg;</a>&nbsp;<br>
<A HREF="javascript:launchSupport()">WebSphere Business Process Manager&#153; Support</a>&nbsp;</div>  -->
<a href="javascript:doScbdLogout();" class="twlogo"><bean:message key="scbd_main.logoff" /></a>
</td></tr>
</table>
<div class="tabBar">
  <lsw:ScoreboardList>
  <div onClick="tabClicked(this)" lsw:SCBD="<%= curScoreboardId %>" class="<%= selectedScoreboardId.equals(curScoreboardId)?"tabSelected":"tabUnselected" %>">
   <%= curScoreboardTitle %></div>
  </lsw:ScoreboardList>
<div class="nomoretabs"></div>
</div>
<div class="tabBarBottom">
<div class="setDefaultTab" title="<bean:message key="scbd_main.make_default" arg0="<%= selectedScoreboardName %>" />" ><button class="makeDefault" onClick="setDefaultTab('<%= selectedScoreboardId %>', '<%= selectedScoreboardName %>')";return false;"><bean:message key="scbd_main.make_scoreboard_default" /></button></div>
</div>
</div>
<div class="scoreboardBody">
<lsw:ScoreboardBody/>
<lsw:False>
<b><bean:message key="scbd_main.no_enabled_scoreboards" /></b>
</lsw:False>
</body></lsw:Scoreboard></html>