<%@ page language="java" pageEncoding="UTF-8" contentType="text/html; charset=UTF-8"%>
<%@ page import="java.io.PrintWriter, com.lombardisoftware.core.StringUtilities,
                 java.io.StringWriter, org.apache.commons.lang.StringEscapeUtils"%>
<%@ taglib uri="/lsw" prefix="lsw" %>
<%@ include file="/html/msgs-init.jsp" %>
<%@ page isErrorPage="true" %>
<!--
<tw:xmlData>
<error>
<message>
<% if (exception != null) { %><%= StringUtilities.xmlEncodeString(exception.getMessage()) %><% } else { %><%= StringUtilities.xmlEncodeString((String)request.getAttribute("com.lombardisoftware.error.message")) %><% } %>
</message>
<stackTrace>
<% if (exception != null) {
      StringWriter writer = new StringWriter();
      PrintWriter printWriter = new PrintWriter(writer);
      exception.printStackTrace(printWriter);
      printWriter.flush();
      out.write(StringUtilities.xmlEncodeString(writer.toString()));
   } else {
       %><%= StringUtilities.xmlEncodeString((String)request.getAttribute("com.lombardisoftware.error.stackTrace")) %>
<% } %>
</stackTrace>
</error>
</tw:xmlData>
-->
<html>
<head>
<title><bean:message key="tm_error.title" /> <% if (exception != null) { %><%= StringUtilities.xmlEncodeString(exception.getMessage()) %><% } else { %><%= request.getAttribute("com.lombardisoftware.error.message") %><% } %></title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
</head>
<script language="JavaScript">

var flgDetails = false;
var objTrace   = null;

function doOnLoad() {
}

function showDetails() {
 flgDetails = !flgDetails;

 if (objTrace == null)
  objTrace = document.getElementById("stacktrace");
 if (flgDetails) {
  objTrace.style.visibility = "visible";
 } else {
  objTrace.style.visibility = "hidden";
 }
}

try {
    // Handle handshaking with social portal and task widget
    if ((!!(window.parent)) && (window != window.parent)) {
        var event = {
            "name": "onError",
            "parameters": [ '<% if (exception != null) { %><%= StringEscapeUtils.escapeJavaScript(exception.getMessage().toString()).replace("<","\\u003c") %><% } else { %><%= StringEscapeUtils.escapeJavaScript(request.getAttribute("com.lombardisoftware.error.message").toString()) %><% } %>']
        };
        // sending error message to the social portal
		// work item 131966
		var serializedEvent = JSON.stringify(event);
		try {
			window.parent.postMessage(serializedEvent, "*");
		} catch (e) {
			// postMessage() failed, use direct call onMessage instead with faked event. Container MUST be co-located
			console.log("iframe postMessage() failed, call onMessage() directly - event=", serializedEvent);
			if (!!window.parent.onMessage && typeof window.parent.onMessage === 'function') {				
				window.parent.onMessage({origin: window.location.protocol + "//" + window.location.host,
										data: serializedEvent, 
										source: window});
			} else {
				console.log("onMessage() does not exist");				
			}
		}		
    }
} catch (e) {
}
</script>
<LINK REL="stylesheet" HREF="<lsw:ImagePrefix />html/common/tw.css" TYPE="text/css">
<body class="folders" onLoad="doOnLoad()">
<table width="100%" cellpadding="0" cellspacing="0" border="0">
<tr><td class="cstitle">&nbsp;<bean:message key="tm_error.error" /></td></tr>
</table>
<table cellpadding="4" cellspacing="0" border="0" width="100%" style="border:solid black 1">
<tr>
<td><div class="errormsg" align="left"><% if (exception != null) { %><%= StringUtilities.xmlEncodeString(exception.getMessage()) %><% } else { %><%= request.getAttribute("com.lombardisoftware.error.message") %><% } %></div></td>
</tr>
<tr>
<td><center><input name="detailsB" class="button" type="button" value='<bean:message key="tm_error.button_details" />' onClick="showDetails()"></center></td>
</tr>
</table>
<br>
<div id="stacktrace" style="visibility:hidden">
<table cellpadding="4" cellspacing="0" border="0" width="100%" style="border:solid black 1">
<% 
String stackTraceString = "";
if (exception != null) {
    StringWriter writer = new StringWriter();
    PrintWriter printWriter = new PrintWriter(writer);
    exception.printStackTrace(printWriter);
    printWriter.flush();
	stackTraceString = StringUtilities.xmlEncodeString(writer.toString());
} else {
	stackTraceString = request.getAttribute("com.lombardisoftware.error.stackTrace").toString();
} 
%>
<tr><td><div class="errormsg" style="font-family:Courier New, Courier, monospace">
<%=stackTraceString%>
</div></td></tr>
</table>
</div>
</body>
</html>
