<%@ page language="java" pageEncoding="UTF-8" contentType="text/html; charset=UTF-8"%>
<%@ page import="com.lombardisoftware.servlet.ControllerServlet" %>
<%@ page import="com.lombardisoftware.servlet.util.MimeTypeUtils" %>

<%
    // To prevent XSS attack we could escape the content, but per design it is already escaped. To avoid
    // the data being escaped twice and to prevent XSS attack at the same time, we do not allow a user
    // to force the content type. We resolve MIME type based on file extension and if it is considered
    // as other than downloadable, cancel the request.

    String fileName = request.getParameter("fileName");
    String mimeType = MimeTypeUtils.getMimeTypeForDownloadableData(fileName);

    if (mimeType == null) {
        ControllerServlet.processError(request, response, new ServletException("Content type cannot be resolved"));
    }

    response.setContentType(mimeType + "; charset=utf-8");
    response.addHeader("Content-Disposition", fileName);
    response.getWriter().print(request.getParameter("data"));
%>
