<%@ page language="java" pageEncoding="UTF-8" contentType="text/html; charset=UTF-8"%>
<jsp:useBean id="content" class="java.lang.String" scope="request" />
<!DOCTYPE html>
<html>
<head>
<!-- GENERATION: All resources (including individual control external resources) loading start -->

<link rel="stylesheet" type="text/css" href="/portal/js/dojo/1.6.1/dijit/themes/soria/soria.css">
<script type="text/javascript" src="/portal/js/dojo/1.6.1/dojo/dojo.js" 
     djConfig="parseOnLoad:true"></script>

<script type="text/javascript" src="../../script/coachNG.js"></script>
<link rel="stylesheet" type="text/css" href="../common/coach_ng.css">

<!-- GENERATION: All resources loading end -->

<script type="text/javascript">
	// GENERATION: View scope class starts here
	// TextFieldView
	dojo.provide("com.ibm.bpm.coach.snapshotId.TextFieldView");
	com.ibm.bpm.coach.snapshotId.TextFieldView.prototype = new com.ibm.bpm.coach.CoachView;
	com.ibm.bpm.coach.snapshotId.TextFieldView.prototype.constructor = com.ibm.bpm.coach.snapshotId.TextFieldView;
	com.ibm.bpm.coach.snapshotId.TextFieldView = function (element, binding, options, readOnly) {
		com.ibm.bpm.coach.CoachView.apply(this, [element, binding, options, readOnly]);
		
		this.view = function() {
			// Override super-class lifeCycle onView method
			// Sample JS code:  Populate the input text by the binding object initial value
			this.context.element.getElementsByTagName("input")[0].value = this.context.binding.get("value");
			
		};
    		this.change = function(changeEvent) {
							// Override super-class change method
							
							//changeEvent has the following properties:
							// type = binding/config
							// property = (for complex types) the property that was changed
							// oldVal = (for simple types) previous value
							// newVal = new value
							// insertedInto = (for arrays) index where the object was added to the list
							// removedFrom = (for arrays) index where the object was removed from the list
							// optionName = (for config changes) the name of the option that has changed
							if (changeEvent.type == "config"){
							   console.debug("config change " + changeEvent.property + " " + changeEvent.newVal);
							   if (changeEvent.property == "_metadata.visibility"){
							        console.debug(this.context.options._metadata.visibility);
							   }
							} else {
								this.context.element.getElementsByTagName("input")[0].value = changeEvent.newVal;
							}
    		};
    		this.load = function() {
    			var viewElement = this.context.element.getElementsByTagName("input")[0]; 
    			dojo.connect(viewElement, "onchange", this, function() {this.context.binding.set("value", viewElement.value);});
    		};
	};

    // ButtonView
    dojo.provide("com.ibm.bpm.coach.snapshotId.ButtonView");
	com.ibm.bpm.coach.snapshotId.ButtonView.prototype = new com.ibm.bpm.coach.CoachView;
	com.ibm.bpm.coach.snapshotId.ButtonView.prototype.constructor = com.ibm.bpm.coach.snapshotId.ButtonView;
	com.ibm.bpm.coach.snapshotId.ButtonView = function (element, binding, options, readOnly) {
		com.ibm.bpm.coach.CoachView.apply(this, [element, binding, options, readOnly]);
		
		this.view = function() {
			// Super-class lifeCycle onView method
			// Sample JS code:  Populate the input text by the binding object initial value
			this.context.element.getElementsByTagName("input")[0].value = this.context.options._metadata.label;
	    	this.context.element.getElementsByTagName("input")[0].onclick = function() {
	    		alert("button is clicked");
	    	};
		};
	};

	// LabelView
	dojo.provide("com.ibm.bpm.coach.snapshotId.LabelView");
	com.ibm.bpm.coach.snapshotId.LabelView.prototype = new com.ibm.bpm.coach.CoachView;
	com.ibm.bpm.coach.snapshotId.LabelView.prototype.constructor = com.ibm.bpm.coach.snapshotId.LabelView;
	com.ibm.bpm.coach.snapshotId.LabelView = function (element, binding, options, readOnly) {
		com.ibm.bpm.coach.CoachView.apply(this, [element, binding, options, readOnly]);
		
		this.view = function() {
			// Override super-class lifeCycle onView method
			// Sample JS code:  Populate the input text by the binding object initial value
			this.context.element.firstChild.innerHTML = this.context.binding.get("value");
			
		};
    		this.change = function(changeEvent) {
							// Override super-class change method
    							console.debug("subclass change detected");
								this.context.element.firstChild.innerHTML = changeEvent.newVal;
    						};	        
	};
	// GENERATION: View scope class ends here	

    // ListView09
	dojo.provide("com.ibm.bpm.coach.snapshotId.ListView09");
	com.ibm.bpm.coach.snapshotId.ListView09.prototype = new com.ibm.bpm.coach.CoachView;
	com.ibm.bpm.coach.snapshotId.ListView09.prototype.constructor = com.ibm.bpm.coach.snapshotId.ListView09;
	com.ibm.bpm.coach.snapshotId.ListView09 = function (element, binding, options, readOnly) {
		com.ibm.bpm.coach.CoachView.apply(this, [element, binding, options, readOnly]);

		this.view = function() {
			// Override super-class lifeCycle onView method
			// Sample JS code:  Populate the input text by the binding object initial value
			
		};

    		this.change = function(changeEvent) {
							// Override super-class change method
    							console.debug("list change detected, new val: ", changeEvent.newVal, 
    							"removedFrom: ",changeEvent.removedFrom, 
    							"insertedInto: ",changeEvent.insertedInto);
    						};	        
  	};
	
	// ListViewString
	dojo.provide("com.ibm.bpm.coach.snapshotId.ListViewString");
	com.ibm.bpm.coach.snapshotId.ListViewString.prototype = new com.ibm.bpm.coach.CoachView;
	com.ibm.bpm.coach.snapshotId.ListViewString.prototype.constructor = com.ibm.bpm.coach.snapshotId.ListViewString;
	com.ibm.bpm.coach.snapshotId.ListViewString = function (element, binding, options, readOnly) {
		com.ibm.bpm.coach.CoachView.apply(this, [element, binding, options, readOnly]);
        
		
		this.load = function() {
		 
			//simple helper function for retriving the content box
			var getTemplateBox = function(currentDiv, templateViewName){
				var childrenContentBoxes = 	dojo.query('#' + currentDiv.id + '> .ContentBox');
				if(childrenContentBoxes.length == 0 ) {
					// no child
					return;
				}
				// we only care the first contentBox
				var contentBoxDiv = childrenContentBoxes[0];
			
				if(contentBoxDiv.getAttribute('data-view-managed') != "true") {
					// robust check, if it's framework managed, we shouldn't create view here
					return null;
				}
				
				if (!!templateViewName){
					var views = dojo.query('#' + contentBoxDiv.id + '> .' + templateViewName);
				    return views[0];
				}
				else {
					return contentBoxDiv;
				}			
			};
			
			/*
			* 1. Create view markup and scope object for each object in the list
			*/
		    var viewTemplateBox = getTemplateBox(this.context.element);							
			//save the template in viewScope for later add view
			this.viewTemplate = viewTemplateBox.children[0];
			viewTemplateBox.removeChild(this.viewTemplate);
			
			//create view markup and view scope
			for(var i=0; i<this.context.binding.get("value").length(); i++) {
				var viewDiv = this.viewTemplate.cloneNode(true);
				viewTemplateBox.appendChild(viewDiv);
				this.context.createView(viewDiv, i);
			}		
			
            /*
			 * 2. Add button click handlers
			 */
			var bindingObj = this.context.binding; //Note: if the object that this view bound to changes, we need to refresh the view
			var element = this.context.element;
			
			//add button click handler
			this.context.element.getElementsByTagName("input")[0].onclick = function(event) {
	    		bindingObj.get("value").add({name : bindingObj.get("value").length()});
	    	}
			
			//delete button
			this.context.element.getElementsByTagName("input")[2].onclick = function(event) {
			    var index = parseInt(element.getElementsByTagName("input")[1].value);
				if(index>=0){
					bindingObj.get("value").remove(index);
				}
	    	}
		    //update button
			this.context.element.getElementsByTagName("input")[4].onclick = function(event) {
				var index = parseInt(element.getElementsByTagName("input")[3].value);
				if(index>=0){				
					bindingObj.get("value").put(index,{name : Math.random()});
				}
	    	}
			
			//update the value of the binding object. Mostly it wont not be done here,
			//instead the update is done by sth outside this view: like change from server side. 
			//Just put it here to test this case
			this.context.element.getElementsByTagName("input")[5].onclick = function(event) {			   
				var newObject = [{name: "newName"}, {name: "newName2"}]; 
				//Note that the new value is a simple array, ie, not coach.List
				//bindingObj.set("value", new com.ibm.bpm.coach.List(newObject) );
				bindingObj.set("value", newObject);
	    	}
			
			/*
			 * 3. Register addtional change listeners, ie, binding to additional data
			 */
			//Todo: Code review: either use dojo.hitch, or pass in the this object, so that the framework can apply this
			this.context.binding.get("value").bindAll(dojo.hitch(this, this.listUpdated));
		}
		
		//User defined change handler
		this.listUpdated = function (changeEvent){
		
		    var childrenContentBox = dojo.query('#' + this.context.element.id + '> .ContentBox')[0];
			 
		    //update case: suppose to refresh the view. but currently we do not support refresh view
			//instead, they will receive 2 notifications, one is for remove, another is for add
			if (changeEvent.insertedInto >= 0 &&  changeEvent.removedFrom >= 0){
				var viewId = "";
				var index = "";
				//this.context.refreshView(viewId, index)
			}
								
			//an object is removed from the list, delete the view
			if (changeEvent.removedFrom >= 0){								    	
				var viewElements = dojo.query('#' + childrenContentBox.id + ' div');
				var viewToDelete = viewElements[changeEvent.removedFrom];
				this.context.deleteView(viewToDelete);	
				viewToDelete.parentNode.removeChild(viewToDelete);
				//need to clean up the watch handler... I guess we can do it later
			}
								//add case. the list view will create the markup for a new item and call createView (createView is a function will be implementated by framework)
								if (changeEvent.insertedInto >= 0 ){								    
									//1. create the markup for the view, by clonning the stored template							    
									var newPersonDiv = this.viewTemplate.cloneNode(true);
									
									//find the place to insert the new div
									//var viewElements = dojo.query('#' + this.context.element.id + '> .ListViewString');
									var viewElements = dojo.query('#' + this.context.element.children[7].id + ' div');
									var numberOfViewElement = viewElements.length;
									this.context.element.children[7].insertBefore( newPersonDiv, viewElements[changeEvent.insertedInto]);		
									
									//???? To verify: you must need an context box...around the dom for the markup
									//no need to have context box
								    //2.call initview helper from framework	
									//this.context.adjustIdAndBinding(newPersonDiv, this, changeEvent.insertedInto);									
									var newViewScope = this.context.createView(newPersonDiv, changeEvent.insertedInto);
									//newViewScope.view();
								}		
    							
		};
		
		this.view = function() {	    
		     
			
		};

    	this.change = function(changeEvent) {
		                 // Override super-class change method
    							console.debug("list change detected, new val: ", changeEvent.newVal, 
    							"removedFrom: ",changeEvent.removedFrom, 
    							"insertedInto: ",changeEvent.insertedInto);
								
			             var    createViewMarkup = function(context, person, index){
								// var   newPersonDiv = document.createElement("div");										
									// var   nameInput = document.createElement("input");										
									// nameInput.value = person.name;											 
									// var   phoneInput = document.createElement("input");										
									// phoneInput.value = person.phoneNumber;
									// newPersonDiv.appendChild(nameInput);
									// newPersonDiv.appendChild(document.createElement("br"));
									// newPersonDiv.appendChild(phoneInput);
									// return newPersonDiv;	
					
						};
						
						//Case 1
						if(changeEvent.property == "person"){
								  //remove all the old dom
								  var viewElements = dojo.query('#' + this.context.element.children[7].id + ' div');
									
									//var viewElementList = dojo.query('#div_ListViewString div');
									var numberOfViewElement = viewElements.length;
									for (var i=0; i<numberOfViewElement; i++){
										var viewToDelete = viewElements[i];
										this.context.deleteView(viewToDelete);	
										viewToDelete.parentNode.removeChild(viewToDelete);
									}
								
								debugger;
								
                                for(var i=0; i<this.context.binding.get("value").length(); i++) {
								    	debugger;
									var newPersonDiv = this.viewTemplate.cloneNode(true);
									
									//find the place to insert the new div
									//var viewElements = dojo.query('#' + this.context.element.id + '> .ListViewString');
									var viewElements = dojo.query('#' + this.context.element.children[7].id + ' div');
									var numberOfViewElement = viewElements.length;
									this.context.element.children[7].appendChild(newPersonDiv);
									//???? To verify: you must need an context box...around the dom for the markup
									//no need to have context box
								    //2.call initview helper from framework	
									//this.context.adjustIdAndBinding(newPersonDiv, this, changeEvent.insertedInto);									
									var newViewScope = this.context.createView(newPersonDiv, i);
									//newViewScope.view();
								}			
                                this.context.binding.get("value").bindAll(dojo.hitch(this, this.listUpdated));								
							}
            
		};
		this.unload = function() {
			//remove additional registeration added
		};

  	};


	// PublisherView
	dojo.provide("com.ibm.bpm.coach.snapshotId.PublisherView");
	com.ibm.bpm.coach.snapshotId.PublisherView.prototype = new com.ibm.bpm.coach.CoachView;
	com.ibm.bpm.coach.snapshotId.PublisherView.prototype.constructor = com.ibm.bpm.coach.snapshotId.PublisherView;
	com.ibm.bpm.coach.snapshotId.PublisherView = function (element, binding, options, readOnly) {
		com.ibm.bpm.coach.CoachView.apply(this, [element, binding, options, readOnly]);

    		this.change = function(changeEvent) {
							// Override super-class change method
    							console.debug("subclass change detected: " + changeEvent.property);
    						};
    						
			this.load = function() {
				var binding = this.context.binding.get("value");
				console.debug("getting publisher: " + binding);
				console.debug("getting publisher.prop: " + binding.get("prop"));
				console.debug("getting publisher.prop.prop1: " + binding.get("prop.prop1"));
				console.debug("getting publisher.prop.prop2: " + binding.get("prop.prop2"));
				console.debug("getting publisher.prop.prop2.prop3: " + binding.get("prop.prop2.prop3"));
				binding.bindAll(function(e) {console.debug("custom bindAll: " + e.property + " = " +e.newVal);});
				binding.bind("prop.prop2.prop3", function(e) {console.debug("custom bind prop.prop2.prop3 changed: " + e.newVal);});
			};    						
		
	};

	// PersonView
	dojo.provide("com.ibm.bpm.coach.snapshotId.PersonView");
	com.ibm.bpm.coach.snapshotId.PersonView.prototype = new com.ibm.bpm.coach.CoachView;
	com.ibm.bpm.coach.snapshotId.PersonView.prototype.constructor = com.ibm.bpm.coach.snapshotId.PersonView;
	com.ibm.bpm.coach.snapshotId.PersonView = function (element, binding, options, readOnly) {
		com.ibm.bpm.coach.CoachView.apply(this, [element, binding, options, readOnly]);
		
		this.view = function() {
			// Override super-class lifeCycle onView method
			// Sample JS code:  Populate the input text by the binding object initial value
			this.context.element.getElementsByTagName("input")[0].value = this.context.binding.get("value").get("name");
			this.context.element.getElementsByTagName("input")[1].value = this.context.binding.get("value").get("phoneNumber");
		};
    		this.change = function(changeEvent) {
							// Override super-class change method
    							console.debug("subclass change detected: " + changeEvent.property);
    							var inputList = this.context.element.getElementsByTagName("input");
    							for (var i=0; i<inputList.length; i++) {
    								if (inputList[i].name == changeEvent.property) {
									inputList[i].value = changeEvent.newVal;
									break;
								}
							}
    						};	        
    		this.load = function() {
    			dojo.connect(this.context.element.getElementsByTagName("input")[0], "onchange", this, 
    				function() {this.context.binding.get("value").set("name", this.context.element.getElementsByTagName("input")[0].value);}
    				);
    			dojo.connect(this.context.element.getElementsByTagName("input")[1], "onchange", this, 
    				function() {this.context.binding.get("value").set("phoneNumber", this.context.element.getElementsByTagName("input")[1].value);}
    				);
    		};
	};
	
    // ListView10
	dojo.provide("com.ibm.bpm.coach.snapshotId.ListView10");
	com.ibm.bpm.coach.snapshotId. ListView10.prototype = new com.ibm.bpm.coach.CoachView;
	com.ibm.bpm.coach.snapshotId. ListView10.prototype.constructor = com.ibm.bpm.coach.snapshotId. ListView10;
	com.ibm.bpm.coach.snapshotId. ListView10 = function (element, binding, options, readOnly) {
		com.ibm.bpm.coach.CoachView.apply(this, [element, binding, options, readOnly]);

		this.load = function() {

			var currentDiv = this.context.element;
			var immediateContentBoxList = dojo.query('#' + this.context.element.id + '> .ContentBox');
			if(immediateContentBoxList.length == 0) {
				// no child
				return;
			}
			// we only care the first contentBox
			var contentBoxDiv = immediateContentBoxList[0];
			
			if(contentBoxDiv.getAttribute('data-view-managed') != "true") {
				// robust check, if it's framework managed, we shouldn't create view here
				return;
			}
			
			if(this.context.binding.get("value") instanceof com.ibm.bpm.coach.List) {
				// need to repeat the contentBox based on the data-binding
				
				// step 1, save the template in my own viewScope for the future use
				currentDiv.removeChild(contentBoxDiv);
				// 
				for(var k=0; k<this.context.binding.get("value").length(); k++) {
					var oneDiv = contentBoxDiv.cloneNode(true);
					oneDiv.insertBefore(document.createTextNode(" This is ContentBox " + k), oneDiv.firstChild);
					currentDiv.appendChild(oneDiv);
					this.context.createView(oneDiv, k);
				}
			}	
		}

		this.view = function() {
			// Override super-class lifeCycle onView method
			// Sample JS code:  Populate the input text by the binding object initial value
			
		};

    	this.change = function(changeEvent) {
			// Override super-class change method
				console.debug("list change detected, object: ", changeEvent.object, 
				"removedFrom: ",changeEvent.removedFrom, 
				"insertedInto: ",changeEvent.insertedInto);
    	};	        
  	};

    // PublisherView_SM
	dojo.provide("com.ibm.bpm.coach.snapshotId.PublisherView_SM");
	com.ibm.bpm.coach.snapshotId.PublisherView_SM.prototype = new com.ibm.bpm.coach.CoachView;
	com.ibm.bpm.coach.snapshotId.PublisherView_SM.prototype.constructor = com.ibm.bpm.coach.snapshotId.PublisherView_SM;
	com.ibm.bpm.coach.snapshotId.PublisherView_SM = function (element, binding, options, readOnly) {
		com.ibm.bpm.coach.CoachView.apply(this, [element, binding, options, readOnly]);

    		this.change = function(changeEvent) {
							// Override super-class change method
    							console.debug("subclass change detected: " + changeEvent.property);
    						};
    						
			this.load = function() {
			
				this.createMySubViews();
				
				var binding = this.context.binding.get("value");
				console.debug("getting publisher: " + binding);
				console.debug("getting publisher.prop: " + binding.get("prop"));
				console.debug("getting publisher.prop.prop1: " + binding.get("prop.prop1"));
				console.debug("getting publisher.prop.prop2: " + binding.get("prop.prop2"));
				console.debug("getting publisher.prop.prop2.prop3: " + binding.get("prop.prop2.prop3"));
				binding.bindAll(function(e) {console.debug("custom bindAll: " + e.property + " = " +e.newVal);});
				binding.bind("prop.prop2.prop3", function(e) {console.debug("custom bind prop.prop2.prop3 changed: " + e.newVal);});
			};    						
		
			this.createMySubViews = function() {
				var currentDiv = this.context.element;
				var immediateTextFieldList = dojo.query('#' + this.context.element.id + ' .TextFieldView');
				
				immediateTextFieldList[0].appendChild(document.createTextNode(" Publisher name of the phone book"));
				this.context.createView(immediateTextFieldList[0]);
				
				immediateTextFieldList[1].appendChild(document.createTextNode("  Publish year"));
				this.context.createView(immediateTextFieldList[1]);
							
				// hide last TextFieldView
				immediateTextFieldList[2].style.display = "none";
			}; 

	};
	
    // ButtonView_DeleteContentBox
    dojo.provide("com.ibm.bpm.coach.snapshotId.ButtonView_DeleteContentBox");
	com.ibm.bpm.coach.snapshotId.ButtonView_DeleteContentBox.prototype = new com.ibm.bpm.coach.CoachView;
	com.ibm.bpm.coach.snapshotId.ButtonView_DeleteContentBox.prototype.constructor = com.ibm.bpm.coach.snapshotId.ButtonView_DeleteContentBox;
	com.ibm.bpm.coach.snapshotId.ButtonView_DeleteContentBox = function (element, binding, options, readOnly) {
		com.ibm.bpm.coach.CoachView.apply(this, [element, binding, options, readOnly]);
		
		this.view = function() {
			var bindingObj = this.context.binding;
			var context = this.context;

			this.context.element.getElementsByTagName("input")[0].value = this.context.options._metadata.label;
	    	this.context.element.getElementsByTagName("input")[0].onclick = function(event) {
	    		    		
	    		// dirty way, just want to test if deleteView(contentBoxDivNode) works
	    		var viewScopeToWork = com.ibm.bpm.coach.GlobalAssets.topLevelViewScope["div_23"];
	    		var secondContentBoxNode = document.getElementById("div_23_ContentBox_1");
	    		viewScopeToWork.context.deleteView(secondContentBoxNode);
	    		viewScopeToWork.context.element.removeChild(secondContentBoxNode);
	    	};
		};
	};

    // ButtonView_DeleteOneView
    dojo.provide("com.ibm.bpm.coach.snapshotId.ButtonView_DeleteOneView");
	com.ibm.bpm.coach.snapshotId.ButtonView_DeleteOneView.prototype = new com.ibm.bpm.coach.CoachView;
	com.ibm.bpm.coach.snapshotId.ButtonView_DeleteOneView.prototype.constructor = com.ibm.bpm.coach.snapshotId.ButtonView_DeleteOneView;
	com.ibm.bpm.coach.snapshotId.ButtonView_DeleteOneView = function (element, binding, options, readOnly) {
		com.ibm.bpm.coach.CoachView.apply(this, [element, binding, options, readOnly]);
		
		this.view = function() {

			var bindingObj = this.context.binding;
			var context = this.context;

			this.context.element.getElementsByTagName("input")[0].value = this.context.options._metadata.label;
	    	this.context.element.getElementsByTagName("input")[0].onclick = function(event) {
	    		// dirty way, just want to test if deleteView(contentBoxDivNode) works
	    		var viewScopeToWork = com.ibm.bpm.coach.GlobalAssets.topLevelViewScope["div_23"];
	    		var firstContentBoxNode = document.getElementById("div_23_ContentBox_0");
	    		var firstViewOfFirstContentBoxNode = document.getElementById("div_23_01_0");
	    		viewScopeToWork.context.deleteView(firstViewOfFirstContentBoxNode);
	    		firstContentBoxNode.removeChild(firstViewOfFirstContentBoxNode);
	    	};
		};
	};

	// SectionView
	dojo.provide("com.ibm.bpm.coach.snapshotId.SectionView");
	com.ibm.bpm.coach.snapshotId.SectionView.prototype = new com.ibm.bpm.coach.CoachView;
	com.ibm.bpm.coach.snapshotId.SectionView.prototype.constructor = com.ibm.bpm.coach.snapshotId.SectionView;
	com.ibm.bpm.coach.snapshotId.SectionView = function (element, binding, options, readOnly) {
		com.ibm.bpm.coach.CoachView.apply(this, [element, binding, options, readOnly]);				
	};	
	
    // TableView
	dojo.provide("com.ibm.bpm.coach.snapshotId.TableView");
	com.ibm.bpm.coach.snapshotId. TableView.prototype = new com.ibm.bpm.coach.CoachView;
	com.ibm.bpm.coach.snapshotId. TableView.prototype.constructor = com.ibm.bpm.coach.snapshotId. TableView;
	com.ibm.bpm.coach.snapshotId. TableView = function (element, binding, options, readOnly) {
		com.ibm.bpm.coach.CoachView.apply(this, [element, binding, options, readOnly]);
		
		this.rowTemplate = null;
		this.tableElement = null;
		
		this.load = function() {

			// Register listener for List changes
			this.context.binding.get("value").bindAll(dojo.hitch(this, this.listUpdated));

			this.tableElement = document.createElement("table");
			this.tableElement.setAttribute("style", "width: 60%");

			this.context.element.appendChild(this.tableElement);
			
			var immediateContentBoxList = com.ibm.bpm.coach.shallowQueryByClass(this.context.element, 'ContentBox', true); // dojo.query('> .ContentBox', this.context.element);
			if(immediateContentBoxList.length == 0) {
				// no child
				return;
			}
			// Suppose only one ContentBox under the tableView
			var contentBoxDiv = immediateContentBoxList[0];
			
			if(this.context.binding.get("value") instanceof com.ibm.bpm.coach.List) {
				// need to repeat the contentBox based on the data-binding
				var directSubViewScopes = new Array();
				var immediateSubViewList = com.ibm.bpm.coach.shallowQueryByClass(contentBoxDiv, 'view', true);
				dojo.forEach(immediateSubViewList, function(item, index) {
					// wrap the subView in the ContentBox with "td"
					var tdElement = document.createElement("td");
					tdElement.appendChild(item);
					contentBoxDiv.appendChild(tdElement);
				});				
				
				// save the template in my own viewScope for the future use
				this.context.element.removeChild(contentBoxDiv);
				this.rowTemplate = contentBoxDiv;				
				
				// create table rows
				for(var k=0; k<this.context.binding.get("value").length(); k++) {
					this.createOneTR(k);
				}
			}	
		}
		
		this.createOneTR = function(k) {
			var trElement = document.createElement("tr");
		
			var oneDiv = this.rowTemplate.cloneNode(true);
			trElement.appendChild(oneDiv);
			this.tableElement.appendChild(trElement);
			this.context.createView(oneDiv, k);
		}

		this.view = function() {
			// Override super-class lifeCycle onView method
			// Sample JS code:  Populate the input text by the binding object initial value			
		};

    	this.listUpdated = function(changeEvent) {
			// Override super-class change method
				console.debug("list change detected, object: ", changeEvent.object, 
				"removedFrom: ",changeEvent.removedFrom, 
				"insertedInto: ",changeEvent.insertedInto);
				
			if(changeEvent.removedFrom >= 0) {
	    		var viewScopeToWork = this;
				var immediateContentBoxList = com.ibm.bpm.coach.shallowQueryByClass(this.context.element, 'ContentBox'); //dojo.query('#' + this.context.element.id + ' .ContentBox');
				
	    		var contentBoxNode = immediateContentBoxList[changeEvent.removedFrom];
	    		viewScopeToWork.context.deleteView(contentBoxNode);
	    		// viewScopeToWork is tableView node,  viewScopeToWork.context.element.lastChild is table node, contentBoxNode.parentNode is tr node
	    		viewScopeToWork.context.element.lastChild.removeChild(contentBoxNode.parentNode);
			}
			
			if(changeEvent.insertedInto >= 0) {
				this.createOneTR(changeEvent.insertedInto);
			}			
    	};	        
  	};
  	
  	
  	// ButtonView_AddOneTableRow
    dojo.provide("com.ibm.bpm.coach.snapshotId.ButtonView_AddOneTableRow");
	com.ibm.bpm.coach.snapshotId.ButtonView_AddOneTableRow.prototype = new com.ibm.bpm.coach.CoachView;
	com.ibm.bpm.coach.snapshotId.ButtonView_AddOneTableRow.prototype.constructor = com.ibm.bpm.coach.snapshotId.ButtonView_AddOneTableRow;
	com.ibm.bpm.coach.snapshotId.ButtonView_AddOneTableRow = function (element, binding, options, readOnly) {
		com.ibm.bpm.coach.CoachView.apply(this, [element, binding, options, readOnly]);
		
		this.view = function() {

			var bindingObj = this.context.binding;
			var context = this.context;

			this.context.element.getElementsByTagName("input")[0].value = "Add";
	    	this.context.element.getElementsByTagName("input")[0].onclick = function(event) {	    	
		    	var blankPerson =	{
										name: 		"LastName, FirstName",
										address:	[
													{	street: "",
														city:	"",
														type:	"Home"
													},
													{	street: "",
														city:	"",
														type:	"Business"
													}
												],
										birthdate:	{	day:	"",
													month: "",
													year:	""
												},
										phoneNumber:	""
									}
		    	bindingObj.get("value").add(blankPerson);
	    	};
		};
	};
  	
  	// ButtonView_DeleteOneTableRow
    dojo.provide("com.ibm.bpm.coach.snapshotId.ButtonView_DeleteOneTableRow");
	com.ibm.bpm.coach.snapshotId.ButtonView_DeleteOneTableRow.prototype = new com.ibm.bpm.coach.CoachView;
	com.ibm.bpm.coach.snapshotId.ButtonView_DeleteOneTableRow.prototype.constructor = com.ibm.bpm.coach.snapshotId.ButtonView_DeleteOneTableRow;
	com.ibm.bpm.coach.snapshotId.ButtonView_DeleteOneTableRow = function (element, binding, options, readOnly) {
		com.ibm.bpm.coach.CoachView.apply(this, [element, binding, options, readOnly]);
		
		this.view = function() {

			var bindingObj = this.context.binding;
			var context = this.context;

			context.element.getElementsByTagName("input")[0].value = "Delete";
	    	context.element.getElementsByTagName("input")[0].onclick = function(event) {
	    		
				var parentNode = context.element.parentNode;
				while(!com.ibm.bpm.coach.isContentBox(parentNode)) {					
					parentNode = parentNode.parentNode;
				}
				
				parentNode = parentNode.parentNode;
				while(!com.ibm.bpm.coach.isContentBox(parentNode)) {					
					parentNode = parentNode.parentNode;
				}				
				// now parentNode is ContentBox we need. above steps are kind of hacking
				var contenBoxNode = parentNode;

				while(parentNode.tagName != 'TABLE') {					
					parentNode = parentNode.parentNode;
				}				
				// now parentNode is table Node
				var tableNode = parentNode;
				
				var contentBoxList = com.ibm.bpm.coach.shallowQueryByClass(tableNode, 'ContentBox');
				dojo.forEach(contentBoxList,  function(item, index) {
					if(item.id == contenBoxNode.id) {
	    				bindingObj.get("value").remove(index);
	    				// alert("going to remove " + index + " on " + contenBoxNode.id);
					}
				});
	    	};
		};
	};
	
	
	// GENERATION: View scope class ends here	

</script>

<script type="text/javascript">
	com.ibm.bpm.coach.initData = function() {
		//##DataBinding begin
		//sample object definition
		this.local = {phoneBook: {
				publishData: 	{	year: "2011",
							publisher: "Mellow-Yellow",
							edition: "1.1",
							prop: {prop1: "val1", prop2: {prop3: "val3"}}
					     	},
				person:		[	
							{
								name: 		"Doe, John",
								address:	[
											{	street: "123 Town Street",
												city:	"Peasantville",
												type:	"Home"
											},
											{	street: "456 Baker Street",
												city:	"Peasantville",
												type:	"Business"	
											}
										],
								birthdate:	{	day:	"31",
											month: "January",
											year:	"1921"
										},
								phoneNumber:	"987-654-321"
							},
							{
								name: 		"Doe, Jane",
								address:	[
											{	street: "123 River Road",
												city:	"Peasantville",
												type:	"Home"
											},
											{	street: "456 Market Square",
												city:	"Peasantville",
												type:	"Business"
											}
										],
								birthdate:	{	day:	"1",
											month: "March",
											year:	"1925"
										},
								phoneNumber:	"987-555-5555"
							}
						],
				test:"test1",		
				title:	"People Pages"
			      }
			}; //local definition
			
			this.local.dataObject01 = 'Default value of binding data object 01';
			this.local.dataObject02 = 'Default value of binding data object 02';
			
			//system data
			this.system.user = "Mr. Jones";

		//##DataBinding end (sample data)	
	}; //initData
	
	com.ibm.bpm.coach.initConfig = function() {
			/*
			 * options/configuration data 
			 * Keyed by the div id for the view
			*/
			var viewId = "div_01";
            this.options[viewId] = {refOption: com.ibm.bpm.coach.resolveOptionValue.call(this, viewId, "refOption", "local.dataObject01"),
                         valOption: "test",
                         _metadata: {label: "",
                                   help: "",
                                   id: "",
                                   visibility: com.ibm.bpm.coach.resolveOptionValue.call(this, viewId, "_metadata.visibility", "local.dataObject02"),
                                   className: "",
                                   attributes: [{attr1: ""}, {attr2: ""}]
                                  }
                       };
			viewId = "div_02";
            this.options[viewId] = {refOption: com.ibm.bpm.coach.resolveOptionValue.call(this, viewId, "refOption", "local.dataObject01"),
                         valOption: "test",
                         _metadata: {label: "",
                                   help: "",
                                   id: "",
                                   visibility: com.ibm.bpm.coach.resolveOptionValue.call(this, viewId, "_metadata.visibility", "local.dataObject02"),
                                   className: "",
                                   attributes: [{attr1: ""}, {attr2: ""}]
                                  }
                       };
			viewId = "div_03";
            this.options[viewId] = {refOption: com.ibm.bpm.coach.resolveOptionValue.call(this, viewId, "refOption", "local.dataObject01"),
                         valOption: "test",
                         _metadata: {label: "Submit",
                                   help: "",
                                   id: "",
                                   visibility: com.ibm.bpm.coach.resolveOptionValue.call(this, viewId, "_metadata.visibility", "local.dataObject02"),
                                   className: "",
                                   attributes: [{attr1: ""}, {attr2: ""}]
                                  }
                       };
			viewId = "div_04";
            this.options[viewId] = {refOption: com.ibm.bpm.coach.resolveOptionValue.call(this, viewId, "refOption", "local.dataObject01"),
                         valOption: "test",
                         _metadata: {label: "",
                                   help: "",
                                   id: "",
                                   visibility: com.ibm.bpm.coach.resolveOptionValue.call(this, viewId, "_metadata.visibility", "local.dataObject02"),
                                   className: "",
                                   attributes: [{attr1: ""}, {attr2: ""}]
                                  }
                       };
			viewId = "div_05";
            this.options[viewId] = {refOption: com.ibm.bpm.coach.resolveOptionValue.call(this, viewId, "refOption", "local.dataObject01"),
                         valOption: "test",
                         _metadata: {label: "",
                                   help: "",
                                   id: "",
                                   visibility: com.ibm.bpm.coach.resolveOptionValue.call(this, viewId, "_metadata.visibility", "local.dataObject02"),
                                   className: "",
                                   attributes: [{attr1: ""}, {attr2: ""}]
                                  }
                       };
			viewId = "div_06";
            this.options[viewId] = {refOption: com.ibm.bpm.coach.resolveOptionValue.call(this, viewId, "refOption", "local.dataObject01"),
                         valOption: "test",
                         _metadata: {label: "Submit",
                                   help: "",
                                   id: "",
                                   visibility: com.ibm.bpm.coach.resolveOptionValue.call(this, viewId, "_metadata.visibility", "local.dataObject02"),
                                   className: "",
                                   attributes: [{attr1: ""}, {attr2: ""}]
                                  }
                       };
			viewId = "div_24";
            this.options[viewId] = {refOption: com.ibm.bpm.coach.resolveOptionValue.call(this, viewId, "refOption", "local.dataObject01"),
                         valOption: "test",
                         _metadata: {label: "Delete last contentBox",
                                   help: "",
                                   id: "",
                                   visibility: com.ibm.bpm.coach.resolveOptionValue.call(this, viewId, "_metadata.visibility", "local.dataObject02"),
                                   className: "",
                                   attributes: [{attr1: ""}, {attr2: ""}]
                                  }
                       };
			viewId = "div_25";
            this.options[viewId] = {refOption: com.ibm.bpm.coach.resolveOptionValue.call(this, viewId, "refOption", "local.dataObject01"),
                         valOption: "test",
                         _metadata: {label: "Delete first subView of first contentBox",
                                   help: "",
                                   id: "",
                                   visibility: com.ibm.bpm.coach.resolveOptionValue.call(this, viewId, "_metadata.visibility", "local.dataObject02"),
                                   className: "",
                                   attributes: [{attr1: ""}, {attr2: ""}]
                                  }
                       };
	};
	
</script>
</head>
<body>
	<div class="body" id="mainBody">
	    <h1>Welcome to Coach NG POC!!!</h1>
	    <br/>
	    <h2>Some simple views </h2>
	    First simple view of type TextFieldView
	    <!-- Generation: view starts -->
		<div id="div_01" class="TextFieldView view topLevel" data-type="com.ibm.bpm.coach.snapshotId.TextFieldView" data-binding="local.dataObject01" data-viewid="view01">
			<div id="div_01_01" class="customHTML" data-binding="">
				<input type="text" name="inputName" size='100' value='default'/>
			</div>
		</div>
		<!-- Generation: view ends -->
		
	    <br/>
	    Second simple view of type TextFieldView
	   	<!-- Generation: view starts -->
	    <div id="div_02" class="TextFieldView view topLevel" data-type="com.ibm.bpm.coach.snapshotId.TextFieldView" data-binding="local.dataObject02" data-viewid="view02">
	    	<div id="div_02_01" class="customHTML" data-binding="">
				<input type="text" name="inputName" size='100' value='default'/>
			</div>
		</div>
		<!-- Generation: view ends -->
		
	    <br/>
	    Third simple view of type ButtonView
		<!-- Generation: view starts -->
	    <div id="div_03" class="ButtonView view topLevel" data-type="com.ibm.bpm.coach.snapshotId.ButtonView" data-binding="" data-viewid="view03">
	    	<div id="div_03_01" class="customHTML" data-binding="">
				<input type="button" name="btnName" value="default"></input>
			</div>
		</div>
		<!-- Generation: view ends -->
		
<!-- //##DataBinding start -->
	    <br/>
	    <h2>PhoneBook - More on data binding </h2>
	    <!-- Generation: view starts -->
	    <div id="div_07" class="LabelView view topLevel" data-type="com.ibm.bpm.coach.snapshotId.LabelView" data-binding="local.phoneBook.title" data-viewid="view05">
			<div id="div_07_01" class="customHTML" data-binding="">
			</div>
		</div>
	    <!-- Generation: view ends -->
	    <!-- Generation: view starts -->
	    <div id="div_08" class="LabelView view topLevel" data-type="com.ibm.bpm.coach.snapshotId.LabelView" data-binding="local.phoneBook.publishData.edition" data-viewid="view06a">
			<div id="div_08_01" class="customHTML" data-binding="">
			</div>		
		</div>
	    <!-- Generation: view ends -->
	    <!-- Generation: view starts -->
	    <div id="div_09" class="LabelView view topLevel" data-type="com.ibm.bpm.coach.snapshotId.LabelView" data-binding="system.user" data-viewid="view06b">
			<div id="div_09_01" class="customHTML" data-binding="">
			</div>		
		</div>
	    <!-- Generation: view ends -->
	    <br/>
	    <!-- Generation: view starts -->
	    <div id="div_10" class="TextFieldView view topLevel" data-type="com.ibm.bpm.coach.snapshotId.TextFieldView" data-binding="local.phoneBook.title" data-viewid="view07">
			<div id="div_10_01" class="customHTML" data-binding="">
				<input type="text" name="inputName" size='100' value='default' />
			</div>
		</div>

	    <br/>
		    
		<h3>Sample list View, view managed, with dynamic update: add, remove, update data from the data list</h3>
		<h4>Sample list 1<h4>
		<div id="div_ListViewString" class="ListViewString view topLevel" data-type="com.ibm.bpm.coach.snapshotId.ListViewString" data-binding="local.phoneBook.person[]" data-config="" data-viewid="view_ListViewString">
		    
		    <input type="button" name="btnName" value="Add"></input>
					&nbsp;&nbsp;	&nbsp;&nbsp; &nbsp;&nbsp;
			<input  name="btnName" size='1' ></input>
			<input type="button" name="btnName" value="Delete"></input>
			
			&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
			<input  name="btnName" size='1' ></input>
			<input type="button" name="btnName" value="Update"></input>
			<br/>	
			
			<input type="button" name="btnName" value="Reset List"></input>
						
			<div id="div_ListViewString_contentBox" class="ContentBox" data-view-managed=true>
				<div id="div_ListViewString_1" class="TextFieldView view" data-type="com.ibm.bpm.coach.snapshotId.TextFieldView" data-binding="local.phoneBook.person[].name" data-config="" data-viewid="view_ListViewString_01">
					<input type="text" name="phone" size='100' value='default'/>
				</div>		   		
			</div>
	    </div>

		<!-- Generation: view ends -->
	    <br/>
	    
	    <br/>
	    <h2>Build complex views using ContentBox </h2>
	    <h3>Framework managed, non-repeat </h3>
	    <!-- Generation: view starts -->
	    <div id="div_20" class="PublisherView view topLevel" data-type="com.ibm.bpm.coach.snapshotId.PublisherView" data-binding="local.phoneBook.publishData" data-viewid="view_20">
			<div id="div_20_contentBox" class="ContentBox" data-view-managed=false>
			    <div id="div_20_01" class="TextFieldView view" data-type="com.ibm.bpm.coach.snapshotId.TextFieldView" data-binding="local.phoneBook.publishData.publisher" data-viewid="view_20_01">
					<div id="div_20_01_01" class="customHTML" data-binding="">
						<input type="text" name="inputName" size='100' value='default' />
					</div>
				</div>
			    <br/>
			    <div id="div_20_02" class="TextFieldView view" data-type="com.ibm.bpm.coach.snapshotId.TextFieldView" data-binding="local.phoneBook.publishData.year" data-viewid="view_20_02">
					<div id="div_20_02_01" class="customHTML" data-binding="">
						<input type="text" name="inputName" size='100' value='default' />
					</div>
				</div>
			    <br/>
			    <div id="div_20_03" class="TextFieldView view" data-type="com.ibm.bpm.coach.snapshotId.TextFieldView" data-binding="local.phoneBook.publishData.edition" data-viewid="view_20_03">
					<div id="div_20_03_01" class="customHTML" data-binding="">
						<input type="text" name="inputName" size='100' value='default' />
					</div>
				</div>
			    <br/>
			</div>
		</div>
		<!-- Generation: view ends -->

	    <br/>
	    <h3>View managed, non-repeat. View's markup is exactly same as above example.<br/>
	    	However view decides to add description on each field. This also shows how to call createView(domNode) </h3>	    
		<!-- Generation: view starts -->
	    <div id="div_21" class="PublisherView_SM view topLevel" data-type="com.ibm.bpm.coach.snapshotId.PublisherView_SM" data-binding="local.phoneBook.publishData" data-viewid="view_21">
			<div id="div_21_contentBox" class="ContentBox" data-view-managed=true>
			    <div id="div_21_01" class="TextFieldView view" data-type="com.ibm.bpm.coach.snapshotId.TextFieldView" data-binding="local.phoneBook.publishData.publisher" data-viewid="view_21_01">
					<div id="div_21_01_01" class="customHTML" data-binding="">
						<input type="text" name="inputName" size='100' value='default' />
					</div>
				</div>
			    <br/>
			    <div id="div_21_02" class="TextFieldView view" data-type="com.ibm.bpm.coach.snapshotId.TextFieldView" data-binding="local.phoneBook.publishData.year" data-viewid="view_21_02">
					<div id="div_21_02_01" class="customHTML" data-binding="">
						<input type="text" name="inputName" size='100' value='default' />
					</div>
				</div>
			    <br/>
			    <div id="div_21_03" class="TextFieldView view" data-type="com.ibm.bpm.coach.snapshotId.TextFieldView" data-binding="local.phoneBook.publishData.edition" data-viewid="view_21_03">
					<div id="div_21_03_01" class="customHTML" data-binding="">
						<input type="text" name="inputName" size='100' value='default' />
					</div>
				</div>
			    <br/>
			</div>
		</div>
		<!-- Generation: view ends -->	

	    <h3>Framework managed, repeat </h3>	    
	    <!-- Generation: view starts -->
	    <div id="div_22" class="ListView09 view topLevel" data-type="com.ibm.bpm.coach.snapshotId.ListView09" data-binding="local.phoneBook.person[]" data-viewid="view_22">
			<div id="div_22_ContentBox" class="ContentBox" data-view-managed=false>
			    <div id="div_22_01" class="TextFieldView view" data-type="com.ibm.bpm.coach.snapshotId.TextFieldView" data-binding="local.phoneBook.title" data-viewid="view_22_01">
					<div id="div_22_01_01" class="customHTML" data-binding="">
						<input type="text" name="inputName" size='100' value='default'/>
					</div>
				</div>
			    <div id="div_22_03" class="PersonView view" data-type="com.ibm.bpm.coach.snapshotId.PersonView" data-binding="local.phoneBook.person[]" data-viewid="view_22_03">
					<div id="div_22_03_ContentBox" class="ContentBox" data-repeat=false data-view-managed=false>
					    <div id="div_22_03_01" class="TextFieldView view" data-type="com.ibm.bpm.coach.snapshotId.TextFieldView" data-binding="local.phoneBook.person[].name" data-viewid="view_22_03_01">
							<div id="div_22_03_01_01" class="customHTML" data-binding="">
								<input type="text" name="inputName" size='100' value='default'/>
							</div>
						</div>
					    <div id="div_22_03_02" class="TextFieldView view" data-type="com.ibm.bpm.coach.snapshotId.TextFieldView" data-binding="local.phoneBook.person[].phoneNumber" data-viewid="view_22_03_02">
							<div id="div_22_03_02_01" class="customHTML" data-binding="">
								<input type="text" name="inputName" size='100' value='default'/>
							</div>
						</div>
					</div>
				</div>
			    <div id="div_22_04" class="TextFieldView view" data-type="com.ibm.bpm.coach.snapshotId.TextFieldView" data-binding="local.phoneBook.person[].birthdate.year" data-viewid="view_22_04">
					<div id="div_22_04_01" class="customHTML" data-binding="">
						<input type="text" name="inputName" size='100' value='default'/>
					</div>
				</div>
				<br/>
			</div>
	    </div>
		<!-- Generation: view ends -->
		
	    <br/>
	    <h3>View managed, repeat. View's markup is exactly same as above example<br/>
	    	However view decides to add a counter for each ContentBox. <br/>
	    	This also shows how to call createView(domNode, index), deleteView(contentBoxDomNode) and deleteView(viewDomNode)</h3>	    
	    <!-- Generation: view starts -->
	    <div id="div_23" class="ListView10 view topLevel" data-type="com.ibm.bpm.coach.snapshotId.ListView10" data-binding="local.phoneBook.person[]" data-viewid="view09">
			<div id="div_23_ContentBox" class="ContentBox" data-view-managed=true>
			    <div id="div_23_01" class="TextFieldView view" data-type="com.ibm.bpm.coach.snapshotId.TextFieldView" data-binding="local.phoneBook.title" data-viewid="view_23_01">
					<div id="div_23_01_01" class="customHTML" data-binding="">
						<input type="text" name="inputName" size='100' value='default'/>
					</div>
				</div>
			    <div id="div_23_03" class="PersonView view" data-type="com.ibm.bpm.coach.snapshotId.PersonView" data-binding="local.phoneBook.person[]" data-viewid="view_23_03">
					<div id="div_23_03_ContentBox" class="ContentBox" data-repeat=false data-view-managed=false>
					    <div id="div_23_03_01" class="TextFieldView view" data-type="com.ibm.bpm.coach.snapshotId.TextFieldView" data-binding="local.phoneBook.person[].name" data-viewid="view_23_03_01">
							<div id="div_23_01_01" class="customHTML" data-binding="">
								<input type="text" name="inputName" size='100' value='default'/>
							</div>
						</div>
					    <div id="div_23_03_02" class="TextFieldView view" data-type="com.ibm.bpm.coach.snapshotId.TextFieldView" data-binding="local.phoneBook.person[].phoneNumber" data-viewid="view_23_03_02">
							<div id="div_23_03_02_01" class="customHTML" data-binding="">
								<input type="text" name="inputName" size='100' value='default'/>
							</div>
						</div>
					</div>
				</div>
			    <div id="div_23_04" class="TextFieldView view" data-type="com.ibm.bpm.coach.snapshotId.TextFieldView" data-binding="local.phoneBook.person[].birthdate.year" data-viewid="view_23_04">
					<div id="div_23_04_01" class="customHTML" data-binding="">
						<input type="text" name="inputName" size='100' value='default'/>
					</div>
				</div>
				<br/>
			</div>
	    </div>
	    <div id="div_24" class="ButtonView_DeleteContentBox view topLevel" data-type="com.ibm.bpm.coach.snapshotId.ButtonView_DeleteContentBox" data-binding="" data-viewid="view_24">
			<input type="button" name="btnName" value="default"></input>
		</div>
	    <div id="div_25" class="ButtonView_DeleteOneView view topLevel" data-type="com.ibm.bpm.coach.snapshotId.ButtonView_DeleteOneView" data-binding="" data-viewid="view_25">
			<input type="button" name="btnName" value="default"></input>
		</div>
		<!-- Generation: view ends -->
		
	    
	    <h3>Section - Framework Managed </h3>
	    <!-- Generation: view starts -->
	    <div id="div_30" class="SectionView view topLevel" data-type="com.ibm.bpm.coach.snapshotId.SectionView" data-binding="local.phoneBook.publishData" data-viewid="view_30">
			<div id="div_30_contentBox" class="ContentBox" data-view-managed=false>
			    <div id="div_30_01" class="TextFieldView view" data-type="com.ibm.bpm.coach.snapshotId.TextFieldView" data-binding="local.phoneBook.publishData.publisher" data-viewid="view_30_01">
					<div id="div_30_01_01" class="customHTML" data-binding="">
						<input type="text" name="inputName" size='100' value='default' />
					</div>
				</div>
			    <br/>
			    <div id="div_30_02" class="TextFieldView view" data-type="com.ibm.bpm.coach.snapshotId.TextFieldView" data-binding="local.phoneBook.publishData.year" data-viewid="view_30_02">
					<div id="div_30_02_01" class="customHTML" data-binding="">
						<input type="text" name="inputName" size='100' value='default' />
					</div>
				</div>
			    <br/>
			    <div id="div_30_03" class="TextFieldView view" data-type="com.ibm.bpm.coach.snapshotId.TextFieldView" data-binding="local.phoneBook.publishData.edition" data-viewid="view_30_03">
					<div id="div_30_03_01" class="customHTML" data-binding="">
						<input type="text" name="inputName" size='100' value='default' />
					</div>
				</div>
			    <br/>
			</div>
		</div>
		<!-- Generation: view ends -->
	    
	    <h3>Repeatable Section - Framework managed</h3>	
	    <!-- Generation: view starts -->
	    <div id="div_31" class="SectionView view topLevel" data-type="com.ibm.bpm.coach.snapshotId.SectionView" data-binding="local.phoneBook.person[]" data-viewid="view_31">
			<div id="div_31_ContentBox" class="ContentBox" data-view-managed=false>
			    <div id="div_31_01" class="TextFieldView view" data-type="com.ibm.bpm.coach.snapshotId.TextFieldView" data-binding="local.phoneBook.person[].name" data-viewid="view_31_01">
					<div id="div_31_01_01" class="customHTML" data-binding="">
						<input type="text" name="inputName" size='100' value='default'/>
					</div>
				</div>
			    <div id="div_31_04" class="TextFieldView view" data-type="com.ibm.bpm.coach.snapshotId.TextFieldView" data-binding="local.phoneBook.person[].phoneNumber" data-viewid="view_31_04">
					<div id="div_31_04_01" class="customHTML" data-binding="">
						<input type="text" name="inputName" size='100' value='default'/>
					</div>
				</div>
				<br/>
			</div>
	    </div>
		<!-- Generation: view ends -->
	    <br/>
	    <h3>Table - View managed</h3>
	    <!-- Generation: view starts -->
	    <div id="div_26" class="TableView view topLevel" data-type="com.ibm.bpm.coach.snapshotId.TableView" data-binding="local.phoneBook.person[]" data-viewid="view_26">
			<div id="div_26_ContentBox" class="ContentBox" data-view-managed=true>
			    <div id="div_26_01" class="TextFieldView view" data-type="com.ibm.bpm.coach.snapshotId.TextFieldView" data-binding="local.phoneBook.person[].name" data-viewid="view_26_01">
					<div id="div_26_01_01" class="customHTML" data-binding="">
						<input type="text" name="inputName" size='20' value='default'/>
					</div>
				</div>
			    <div id="div_26_02" class="TextFieldView view" data-type="com.ibm.bpm.coach.snapshotId.TextFieldView" data-binding="local.phoneBook.person[].phoneNumber" data-viewid="view_26_02">
					<div id="div_26_02_01" class="customHTML" data-binding="">
						<input type="text" name="inputName" size='20' value='default'/>
					</div>
				</div>
			    <div id="div_26_03" class="SectionView view" data-type="com.ibm.bpm.coach.snapshotId.SectionView" data-binding="" data-viewid="view_26_03">
					<div id="div_26_03_ContentBox" class="ContentBox" data-view-managed=false>
					    <div id="div_26_03_01" class="TextFieldView view" data-type="com.ibm.bpm.coach.snapshotId.TextFieldView" data-binding="local.phoneBook.person[].birthdate.month" data-viewid="view_26_03_01">
							<div id="div_26_01_01" class="customHTML" data-binding="">
								<input type="text" name="inputName" size='10' value='default'/>
							</div>
						</div>
					    <div id="div_26_03_02" class="TextFieldView view" data-type="com.ibm.bpm.coach.snapshotId.TextFieldView" data-binding="local.phoneBook.person[].birthdate.day" data-viewid="view_26_03_02">
							<div id="div_26_03_02_01" class="customHTML" data-binding="">
								<input type="text" name="inputName" size='10' value='default'/>
							</div>
						</div>
					    <div id="div_26_03_03" class="TextFieldView view" data-type="com.ibm.bpm.coach.snapshotId.TextFieldView" data-binding="local.phoneBook.person[].birthdate.year" data-viewid="view_26_03_03">
							<div id="div_26_03_03_01" class="customHTML" data-binding="">
								<input type="text" name="inputName" size='10' value='default'/>
							</div>
						</div>
					</div>
				</div>
				<!--
				-->
			    <div id="div_26_04" class="TableView view" data-type="com.ibm.bpm.coach.snapshotId.TableView" data-binding="local.phoneBook.person[].address[]" data-viewid="view_26_04">
					<div  class="ContentBox" data-view-managed=true>
					    <div id="div_26_04_01" class="TextFieldView view" data-type="com.ibm.bpm.coach.snapshotId.TextFieldView" data-binding="local.phoneBook.person[].address[].street" data-viewid="view_26_04_01">
							<div id="div_26_04_01_01" class="customHTML" data-binding="">
								<input type="text" name="inputName" size='20' value='default'/>
							</div>
						</div>
					    <div id="div_26_04_02" class="TextFieldView view" data-type="com.ibm.bpm.coach.snapshotId.TextFieldView" data-binding="local.phoneBook.person[].address[].city" data-viewid="view_26_04_02">
							<div id="div_26_04_02_01" class="customHTML" data-binding="">
								<input type="text" name="inputName" size='10' value='default'/>
							</div>
						</div>
					    <div id="div_26_04_03" class="TextFieldView view" data-type="com.ibm.bpm.coach.snapshotId.TextFieldView" data-binding="local.phoneBook.person[].address[].type" data-viewid="view_26_04_03">
							<div id="div_26_04_03_01" class="customHTML" data-binding="">
								<input type="text" name="inputName" size='10' value='default'/>
							</div>
						</div>
					</div>
				</div>
			    <div id="div_26_05" class="SectionView view" data-type="com.ibm.bpm.coach.snapshotId.SectionView" data-binding="" data-viewid="view_26_05">
					<div id="div_26_05_ContentBox" class="ContentBox" data-view-managed=false>
					    <div id="div_26_05_01" class="ButtonView_DeleteOneTableRow view" data-type="com.ibm.bpm.coach.snapshotId.ButtonView_DeleteOneTableRow" data-binding="local.phoneBook.person" data-viewid="view_26_05_01">
							<div id="div_26_05_01_1" class="customHTML" data-binding="">
								<input type="button" name="btnName" value='default'/>
							</div>
						</div>
					    <div id="div_26_05_02" class="ButtonView_AddOneTableRow view" data-type="com.ibm.bpm.coach.snapshotId.ButtonView_AddOneTableRow" data-binding="local.phoneBook.person" data-viewid="view_26_05_02">
							<div id="div_26_05_02_1" class="customHTML" data-binding="">
								<input type="button" name="btnName" value='default'/>
							</div>
						</div>
					</div>
				</div>
		    </div>
		</div>
		
	    <br/><br/><br/><br/><br/><br/><br/><br/><br/>	    
</body>