<%@ page language="java" pageEncoding="UTF-8" contentType="text/html; charset=UTF-8"%>
<%@ include file="/html/msgs-init.jsp" %>
<%--
-@+@-
<pageInfo>
<schema>
<simpleType name="time">
  <restriction base="Time">
    <format value="HH:mm"/>
  </restriction>
</simpleType>
<simpleType name="string">
  <restriction base="String">
  </restriction>
</simpleType>
<simpleType name="integer">
  <restriction base="Integer">
  </restriction>
</simpleType>
</schema>
<fields>
<field name="zName" type="string" required="true">
  <description>Name</description>
</field>
<field name="zTimezone" type="string" required="true">
  <description>Timezone</description>
</field>
<field name="zStartWork" type="time" required="false">
  <description>Start Work</description>
</field>
<field name="zEndWork" type="time" required="false">
  <description>End Work</description>
</field>
<field name="zPrioUnit" type="integer" required="true">
  <description>Increment Type</description>
</field>
<field name="zPrioValue" type="integer" required="true">
  <description>Increment Quantity</description>
</field>
<field name="zPrioTime" type="time" required="false">
  <description>Time Due</description>
</field>
</fields>
</pageInfo>
-@+@-
--%>
<%--Created By: Lombardi Software
Last Modified: 11-25-02
Description: Console Process for maintaining Calendars.--%>
<%@ include file="/html/common/prolog.jsp" %>
<%@ include file="/html/common/javascript.jsp" %>
<%@ include file="/html/common/validation.jsp" %>
<HTML>
<lsw:SetContext zPath="CaptureAdditionalParameters">
<HEAD>
<title><bean:message key="TWC_Calendar.title" /></title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<script language="JavaScript">

var whitespace = /^\s*$/;

// The current System Default Calendar
var theDefault = -1;

<%-- creates an array entry for arrayAll containing all information for each Calendar --%>
function ListEntry(id,name,tz,startWork,endWork,weekend,holiday,prioUnit,prioValue,prioTime,sysdef) {
	this.id =  id;
	this.name = name;
	this.tz = tz;
	this.startWork = (whitespace.test(startWork) || startWork == undefined ? "" : startWork.substring(0,2) + ":" + startWork.substring(2,4));
	this.endWork = (whitespace.test(endWork) || endWork == undefined ? "" : endWork.substring(0,2) + ":" + endWork.substring(2,4));
	this.weekend = weekend;
	this.holiday = holiday;
	this.prioUnit = prioUnit;
	this.prioValue = prioValue;
	this.prioTime = (whitespace.test(prioTime) || prioTime == undefined ? "" : prioTime.substring(0,2) + ":" + prioTime.substring(2,4));
	this.sysdef = sysdef;
	if (sysdef) theDefault = id;
}

function compareEntry(a, b) {
 var na = a.name.toLowerCase();
 var nb = b.name.toLowerCase();
 if (na < nb)
  return -1;
 else if (na > nb)
  return 1
 else
  return 0;
}

var arrayAll = new Array();
<%--insert arrayAll function calls as generated by resultSetToArray.xsl--%>
<lsw:SetContext zPath="./variable[@name='tw_local_Array']"><lsw:String zPath="./initialValue"/></lsw:SetContext>
arrayAll = arrayAll.sort(compareEntry);

function changeStatus(obj){
  if (obj.selectedIndex > -1) {
	if(obj.options[obj.selectedIndex].value >= 3) {
	  document.frm.zPrioTime.readOnly = true;
	  document.frm.zPrioTime.style.backgroundColor = "silver" ;
	  document.frm.zPrioTime.value = "";
	}
	if(obj.options[obj.selectedIndex].value <= 2) {
	  document.frm.zPrioTime.readOnly = false;
	  document.frm.zPrioTime.style.backgroundColor = "white" ;
	  var o = document.frm.zCalendarList;
	  if (o.selectedIndex < 0) {
	  	document.frm.zPrioTime.value = "17:00";
	  }
	}
  }
}

function setupCombo(obj, value, defaultIdx) {
	obj.selectedIndex = (defaultIdx == null ? -1 : defaultIdx);
	for(i = (obj.options.length - 1); i >= 0; i--) {
	  if (obj.options[i].value == value)
		 obj.options[i].selected = true;
	}
}

function setButtonState(button, isSystem) {

	if (button == "Update") {
	  document.frm.updateB.disabled = false;
	} else {
	  document.frm.updateB.disabled = true;
	}
	document.frm.ClearB.disabled = false;
}

<%--cycles through arrayAll and updates the details section of form with values for selected Calendar--%>
function doFillDetails(obj) {
	var id = 0;
	if (obj != null) {
  	  id = obj.options[obj.selectedIndex].value;;
	  for(i = 0; i < arrayAll.length; i++) {
		var flt = arrayAll[i];
		if (flt.id == id) {
		  document.frm.tw_local_TWC_Cal_ID.value = flt.id;
		  document.frm.zName.value = flt.name;
		  setupCombo(document.frm.zTimezone, flt.tz);
		  document.frm.zStartWork.value = flt.startWork;
		  document.frm.zEndWork.value = flt.endWork;
		  document.frm.zWeekend.value = flt.weekend;
		  document.frm.zHoliday.value = flt.holiday;
		  setupCombo(document.frm.zPrioUnit, flt.prioUnit);
		  document.frm.zPrioValue.value = flt.prioValue;
		  document.frm.zPrioTime.value = flt.prioTime;
		  document.frm.zIsDefault.checked = flt.sysdef;
		  if (flt.sysdef) {
			document.frm.zIsDefault.disabled = true;
			document.frm.zIsDefault.checked = true;
		  } else {
			document.frm.zIsDefault.disabled = false;
			document.frm.zIsDefault.checked = false;
		  }
		  clearErrorMsg();
		  setButtonState("Update", flt.sysdef);
		  changeStatus(document.frm.zPrioUnit);
		  document.frm.zName.focus();
		  break;
		}
	  }
	}
}

function setFields() {
	document.frm.tw_local_TWC_Cal_Name.value = document.frm.zName.value;
	document.frm.tw_local_TWC_Cal_TZ.value = document.frm.zTimezone.value;
	document.frm.tw_local_TWC_Cal_StartWork.value = document.frm.zStartWork.value;
	document.frm.tw_local_TWC_Cal_EndWork.value = document.frm.zEndWork.value;
	document.frm.tw_local_TWC_Cal_Weekend.value = document.frm.zWeekend.value;
	document.frm.tw_local_TWC_Cal_Holiday.value = document.frm.zHoliday.value;
	document.frm.tw_local_TWC_Cal_PrioUnit.value = document.frm.zPrioUnit.value;
	document.frm.tw_local_TWC_Cal_PrioValue.value = document.frm.zPrioValue.value;
	document.frm.tw_local_TWC_Cal_PrioTime.value = document.frm.zPrioTime.value;
	document.frm.tw_local_TWC_Cal_SysDef.value = (document.frm.zIsDefault.checked ? "T" : "F");
	document.frm.tw_local_TWC_Cal_OldSysDef.value = theDefault;
}

function doAdd() {
	document.frm.tw_local_TWC_btn.value = "Add";
	setFields();
}

function doDelete() {
	if (confirm("Do you really want to delete this item ?")){
	  document.frm.tw_local_TWC_Cal_Name.value = document.frm.zName.value;
	  document.frm.tw_local_TWC_btn.value = "Delete";
	  return true;
	} else {
	  return false;
	}
}

<%--passes all fields to Teamworks for update statement and submits for further processing. Does not differentiate between changed and unchanged fields--%>
function doUpdate() {
	document.frm.tw_local_TWC_btn.value = "Update";
	setFields();
}

<%--clears error field when clear button is pressed and calls doClean--%>
function doClear() {
	clearErrorMsg();
	doClean();
}

<%--resets all fields in details section to blank status--%>
function doClean() {
	document.frm.zName.value= "";
	document.frm.zStartWork.value= "";
	document.frm.zEndWork.value= "";
	document.frm.zWeekend.value= "";
	document.frm.zHoliday.value= "";
	document.frm.zPrioValue.value= "";
	document.frm.zPrioTime.value= "17:00";
	document.frm.ClearB.disabled = false;
	document.frm.updateB.disabled = true;
	document.frm.zName.focus();
	document.frm.zTimezone.selectedIndex = -1;
	document.frm.zPrioUnit.selectedIndex = 0;
	document.frm.zIsDefault.checked = false;
	document.frm.zIsDefault.disabled = false;
	document.frm.zCalendarList.selectedIndex = -1;
}

function doOnLoad() {

	doClean();

	if (document.frm.tw_local_TWC_Error.value == "F") {
		document.frm.zName.focus();
	} else {
		if (document.frm.tw_local_TWC_btn.value == "Update")	document.frm.zCalendarList.value = document.frm.tw_local_TWC_Cal_ID.value;
		if (document.frm.tw_local_TWC_Cal_Name.value != "undefined") document.frm.zName.value = document.frm.tw_local_TWC_Cal_Name.value;
		setupCombo(document.frm.zTimezone, document.frm.tw_local_TWC_Cal_TZ.value);
		if (document.frm.tw_local_TWC_Cal_StartWork.value != "undefined") document.frm.zStartWork.value = document.frm.tw_local_TWC_Cal_StartWork.value;
		if (document.frm.tw_local_TWC_Cal_EndWork.value != "undefined") document.frm.zEndWork.value = document.frm.tw_local_TWC_Cal_EndWork.value;
		if (document.frm.tw_local_TWC_Cal_Weekend.value != "undefined") document.frm.zWeekend.value = document.frm.tw_local_TWC_Cal_Weekend.value;
		if (document.frm.tw_local_TWC_Cal_Holiday.value != "undefined") document.frm.zHoliday.value = document.frm.tw_local_TWC_Cal_Holiday.value;
		setupCombo(document.frm.zPrioUnit, document.frm.tw_local_TWC_Cal_PrioUnit.value, 0);
		if (document.frm.tw_local_TWC_Cal_PrioValue.value != "undefined") document.frm.zPrioValue.value = document.frm.tw_local_TWC_Cal_PrioValue.value;
		if (document.frm.tw_local_TWC_Cal_PrioTime.value != "undefined") document.frm.zPrioTime.value = document.frm.tw_local_TWC_Cal_PrioTime.value;
		changeStatus(document.frm.zPrioUnit);
		if (document.frm.tw_local_TWC_Cal_SysDef.value != "undefined") document.frm.zIsDefault.checked = (document.frm.tw_local_TWC_Cal_SysDef.value == "T" ? true : false);
		if (document.frm.tw_local_TWC_Error.value == "Name") document.frm.zName.focus();
		if (document.frm.tw_local_TWC_Error.value == "TZ") document.frm.zTimezone.focus();
		setButtonState(document.frm.tw_local_TWC_btn.value, document.frm.zIsDefault.checked);
	}
}

function doSubmit() {
  return vldForm(document.frm);
}

</script>
</head>
<LINK REL="stylesheet" HREF="<%= com.lombardisoftware.core.PortalSkinUtilities.getPortalSkinPath(request) %>/tw_console.css" TYPE="text/css">
<body class="cswelcomebody" onLoad="doOnLoad()">
<table width="100%" valign="top" cellpadding="2" cellspacing="0" border="0" style="margin-top:0px">
<tr><td id="content"><div class="heading"><h1><bean:message key="TWC_Calendar.desc" /></h1></div></td></tr>
</table>
<table style="margin:0" width="100%">
<FORM name="frm" ACTION="cap.lsw" METHOD=POST onSubmit="return doSubmit()">
<%@ include file="/html/common/stdFrmHeader.jsp" %>
<lsw:SetContext zPath="./variable[@name='tw_local_TWC_btn']"><input type="hidden" name="tw_local_TWC_btn" value="<lsw:String zPath='./initialValue'/>"/></lsw:SetContext>
<lsw:SetContext zPath="./variable[@name='tw_local_TWC_Cal_ID']"><input type="hidden" name="tw_local_TWC_Cal_ID" value="<lsw:String zPath='./initialValue'/>"/></lsw:SetContext>
<lsw:SetContext zPath="./variable[@name='tw_local_TWC_Cal_Name']"><input type="hidden" name="tw_local_TWC_Cal_Name" value="<lsw:String zPath='./initialValue'/>"/></lsw:SetContext>
<lsw:SetContext zPath="./variable[@name='tw_local_TWC_Cal_TZ']"><input type="hidden" name="tw_local_TWC_Cal_TZ" value="<lsw:String zPath='./initialValue'/>"/></lsw:SetContext>
<lsw:SetContext zPath="./variable[@name='tw_local_TWC_Cal_StartWork']"><input type="hidden" name="tw_local_TWC_Cal_StartWork" value="<lsw:String zPath='./initialValue'/>"/></lsw:SetContext>
<lsw:SetContext zPath="./variable[@name='tw_local_TWC_Cal_EndWork']"><input type="hidden" name="tw_local_TWC_Cal_EndWork" value="<lsw:String zPath='./initialValue'/>"/></lsw:SetContext>
<lsw:SetContext zPath="./variable[@name='tw_local_TWC_Cal_Weekend']"><input type="hidden" name="tw_local_TWC_Cal_Weekend" value="<lsw:String zPath='./initialValue'/>"/></lsw:SetContext>
<lsw:SetContext zPath="./variable[@name='tw_local_TWC_Cal_Holiday']"><input type="hidden" name="tw_local_TWC_Cal_Holiday" value="<lsw:String zPath='./initialValue'/>"/></lsw:SetContext>
<lsw:SetContext zPath="./variable[@name='tw_local_TWC_Cal_PrioUnit']"><input type="hidden" name="tw_local_TWC_Cal_PrioUnit" value="<lsw:String zPath='./initialValue'/>"/></lsw:SetContext>
<lsw:SetContext zPath="./variable[@name='tw_local_TWC_Cal_PrioValue']"><input type="hidden" name="tw_local_TWC_Cal_PrioValue" value="<lsw:String zPath='./initialValue'/>"/></lsw:SetContext>
<lsw:SetContext zPath="./variable[@name='tw_local_TWC_Cal_PrioTime']"><input type="hidden" name="tw_local_TWC_Cal_PrioTime" value="<lsw:String zPath='./initialValue'/>"/></lsw:SetContext>
<lsw:SetContext zPath="./variable[@name='tw_local_TWC_Cal_SysDef']"><input type="hidden" name="tw_local_TWC_Cal_SysDef" value="<lsw:String zPath='./initialValue'/>"/></lsw:SetContext>
<lsw:SetContext zPath="./variable[@name='tw_local_TWC_Cal_OldSysDef']"><input type="hidden" name="tw_local_TWC_Cal_OldSysDef" value="<lsw:String zPath='./initialValue'/>"/></lsw:SetContext>
<lsw:SetContext zPath="./variable[@name='tw_local_TWC_Error']"><input type="hidden" name="tw_local_TWC_Error" value="<lsw:String zPath='./initialValue'/>"/></lsw:SetContext>
<input type="hidden" name="tw_local_TWC_Msg" value=""/>

<table style="margin:5" cellpadding="2" cellspacing="0" border="0">
<tr><td valign="top"><div class="cslabel">&nbsp;<bean:message key="TWC_Calendar.lombardiCalendars" /></div>
<select size="23" style="width:295" name="zCalendarList" onChange="return doFillDetails(this);">
<%-- generate option list from arrayAll --%>
<script>
 var zCalendarId = "";
 for(i = 0; i < arrayAll.length; i++) {
  document.write("<OPTION VALUE='" + arrayAll[i].id +"'");
  if (arrayAll[i].id == zCalendarId)
   document.write(" SELECTED");
  document.write(">" + arrayAll[i].name);
  if (arrayAll[i].sysdef) document.write(" (Default)");
  document.write("</OPTION>\n");
 }
</script>
</select></div>
</td>

<td valign="top"><div class="cslabel">&nbsp;<bean:message key="TWC_Calendar.calendarDetails" /></div>
<table cellpadding="2" cellspacing="0" border="0" style="border:solid gray 1px;height:305;width:300">
<tr><td width="95"><div class="cslabel"><bean:message key="TWC_Calendar.name" /></div></td>
<td><input style="width:200" type="text" name="zName" value=''></td>
<lsw:Validation zFormName="frm" zFieldName="zName"/>
</tr>
<tr><td width="95"><div class="cslabel"><bean:message key="TWC_Calendar.timezone" /></div></td>
<td>
<select style="width:200" name="zTimezone">
<option value="ACT">ACT</option>
<option value="AET">AET</option>
<option value="Africa/Abidjan">Africa/Abidjan</option>
<option value="Africa/Accra">Africa/Accra</option>
<option value="Africa/Addis_Ababa">Africa/Addis_Ababa</option>
<option value="Africa/Algiers">Africa/Algiers</option>
<option value="Africa/Asmera">Africa/Asmera</option>
<option value="Africa/Bangui">Africa/Bangui</option>
<option value="Africa/Banjul">Africa/Banjul</option>
<option value="Africa/Bissau">Africa/Bissau</option>
<option value="Africa/Blantyre">Africa/Blantyre</option>
<option value="Africa/Bujumbura">Africa/Bujumbura</option>
<option value="Africa/Cairo">Africa/Cairo</option>
<option value="Africa/Casablanca">Africa/Casablanca</option>
<option value="Africa/Conakry">Africa/Conakry</option>
<option value="Africa/Dakar">Africa/Dakar</option>
<option value="Africa/Dar_es_Salaam">Africa/Dar_es_Salaam</option>
<option value="Africa/Djibouti">Africa/Djibouti</option>
<option value="Africa/Douala">Africa/Douala</option>
<option value="Africa/Freetown">Africa/Freetown</option>
<option value="Africa/Gaborone">Africa/Gaborone</option>
<option value="Africa/Harare">Africa/Harare</option>
<option value="Africa/Johannesburg">Africa/Johannesburg</option>
<option value="Africa/Kampala">Africa/Kampala</option>
<option value="Africa/Khartoum">Africa/Khartoum</option>
<option value="Africa/Kigali">Africa/Kigali</option>
<option value="Africa/Kinshasa">Africa/Kinshasa</option>
<option value="Africa/Lagos">Africa/Lagos</option>
<option value="Africa/Libreville">Africa/Libreville</option>
<option value="Africa/Lome">Africa/Lome</option>
<option value="Africa/Luanda">Africa/Luanda</option>
<option value="Africa/Lubumbashi">Africa/Lubumbashi</option>
<option value="Africa/Lusaka">Africa/Lusaka</option>
<option value="Africa/Malabo">Africa/Malabo</option>
<option value="Africa/Maputo">Africa/Maputo</option>
<option value="Africa/Maseru">Africa/Maseru</option>
<option value="Africa/Mbabane">Africa/Mbabane</option>
<option value="Africa/Mogadishu">Africa/Mogadishu</option>
<option value="Africa/Monrovia">Africa/Monrovia</option>
<option value="Africa/Nairobi">Africa/Nairobi</option>
<option value="Africa/Ndjamena">Africa/Ndjamena</option>
<option value="Africa/Niamey">Africa/Niamey</option>
<option value="Africa/Nouakchott">Africa/Nouakchott</option>
<option value="Africa/Ouagadougou">Africa/Ouagadougou</option>
<option value="Africa/Porto-Novo">Africa/Porto-Novo</option>
<option value="Africa/Sao_Tome">Africa/Sao_Tome</option>
<option value="Africa/Timbuktu">Africa/Timbuktu</option>
<option value="Africa/Tripoli">Africa/Tripoli</option>
<option value="Africa/Tunis">Africa/Tunis</option>
<option value="Africa/Windhoek">Africa/Windhoek</option>
<option value="AGT">AGT</option>
<option value="America/Adak">America/Adak</option>
<option value="America/Anchorage">America/Anchorage</option>
<option value="America/Anguilla">America/Anguilla</option>
<option value="America/Antigua">America/Antigua</option>
<option value="America/Aruba">America/Aruba</option>
<option value="America/Asuncion">America/Asuncion</option>
<option value="America/Barbados">America/Barbados</option>
<option value="America/Belize">America/Belize</option>
<option value="America/Bogota">America/Bogota</option>
<option value="America/Buenos_Aires">America/Buenos_Aires</option>
<option value="America/Caracas">America/Caracas</option>
<option value="America/Cayenne">America/Cayenne</option>
<option value="America/Cayman">America/Cayman</option>
<option value="America/Chicago">America/Chicago</option>
<option value="America/Costa_Rica">America/Costa_Rica</option>
<option value="America/Cuiaba">America/Cuiaba</option>
<option value="America/Curacao">America/Curacao</option>
<option value="America/Dawson_Creek">America/Dawson_Creek</option>
<option value="America/Denver">America/Denver</option>
<option value="America/Dominica">America/Dominica</option>
<option value="America/Edmonton">America/Edmonton</option>
<option value="America/El_Salvador">America/El_Salvador</option>
<option value="America/Fortaleza">America/Fortaleza</option>
<option value="America/Godthab">America/Godthab</option>
<option value="America/Grand_Turk">America/Grand_Turk</option>
<option value="America/Grenada">America/Grenada</option>
<option value="America/Guadeloupe">America/Guadeloupe</option>
<option value="America/Guatemala">America/Guatemala</option>
<option value="America/Guayaquil">America/Guayaquil</option>
<option value="America/Guyana">America/Guyana</option>
<option value="America/Halifax">America/Halifax</option>
<option value="America/Havana">America/Havana</option>
<option value="America/Indianapolis">America/Indianapolis</option>
<option value="America/Jamaica">America/Jamaica</option>
<option value="America/La_Paz">America/La_Paz</option>
<option value="America/Lima">America/Lima</option>
<option value="America/Los_Angeles">America/Los_Angeles</option>
<option value="America/Managua">America/Managua</option>
<option value="America/Manaus">America/Manaus</option>
<option value="America/Martinique">America/Martinique</option>
<option value="America/Mazatlan">America/Mazatlan</option>
<option value="America/Mexico_City">America/Mexico_City</option>
<option value="America/Miquelon">America/Miquelon</option>
<option value="America/Montevideo">America/Montevideo</option>
<option value="America/Montreal">America/Montreal</option>
<option value="America/Montserrat">America/Montserrat</option>
<option value="America/Nassau">America/Nassau</option>
<option value="America/New_York">America/New_York</option>
<option value="America/Noronha">America/Noronha</option>
<option value="America/Panama">America/Panama</option>
<option value="America/Paramaribo">America/Paramaribo</option>
<option value="America/Phoenix">America/Phoenix</option>
<option value="America/Port-au-Prince">America/Port-au-Prince</option>
<option value="America/Port_of_Spain">America/Port_of_Spain</option>
<option value="America/Porto_Acre">America/Porto_Acre</option>
<option value="America/Puerto_Rico">America/Puerto_Rico</option>
<option value="America/Regina">America/Regina</option>
<option value="America/Rio_Branco">America/Rio_Branco</option>
<option value="America/Santiago">America/Santiago</option>
<option value="America/Santo_Domingo">America/Santo_Domingo</option>
<option value="America/Sao_Paulo">America/Sao_Paulo</option>
<option value="America/Scoresbysund">America/Scoresbysund</option>
<option value="America/St_Johns">America/St_Johns</option>
<option value="America/St_Kitts">America/St_Kitts</option>
<option value="America/St_Lucia">America/St_Lucia</option>
<option value="America/St_Thomas">America/St_Thomas</option>
<option value="America/St_Vincent">America/St_Vincent</option>
<option value="America/Tegucigalpa">America/Tegucigalpa</option>
<option value="America/Thule">America/Thule</option>
<option value="America/Tijuana">America/Tijuana</option>
<option value="America/Tortola">America/Tortola</option>
<option value="America/Vancouver">America/Vancouver</option>
<option value="America/Winnipeg">America/Winnipeg</option>
<option value="Antarctica/Casey">Antarctica/Casey</option>
<option value="Antarctica/DumontDUrville">Antarctica/DumontDUrville</option>
<option value="Antarctica/Mawson">Antarctica/Mawson</option>
<option value="Antarctica/McMurdo">Antarctica/McMurdo</option>
<option value="Antarctica/Palmer">Antarctica/Palmer</option>
<option value="ART">ART</option>
<option value="Asia/Aden">Asia/Aden</option>
<option value="Asia/Almaty">Asia/Almaty</option>
<option value="Asia/Amman">Asia/Amman</option>
<option value="Asia/Anadyr">Asia/Anadyr</option>
<option value="Asia/Aqtau">Asia/Aqtau</option>
<option value="Asia/Aqtobe">Asia/Aqtobe</option>
<option value="Asia/Ashgabat">Asia/Ashgabat</option>
<option value="Asia/Ashkhabad">Asia/Ashkhabad</option>
<option value="Asia/Baghdad">Asia/Baghdad</option>
<option value="Asia/Bahrain">Asia/Bahrain</option>
<option value="Asia/Baku">Asia/Baku</option>
<option value="Asia/Bangkok">Asia/Bangkok</option>
<option value="Asia/Beirut">Asia/Beirut</option>
<option value="Asia/Bishkek">Asia/Bishkek</option>
<option value="Asia/Brunei">Asia/Brunei</option>
<option value="Asia/Calcutta">Asia/Calcutta</option>
<option value="Asia/Colombo">Asia/Colombo</option>
<option value="Asia/Dacca">Asia/Dacca</option>
<option value="Asia/Damascus">Asia/Damascus</option>
<option value="Asia/Dhaka">Asia/Dhaka</option>
<option value="Asia/Dubai">Asia/Dubai</option>
<option value="Asia/Dushanbe">Asia/Dushanbe</option>
<option value="Asia/Hong_Kong">Asia/Hong_Kong</option>
<option value="Asia/Irkutsk">Asia/Irkutsk</option>
<option value="Asia/Jakarta">Asia/Jakarta</option>
<option value="Asia/Jayapura">Asia/Jayapura</option>
<option value="Asia/Jerusalem">Asia/Jerusalem</option>
<option value="Asia/Kabul">Asia/Kabul</option>
<option value="Asia/Kamchatka">Asia/Kamchatka</option>
<option value="Asia/Karachi">Asia/Karachi</option>
<option value="Asia/Katmandu">Asia/Katmandu</option>
<option value="Asia/Krasnoyarsk">Asia/Krasnoyarsk</option>
<option value="Asia/Kuala_Lumpur">Asia/Kuala_Lumpur</option>
<option value="Asia/Kuwait">Asia/Kuwait</option>
<option value="Asia/Macao">Asia/Macao</option>
<option value="Asia/Magadan">Asia/Magadan</option>
<option value="Asia/Manila">Asia/Manila</option>
<option value="Asia/Muscat">Asia/Muscat</option>
<option value="Asia/Nicosia">Asia/Nicosia</option>
<option value="Asia/Novosibirsk">Asia/Novosibirsk</option>
<option value="Asia/Phnom_Penh">Asia/Phnom_Penh</option>
<option value="Asia/Pyongyang">Asia/Pyongyang</option>
<option value="Asia/Qatar">Asia/Qatar</option>
<option value="Asia/Rangoon">Asia/Rangoon</option>
<option value="Asia/Riyadh">Asia/Riyadh</option>
<option value="Asia/Saigon">Asia/Saigon</option>
<option value="Asia/Seoul">Asia/Seoul</option>
<option value="Asia/Shanghai">Asia/Shanghai</option>
<option value="Asia/Singapore">Asia/Singapore</option>
<option value="Asia/Taipei">Asia/Taipei</option>
<option value="Asia/Tashkent">Asia/Tashkent</option>
<option value="Asia/Tbilisi">Asia/Tbilisi</option>
<option value="Asia/Tehran">Asia/Tehran</option>
<option value="Asia/Thimbu">Asia/Thimbu</option>
<option value="Asia/Thimphu">Asia/Thimphu</option>
<option value="Asia/Tokyo">Asia/Tokyo</option>
<option value="Asia/Ujung_Pandang">Asia/Ujung_Pandang</option>
<option value="Asia/Ulaanbaatar">Asia/Ulaanbaatar</option>
<option value="Asia/Ulan_Bator">Asia/Ulan_Bator</option>
<option value="Asia/Vientiane">Asia/Vientiane</option>
<option value="Asia/Vladivostok">Asia/Vladivostok</option>
<option value="Asia/Yakutsk">Asia/Yakutsk</option>
<option value="Asia/Yekaterinburg">Asia/Yekaterinburg</option>
<option value="Asia/Yerevan">Asia/Yerevan</option>
<option value="AST">AST</option>
<option value="Atlantic/Azores">Atlantic/Azores</option>
<option value="Atlantic/Bermuda">Atlantic/Bermuda</option>
<option value="Atlantic/Canary">Atlantic/Canary</option>
<option value="Atlantic/Cape_Verde">Atlantic/Cape_Verde</option>
<option value="Atlantic/Faeroe">Atlantic/Faeroe</option>
<option value="Atlantic/Jan_Mayen">Atlantic/Jan_Mayen</option>
<option value="Atlantic/Reykjavik">Atlantic/Reykjavik</option>
<option value="Atlantic/South_Georgia">Atlantic/South_Georgia</option>
<option value="Atlantic/St_Helena">Atlantic/St_Helena</option>
<option value="Atlantic/Stanley">Atlantic/Stanley</option>
<option value="Australia/Adelaide">Australia/Adelaide</option>
<option value="Australia/Brisbane">Australia/Brisbane</option>
<option value="Australia/Broken_Hill">Australia/Broken_Hill</option>
<option value="Australia/Darwin">Australia/Darwin</option>
<option value="Australia/Hobart">Australia/Hobart</option>
<option value="Australia/Lord_Howe">Australia/Lord_Howe</option>
<option value="Australia/Perth">Australia/Perth</option>
<option value="Australia/Sydney">Australia/Sydney</option>
<option value="BET">BET</option>
<option value="BST">BST</option>
<option value="CAT">CAT</option>
<option value="CNT">CNT</option>
<option value="CST">CST</option>
<option value="CTT">CTT</option>
<option value="EAT">EAT</option>
<option value="ECT">ECT</option>
<option value="EET">EET</option>
<option value="EST">EST</option>
<option value="Europe/Amsterdam">Europe/Amsterdam</option>
<option value="Europe/Andorra">Europe/Andorra</option>
<option value="Europe/Athens">Europe/Athens</option>
<option value="Europe/Belgrade">Europe/Belgrade</option>
<option value="Europe/Berlin">Europe/Berlin</option>
<option value="Europe/Brussels">Europe/Brussels</option>
<option value="Europe/Bucharest">Europe/Bucharest</option>
<option value="Europe/Budapest">Europe/Budapest</option>
<option value="Europe/Chisinau">Europe/Chisinau</option>
<option value="Europe/Copenhagen">Europe/Copenhagen</option>
<option value="Europe/Dublin">Europe/Dublin</option>
<option value="Europe/Gibraltar">Europe/Gibraltar</option>
<option value="Europe/Helsinki">Europe/Helsinki</option>
<option value="Europe/Istanbul">Europe/Istanbul</option>
<option value="Europe/Kaliningrad">Europe/Kaliningrad</option>
<option value="Europe/Kiev">Europe/Kiev</option>
<option value="Europe/Lisbon">Europe/Lisbon</option>
<option value="Europe/London">Europe/London</option>
<option value="Europe/Luxembourg">Europe/Luxembourg</option>
<option value="Europe/Madrid">Europe/Madrid</option>
<option value="Europe/Malta">Europe/Malta</option>
<option value="Europe/Minsk">Europe/Minsk</option>
<option value="Europe/Monaco">Europe/Monaco</option>
<option value="Europe/Moscow">Europe/Moscow</option>
<option value="Europe/Oslo">Europe/Oslo</option>
<option value="Europe/Paris">Europe/Paris</option>
<option value="Europe/Prague">Europe/Prague</option>
<option value="Europe/Riga">Europe/Riga</option>
<option value="Europe/Rome">Europe/Rome</option>
<option value="Europe/Samara">Europe/Samara</option>
<option value="Europe/Simferopol">Europe/Simferopol</option>
<option value="Europe/Sofia">Europe/Sofia</option>
<option value="Europe/Stockholm">Europe/Stockholm</option>
<option value="Europe/Tallinn">Europe/Tallinn</option>
<option value="Europe/Tirane">Europe/Tirane</option>
<option value="Europe/Vaduz">Europe/Vaduz</option>
<option value="Europe/Vienna">Europe/Vienna</option>
<option value="Europe/Vilnius">Europe/Vilnius</option>
<option value="Europe/Warsaw">Europe/Warsaw</option>
<option value="Europe/Zurich">Europe/Zurich</option>
<option value="GMT">GMT</option>
<option value="HST">HST</option>
<option value="IET">IET</option>
<option value="Indian/Antananarivo">Indian/Antananarivo</option>
<option value="Indian/Chagos">Indian/Chagos</option>
<option value="Indian/Christmas">Indian/Christmas</option>
<option value="Indian/Cocos">Indian/Cocos</option>
<option value="Indian/Comoro">Indian/Comoro</option>
<option value="Indian/Kerguelen">Indian/Kerguelen</option>
<option value="Indian/Mahe">Indian/Mahe</option>
<option value="Indian/Maldives">Indian/Maldives</option>
<option value="Indian/Mauritius">Indian/Mauritius</option>
<option value="Indian/Mayotte">Indian/Mayotte</option>
<option value="Indian/Reunion">Indian/Reunion</option>
<option value="IST">IST</option>
<option value="JST">JST</option>
<option value="MET">MET</option>
<option value="MIT">MIT</option>
<option value="MST">MST</option>
<option value="NET">NET</option>
<option value="NST">NST</option>
<option value="Pacific/Apia">Pacific/Apia</option>
<option value="Pacific/Auckland">Pacific/Auckland</option>
<option value="Pacific/Chatham">Pacific/Chatham</option>
<option value="Pacific/Easter">Pacific/Easter</option>
<option value="Pacific/Efate">Pacific/Efate</option>
<option value="Pacific/Enderbury">Pacific/Enderbury</option>
<option value="Pacific/Fakaofo">Pacific/Fakaofo</option>
<option value="Pacific/Fiji">Pacific/Fiji</option>
<option value="Pacific/Funafuti">Pacific/Funafuti</option>
<option value="Pacific/Galapagos">Pacific/Galapagos</option>
<option value="Pacific/Gambier">Pacific/Gambier</option>
<option value="Pacific/Guadalcanal">Pacific/Guadalcanal</option>
<option value="Pacific/Guam">Pacific/Guam</option>
<option value="Pacific/Honolulu">Pacific/Honolulu</option>
<option value="Pacific/Kiritimati">Pacific/Kiritimati</option>
<option value="Pacific/Kosrae">Pacific/Kosrae</option>
<option value="Pacific/Majuro">Pacific/Majuro</option>
<option value="Pacific/Marquesas">Pacific/Marquesas</option>
<option value="Pacific/Nauru">Pacific/Nauru</option>
<option value="Pacific/Niue">Pacific/Niue</option>
<option value="Pacific/Norfolk">Pacific/Norfolk</option>
<option value="Pacific/Noumea">Pacific/Noumea</option>
<option value="Pacific/Pago_Pago">Pacific/Pago_Pago</option>
<option value="Pacific/Palau">Pacific/Palau</option>
<option value="Pacific/Pitcairn">Pacific/Pitcairn</option>
<option value="Pacific/Ponape">Pacific/Ponape</option>
<option value="Pacific/Port_Moresby">Pacific/Port_Moresby</option>
<option value="Pacific/Rarotonga">Pacific/Rarotonga</option>
<option value="Pacific/Saipan">Pacific/Saipan</option>
<option value="Pacific/Tahiti">Pacific/Tahiti</option>
<option value="Pacific/Tarawa">Pacific/Tarawa</option>
<option value="Pacific/Tongatapu">Pacific/Tongatapu</option>
<option value="Pacific/Truk">Pacific/Truk</option>
<option value="Pacific/Wake">Pacific/Wake</option>
<option value="Pacific/Wallis">Pacific/Wallis</option>
<option value="PLT">PLT</option>
<option value="PNT">PNT</option>
<option value="PRT">PRT</option>
<option value="PST">PST</option>
<option value="SST">SST</option>
<option value="UTC">UTC</option>
<option value="VST">VST</option>
<option value="WET">WET</option>
</select>
</td>
<lsw:Validation zFormName="frm" zFieldName="zTimezone"/>
</tr>
<tr>
<td width="95"><div class="cslabel"><bean:message key="TWC_Calendar.startWork" /></div></td>
<td class="cslabel"><input size=6 type="text" name="zStartWork" value='' onChange="vldFld(this);">&nbsp;(09:00,HH:mm)</td>
<lsw:Validation zFormName="frm" zFieldName="zStartWork"/>
</tr>
<td width="95"><div class="cslabel"><bean:message key="TWC_Calendar.endWork" /></div></td>
<td class="cslabel"><input size=6 type="text" name="zEndWork" value='' onChange="vldFld(this);">&nbsp;(17:00,HH:mm)</td>
<lsw:Validation zFormName="frm" zFieldName="zEndWork"/>
</tr>
<tr>
<td width="95"><div class="cslabel"><bean:message key="TWC_Calendar.weekend" /></div></td>
<td><input style="width:200" type="text" name="zWeekend" value=''></td>
</tr>
<tr>
<td width="95"><div class="cslabel">&nbsp;</div></td>
<td><div class="cslabel">(SAT,SUN,ddd,...)</div></td>
</tr>
<tr>
<td width="95"><div class="cslabel"><bean:message key="TWC_Calendar.holiday" /></div></td>
<td><input style="width:200" type="text" name="zHoliday" value=''></td>
</tr>
<tr>
<td width="95"><div class="cslabel">&nbsp;</div></td>
<td><div class="cslabel">(20031225,yyyyMMdd,...)</div></td>
</tr>
<tr>

<td colspan="2" width="100%">
<div class="cslabel">&nbsp;<bean:message key="TWC_Calendar.defaultValues" /></div>
<table cellpadding="2" cellspacing="0" border="0" style="border:solid gray 1px">
<tr>
<td>
<div class="cslabel"><bean:message key="TWC_Calendar.incrementType" /></div></td>
<td>
<select style="width:80" name="zPrioUnit" onChange = "changeStatus(this);">
<option value='2'><bean:message key="TWC_Calendar.days" /></option>
<option value='3'><bean:message key="TWC_Calendar.hours" /></option>
<option value='4'><bean:message key="TWC_Calendar.minutes" /></option>
<option value='1'><bean:message key="TWC_Calendar.months" /></option>
</select>
</td>
<lsw:Validation zFormName="frm" zFieldName="zPrioUnit"/>
</tr>
<tr>
<td><div class="cslabel"><bean:message key="TWC_Calendar.incrementQuantity" /></div></td>
<td><input size=6 type="text" name="zPrioValue" value=''></td>
<lsw:Validation zFormName="frm" zFieldName="zPrioValue"/>
</tr>
<tr>
<td><div class="cslabel"><bean:message key="TWC_Calendar.timeDue" /></div></td>
<td><input size=6 type="text" name="zPrioTime" value='17:00' onChange="vldFld(this);"></td>
<lsw:Validation zFormName="frm" zFieldName="zPrioTime"/>
</tr>
</table>
</td>

</tr>
<tr>
<td><div class="cslabel"><bean:message key="TWC_Calendar.isDefault" /></div></td>
<td><input type="checkbox" name="zIsDefault"></td>
</tr>
<TR><td colspan="2" height="5"></td></TR>
</table>
</td>
</tr>
</table>
<div style="position:absolute;left:405px;top:370px"><input name="updateB" class="button" type="submit" value='<bean:message key="TWC_Calendar.button_update" />' onClick="doUpdate();return true;"></div>
<div style="position:absolute;left:495px;top:370px"><input name="ClearB" class="button" type="button" value='<bean:message key="TWC_Calendar.button_clear" />' onClick="doClear(); return false;"></div>
<br><br>
</form>
<div id="ErrorMsg" class="errortype"><lsw:SetContext zPath="./variable[@name='tw_local_TWC_Msg']"><lsw:String zPath="./initialValue"/></lsw:SetContext></div>
</td></tr>
</table>
<br><br><br><br>
<table class="cshlp" cellpadding="2" cellspacing="0">
<tr><td class="cshlp"><div class="lbl"><bean:message key="TWC_Calendar.maintainCalendars" /></div></td></tr>
<tr><td class="cshlptxt"><div class="info1"><bean:message key="TWC_Calendar.update_calendars" /><br>
<li><bean:message key="TWC_Calendar.update_calendars.li" /></li>
</td></tr>
</div></table>
</body></lsw:SetContext></html>