<%@ page language="java" pageEncoding="UTF-8" contentType="text/html; charset=UTF-8"%>
<%@ include file="common/prolog.jsp" %>
<%@ include file="/html/msgs-init.jsp" %>
<%@page errorPage="tm_error.jsp" %>
<%@page import="com.lombardisoftware.client.persistence.common.POType"%>
<%@page import="java.util.List"%>
<%@page import="java.util.ArrayList"%>
<%@page import="java.util.Map"%>
<%@page import="java.util.LinkedHashMap"%>
<%@page import="com.lombardisoftware.client.persistence.common.ID"%>
<%@page import="com.lombardisoftware.client.persistence.UserAttributeDefValue"%>
<%@page import="com.lombardisoftware.client.persistence.UserAttributeDefinition"%>
<%@page import="com.lombardisoftware.client.persistence.UserAttribute"%>
<%@page import="com.lombardisoftware.client.delegate.UserGroupAPIFacadeDelegate"%>
<%@page import="com.lombardisoftware.client.persistence.UserAttributeDefinitionFactory"%>
<%@page import="com.lombardisoftware.client.persistence.UserAttributeFactory"%>
<%@page import="com.lombardisoftware.core.config.TWConfiguration"%>
<%@page import="com.lombardisoftware.client.delegate.UserGroupAPIFacadeDelegateFactory"%>
<%@page import="java.util.Collection"%>
<%@page import="com.lombardisoftware.client.delegate.BusinessDelegateException"%>
<%@page import="java.util.Collections"%>
<%@page import="java.util.Comparator"%>
<%@page import="com.lombardisoftware.core.TeamWorksException"%>
<%@page import="java.math.BigDecimal"%>
<%@page import="com.lombardisoftware.psapi.data.User"%>
<%@page import="com.lombardi.langutil.collections.CollectionsFactory"%>
<%@page import="com.lombardi.langutil.templates.UnaryFunction"%>
<%@page import="java.util.Enumeration"%>
<%@page import="com.lombardisoftware.client.persistence.common.versioning.VersioningContext"%>
<%@page import="com.lombardisoftware.client.persistence.common.POType.UserAttributeDefinitionValue"%>
<%@page import="com.lombardisoftware.client.persistence.TWClass"%>
<%@page import="com.lombardisoftware.client.persistence.TWClassFactory"%>
<%@page import="java.util.HashMap"%>
<%@page import="java.util.Set"%>
<%@page import="java.util.Iterator"%>
<%@page import="java.util.HashSet"%>
<%@page import="com.lombardisoftware.psapi.data.UserGroup"%>
<%@page import="com.lombardisoftware.client.delegate.SecurityDelegateFactory"%>
<%@page import="com.lombardisoftware.client.delegate.RuntimeServicesDelegateFactory" %>
<%@page import="org.apache.struts.util.MessageResources" %>
<%@page import="org.apache.struts.Globals" %>
<%@page import="org.apache.struts.taglib.TagUtils" %>
<%@page import="com.lombardisoftware.client.SortUtils"%>
<%@page import="com.lombardisoftware.client.SortUtils.FieldSelector"%>
<%@page import="com.ibm.bpm.crconfig.BPMContextRootConfigService"%>
<script src="<lsw:ImagePrefix/>script/utils.js" type="text/javascript"></script>
<html>
<%
    // The locale and message bundle should be set by msgs-init.jsp
    Locale currentLocale = (Locale)request.getSession().getAttribute(Globals.LOCALE_KEY);
    MessageResources bundle = (MessageResources)pageContext.getAttribute(Globals.MESSAGES_KEY, PageContext.APPLICATION_SCOPE);

    String assignmentError = null;

// Parse view by
    String viewByAttr = request.getParameter("viewByAttr");
    boolean byAttr = true;

    if (viewByAttr != null && viewByAttr.equalsIgnoreCase("false")) {
        byAttr = false;
    }

//By Attribute related fields
    String userFilterByAttr = request.getParameter("userFilterByAttr");
    String searchButton = request.getParameter("searchButton");
    String attrDefs = request.getParameter("attrDefs");

    List<User> usersListByAttr = new ArrayList<User>();
    Map<ID<POType.UserAttributeDefinition>, UserAttributeDefinition> userAttrDefsMap = new LinkedHashMap<ID<POType.UserAttributeDefinition>, UserAttributeDefinition>();
    List<UserAttributeDefValue> attrDefValues = new ArrayList<UserAttributeDefValue>();

//By User related fields
    String userFilterByUser = request.getParameter("userFilterByUser");
    String retrieveButton = request.getParameter("retrieveButton");
    String usersList = request.getParameter("usersList");
    
    ID<POType.User> userId = null;
    if (usersList != null) {
        userId = POType.User.cast(ID.fromExternalString(usersList));
    }

//Assign new attr value from View By User view
//If control is list
    String selectedAttr = request.getParameter("selectedAttr");

    if (request.getParameter("updateButton") != null) {
        
        List<UserAttribute> userAtts = userAttributeFactory.findByUser(userId);
        Map<ID<POType.UserAttributeDefinition>, UserAttribute> userAttsByAttId;
        
        userAttsByAttId = CollectionsFactory.buildMap(userAtts, new UnaryFunction<UserAttribute, ID<POType.UserAttributeDefinition>, Exception>() {
            public ID<POType.UserAttributeDefinition> execute(UserAttribute o) {
                return o.getUserAttrDefId();
            }
        });

        Enumeration paramNames = request.getParameterNames();
        List<UserAttribute> attsToSave = CollectionsFactory.newArrayList();
        
        while (paramNames.hasMoreElements()) {
            
            String paramName = (String) paramNames.nextElement();
            String paramValue = request.getParameter(paramName);
            String attrIdString = null;
            Object attValue = null;
            
            if (paramName.startsWith("attrValuesByUser_")) {
                if ((paramValue != null) && (!"-1".equals(paramValue))) {
                    attrIdString = paramName.substring("attrValuesByUser_".length());
                    attValue = ID.fromExternalString(paramValue);
                }
            } else if (paramName.startsWith("attrValByUserText_")) {
                attrIdString = paramName.substring("attrValByUserText_".length());
                attValue = paramValue;
            } else if (paramName.startsWith("attrValByUserCheckboxExpected_")) {
                attrIdString = paramName.substring("attrValByUserCheckboxExpected_".length());
                if (request.getParameter("attrValByUserCheckbox_" + attrIdString) == null) {
                    attValue = "false";
                } else {
                    attValue = "true";
                }
            }
            if (attrIdString != null) {
                
                ID<POType.UserAttributeDefinition> attrId = POType.UserAttributeDefinition.cast(ID.fromExternalString(attrIdString));
                
                boolean doAdd = false;
                
                // Copy the values into a new attribute. We check later if we must update an exiting
                UserAttribute attribute = userAttributeFactory.createUserAttribute();
                
                attribute.setUserId(userId);
                attribute.setUserAttrDefId(attrId);

                if (attValue instanceof ID) {
                    attribute.setUserAttrDefValueId(POType.UserAttributeDefinitionValue.cast((ID) attValue));
                } else if (attValue instanceof String) {
                    attribute.setAttrValue((String) attValue);
                    attribute.setUserAttrDefValueId(null);

                    UserAttributeDefinition definition = SecurityDelegateFactory.getInstance().newInstance().getUserAttributeDefinition(attrId);
                    TWClass twClass = TWClassFactory.getInstance().findByPrimaryKey(definition.getVersioningContext(), definition.getClassRef());
                    if (twClass.isBaseTypeInteger() || twClass.isBaseTypeDecimal()) {
                        String stringValue = attribute.getAttrValue();
                        if ((stringValue != null) && (!"".equals(stringValue))) {
                            try {
                                // We have to check if the value if a number
                                /*BigDecimal numberValue =*/
                                new BigDecimal(stringValue);
                            } catch (NumberFormatException nfe) {
                                assignmentError = TagUtils.getInstance().message(pageContext, null, Globals.LOCALE_KEY, 
                                        "cs_bulk_usr_attr_assign.assignmentError.numeric", new Object[] {definition.getDisplayName()});
                            }
                        }
                    }
                } else {
                    attribute.setAttrValue("");
                    attribute.setUserAttrDefValueId(null);
                }
                
                // now check for an already exising attribute  
                UserAttribute existing = userAttsByAttId.get(attrId);
                if (existing == null) {
                    // the attribute is new, but we only want to write it if it has real content
                    doAdd = ((attribute.getUserAttrDefValueId()!=null) || !attribute.getAttrValue().equals(""));
                } else {
                    // the attribute is already persisted in the db, check if the value has changed, via isPropertyModified
                    existing.setUserId( attribute.getUserId());
                    existing.setUserAttrDefId( attribute.getUserAttrDefId() );
                    existing.setAttrValue( attribute.getAttrValue() );
                    
                    // existing.setUserAttrDefValueId( attribute.getUserAttrDefValueId() );
                    // for any reasons isPropertyModified works incorrect for null values for UserAttrDefValueId
                    
                    
                    
                    if ( existing.getUserAttrDefValueId() != null && ! existing.getUserAttrDefValueId().equals(attribute.getUserAttrDefValueId()) ) { 
                        existing.setUserAttrDefValueId( attribute.getUserAttrDefValueId() );
                        doAdd = true;
                    } else if ( existing.getUserAttrDefValueId() == null && attribute.getUserAttrDefValueId() != null ) { 
                        existing.setUserAttrDefValueId( attribute.getUserAttrDefValueId() );
                        doAdd = true;
                    } // all other cases nothing has changed
                     
                    doAdd = doAdd 
                            || existing.isPropertyModified(UserAttribute.PROPERTY_USER_ID) 
                            || existing.isPropertyModified(UserAttribute.PROPERTY_USER_ATTR_DEF_ID) 
                            || existing.isPropertyModified(UserAttribute.PROPERTY_ATTR_VALUE);
                    
                    if (doAdd) {
                        // we want to write back th original attribute
                        attribute = existing;
                    }
                }
                
                if (doAdd) {
                  attsToSave.add(attribute);
                }
            }
        }

        if (assignmentError == null && !attsToSave.isEmpty()) {
            // only save the values if there were no errors
            userAttributeFactory.save(attsToSave);
        }
    }

    List<User> usersListByUser = new ArrayList<User>();
    Map<ID<POType.User>, String> user2AttrMap = new HashMap<ID<POType.User>, String>();

//Obtain all user attribute definitions
    List<UserAttributeDefinition> userAttrDefsList = SecurityDelegateFactory.getInstance().newInstance().listUserAttributeDefinitions();

    final Map<String, String> resolvedNames = RuntimeServicesDelegateFactory.getInstance().newInstance().resolveAmbiguousNames(userAttrDefsList);

//Sort the userAttrDefsList list
    Collections.sort(userAttrDefsList, new Comparator<UserAttributeDefinition>() {
        public int compare(UserAttributeDefinition uad1, UserAttributeDefinition uad2) {
            String name1 = resolvedNames.get(uad1.getGuid()).toLowerCase();
            String name2 = resolvedNames.get(uad2.getGuid()).toLowerCase();
            return name1.compareTo(name2);
        }
    });

    for (UserAttributeDefinition uad : userAttrDefsList) {
        if (uad.getStorageSource().intValue() == UserAttributeDefinition.STORAGE_SOURCE_TEAMWORKS_PEOPLE_MANAGER) {
            userAttrDefsMap.put(uad.getId(), uad);
        }
    }

    ID<POType.UserAttributeDefinition> attrDefId = null;

    if (attrDefs != null) {
        attrDefId = POType.UserAttributeDefinition.cast(ID.fromExternalString(attrDefs));
    }

//Init user attr values list
    if (attrDefId != null) {
        attrDefValues = new ArrayList<UserAttributeDefValue>(userAttrDefsMap.get(attrDefId).getUserAttributeDefValues());
    }

    if (userFilterByUser != null && userFilterByUser.length() > 0 && retrieveButton != null && retrieveButton
            .equalsIgnoreCase("true")) {
        fillUsers(userFilterByUser, usersListByUser);
    }

    String assignButton = request.getParameter("assignButton");
    String[] selectedUsersByAttr = request.getParameterValues("selectedUserByAttr");
    Set<ID<POType.User>> selectedUserIds = new HashSet<ID<POType.User>>();

    if (selectedUsersByAttr != null && assignButton != null && assignButton.equalsIgnoreCase("true")) {
        for (String selectedUserId : selectedUsersByAttr) {
            selectedUserIds.add(POType.User.cast(ID.fromExternalString(selectedUserId)));
        }

        if (request.getParameter("assignByAttribute") != null) { // Assign button was pressed
            String attrVal = request.getParameter("attrVals");

            final List<ID<POType.User>> userIds = CollectionsFactory.newArrayList(selectedUserIds.size());
            userIds.addAll(selectedUserIds);

            UserAttributeDefinition uad = SecurityDelegateFactory.getInstance().newInstance().getUserAttributeDefinition(attrDefId);
            TWClass twClass = TWClassFactory.getInstance().findByPrimaryKey(uad.getVersioningContext(), uad.getClassRef());

            if (attrVal != null && attrVal.length() > 0) {
                userAttributeFactory
                        .setUserAttributeValueId(userIds, attrDefId, POType.UserAttributeDefinitionValue.cast(ID.fromExternalString(attrVal)));
            } else if (uad.getValuesSource().longValue() == UserAttributeDefinition.VALUES_SOURCE_ANY_ALLOWED) {
                // If control is text box
                String attrValText = request.getParameter("attrValText");
                if ("".equals(attrValText)) {
                    attrValText = null;
                }

                // type check on attrValText
                if (attrValText != null) {
                    if (twClass.isBaseTypeInteger() || twClass.isBaseTypeDecimal()) {
                        try {
                            BigDecimal numberValue = new BigDecimal(attrValText);
                            if (twClass.isBaseTypeInteger() && numberValue.scale() > 0) {
                                assignmentError = TagUtils.getInstance().message(pageContext, null, Globals.LOCALE_KEY, 
                                        "cs_bulk_usr_attr_assign.assignmentError.integer", new Object[] {uad.getDisplayName()});
                            }
                        } catch (Exception e) {
                            assignmentError = TagUtils.getInstance().message(pageContext, null, Globals.LOCALE_KEY, 
                                    "cs_bulk_usr_attr_assign.assignmentError.numeric", new Object[] {uad.getDisplayName()});
                        }
                    }
                }

                if (assignmentError == null) {
                    userAttributeFactory.setUserAttributeValue(userIds, attrDefId, attrValText);
                }
            } else if (twClass.isBaseTypeBoolean()) {
                // If control is checkbox
                String attrValCheckbox = request.getParameter("attrValCheckbox");
                String val = "false";

                if (attrValCheckbox != null) {
                    val = "true";
                }

                userAttributeFactory.setUserAttributeValue(userIds, attrDefId, val);
            }

            // mnn: after assigning attribute values, clear the checkboxes so that the changed users are no longer selected (ORG-237)
            if (assignmentError == null) {
                selectedUserIds.clear();
            }
        }
    }

    String userGroupFilter = request.getParameter("userGroupFilter");

    if (userFilterByAttr != null && searchButton != null && searchButton.equalsIgnoreCase("true")) {
		if(userFilterByAttr.length() == 0 && userGroupFilter.length() > 0){
			fillUsersByParticipantList(userGroupFilter, usersListByAttr);
		}else{
        	fillUsers(userFilterByAttr, usersListByAttr);
        	// Filter by participant
        	if (userGroupFilter != null && userGroupFilter.length() > 0) {
            	if (usersListByAttr.size() > 0) {
                	Set<BigDecimal> userIdsByParticipantList = fillUserIdsByParticipantList(userGroupFilter);
                	for (Iterator<User> it = usersListByAttr.iterator(); it.hasNext();) {
                    	User user = it.next();
                    	if (!userIdsByParticipantList.contains(new BigDecimal(user.getUserID()))) {
                        	it.remove();
                    	}
                	}
            	}
        	}
		}
        // Show attributes assigned to user
        if (attrDefId != null) {
            UserAttributeDefinition uad = SecurityDelegateFactory.getInstance().newInstance().getUserAttributeDefinition(attrDefId);

            /*
            for (User user : usersListByAttr) {
                Collection<UserAttribute> attributes = GenericsUtils.toT(userAttributeFactory.findByUser(new BigDecimal(user.getUserID())));

                for (UserAttribute attr : attributes) {
                    if (attr.getUserAttrDefId().longValue() == attrDefId) {
                        if (uad.getValuesSource().longValue() == UserAttributeDefinition.VALUES_SOURCE_ANY_ALLOWED) {
                            user2AttrMap.put(new Long(user.getUserID()), attr.getAttrValue());
                        } else {
                            user2AttrMap.put(new Long(user.getUserID()), uadDelegate.getValueById(attr.getUserAttrDefValueId().longValue()).getValue());
                        }
                    }
                }
            }
            */

            // mnn: if the UnaryFunctions below are properly parameterized, the JSP compiles correctly, but we get
            // AbstractMethodErrors when we try to invoke them (JBoss 4.0.5).  Switching to un-parameterized functions
            // for now...
            List<ID<POType.User>> userIds =
                    CollectionsFactory.transformCollection(usersListByAttr,
                            new UnaryFunction<User, ID<POType.User>, Exception>() {
                                public ID<POType.User> execute(User u) {
                                    return ID.get(POType.User, new BigDecimal(u.getUserID()));
                                }
                            });

            List<UserAttribute> rawAttributeValues = userAttributeFactory.findByUserIds(userIds);
            Map<ID<POType.User>, List<UserAttribute>> attValues = CollectionsFactory
                    .buildMapOfLists(rawAttributeValues, new UnaryFunction<UserAttribute, ID<POType.User>, Exception>() {
                        public ID<POType.User> execute(UserAttribute att) {
                            return att.getUserId();
                        }
                    });
            Map<ID<POType.UserAttributeDefinitionValue>, UserAttributeDefValue> resolvedValues = Collections.emptyMap();
            if (uad.getValuesSource().longValue() != UserAttributeDefinition.VALUES_SOURCE_ANY_ALLOWED) {
                resolvedValues = new HashMap<ID<POType.UserAttributeDefinitionValue>, UserAttributeDefValue>();
                for (List<UserAttribute> attList : attValues.values()) {
                    for (UserAttribute att : attList) {
                        if (att.getUserAttrDefId().equals(attrDefId) && att.getUserAttrDefValueId() != null) {
                            UserAttributeDefValue value = userAttrDefsMap.get(attrDefId).findValueById(att.getUserAttrDefValueId());
                            if (value != null) {                            
                            	resolvedValues.put(value.getId(), value);
                            }
                        }
                    }
                }
            }

            TWClass userAttrClass = TWClassFactory.getInstance().findByPrimaryKey(uad.getVersioningContext(), uad.getClassRef());
            for (Map.Entry<ID<POType.User>, List<UserAttribute>> entry : attValues.entrySet()) {
                for (UserAttribute att : entry.getValue()) {
                    if (att.getUserAttrDefId().equals(attrDefId)) {
                        if (userAttrClass.isBaseTypeBoolean() || uad.getValuesSource().longValue() == UserAttributeDefinition.VALUES_SOURCE_ANY_ALLOWED) {
                            user2AttrMap.put(entry.getKey(), att.getAttrValue());
                        } else {
                            UserAttributeDefValue value = resolvedValues.get(att.getUserAttrDefValueId());
                            if (value != null) {
                                user2AttrMap.put(entry.getKey(), value.getValue());
                            }
                        }
                    }
                }
            }
        }
    }

//Show attribute defs and vals for 'View by User' page
    Map<ID<POType.UserAttributeDefinition>, List<UserAttributeDefValue>> attrDef2ValuesMap = 
        new HashMap<ID<POType.UserAttributeDefinition>, List<UserAttributeDefValue>>();
    Map<ID<POType.UserAttributeDefinition>, ID<POType.UserAttributeDefinitionValue>> attrDef2AssignedValIdMap = 
        new HashMap<ID<POType.UserAttributeDefinition>, ID<POType.UserAttributeDefinitionValue>>();

    if (userId != null) {
        for (UserAttributeDefinition uad : userAttrDefsMap.values()) {
            attrDef2ValuesMap.put(uad.getId(), new ArrayList<UserAttributeDefValue>(uad.getUserAttributeDefValues()));
        }

        Collection<UserAttribute> attributes = userAttributeFactory.findByUser(userId);

        for (UserAttribute attr : attributes) {
            UserAttributeDefinition uad = SecurityDelegateFactory.getInstance().newInstance().getUserAttributeDefinition(attr.getUserAttrDefId());

            if (uad.getStorageSource().intValue() != UserAttributeDefinition.STORAGE_SOURCE_TEAMWORKS_PEOPLE_MANAGER) {
                continue;
            }

            attrDef2AssignedValIdMap.put(uad.getId(), attr.getUserAttrDefValueId());
        }
    }
%>

<%!
private UserGroupAPIFacadeDelegate userGroupDelegate = UserGroupAPIFacadeDelegateFactory.getInstance().newInstance();
private UserAttributeFactory userAttributeFactory = UserAttributeFactory.getInstance();
private String portalPrefix = TWConfiguration.getInstance().getAuthoringEnvironment().getPortalPrefix();

private void fillUsers(String filter, List<User> usersList) throws TeamWorksException {
    usersList.addAll(userGroupDelegate.getUsersByFilter(filter.contains("%") ? filter : filter + "%"));
    
    SortUtils.sort(usersList, new SortUtils.FieldSelector<User>() {
        public String getValue(User user) {
            return user.getUserName();
        }
    });
}

private Set<BigDecimal> fillUserIdsByParticipantList(String filter) throws TeamWorksException {
    Collection<UserGroup> allUserGroups = userGroupDelegate.getUserGroups();
    List<UserGroup> filteredGroups = new ArrayList<UserGroup>();
    
    if (filter.equals("%")) {
        filteredGroups.addAll(allUserGroups);
    } else {
        for (UserGroup userGroup : allUserGroups) {
            // TODO: JoSQL library should be used 
            if (userGroup.getName().startsWith(filter)) {
                filteredGroups.add(userGroup);
            }
        }
    }
    
    // Fill userIdsByParticipantList list
    Set<BigDecimal> userIdsByParticipantList = new HashSet<BigDecimal>();
    for (UserGroup userGroup : filteredGroups) {
        userIdsByParticipantList.addAll(userGroupDelegate.getRoleUserIds(userGroup.getUserGroupId()));
    }
    return userIdsByParticipantList;
}
private void fillUsersByParticipantList(String filter, List<User> usersList) throws TeamWorksException {
    Collection<UserGroup> allUserGroups = userGroupDelegate.getUserGroups();
	List<UserGroup> filteredGroups = new ArrayList<UserGroup>();
    
    if (filter.equals("%")) {
        filteredGroups.addAll(allUserGroups);
    } else {
        for (UserGroup userGroup : allUserGroups) {
            // TODO: JoSQL library should be used 
            if (userGroup.getName().startsWith(filter)) {
                filteredGroups.add(userGroup);
            }
        }
    }
    //userMap: Used to filter out duplicate users returned for each participant group snapshot
    Map <Long, User> userMap = new HashMap();
    Collection<User> temp;
    // Fill userIdsByParticipantList list
    for (UserGroup userGroup : filteredGroups) {
        temp = userGroupDelegate.getRoleUsers(userGroup.getUserGroupId());
        for(User user : temp){
        	//If a user is already present in the map, dont add to the usersList
        	if(userMap.get(user.getUserID())== null){
        		userMap.put(user.getUserID(), user);
        		usersList.add(user);		
        	}
        }
    } 
}
%>
    <head>
        <title><bean:message key="cs_bulk_usr_attr_assign.title" /></title>
        <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
        <link rel="stylesheet" href="./html/common/tw_console.css" type="text/css" />
		<script type="text/javascript" src="<lsw:ContextRoot zWebAppName='<%=com.ibm.bpm.crconfig.BPMContextRootConfigService.BPM_WARNAME_PROCESSPORTALSUPPORT%>'/>/js/dojo/1.6.1/dojo/dojo.js" djConfig="parseOnLoad:true"></script>
        
        <script type="text/javascript" language="JavaScript">
        dojo.require("dojox.validate.web");
        	function validateAndSubmit(){
        	    if(document.getElementById('viewType_byAttribute').checked){
	        		var selection = document.getElementById("attrDefsId");
	 				var selectedValue = selection.options[selection.selectedIndex].value;
	        		// Check if the attribute selected is "Task Email Address"
	        		if(selectedValue=='51.129fcb3f-baa7-43cd-ad36-36c0917d781c'){
	        		    var emailId = document.frm.attrValText.value;
	        		   	var check = dojox.validate.isEmailAddress(emailId);
	        			if(check){
	        			    return true;
	        			}else{
	        			    alert("<bean:message key="cs_bulk_usr_attr_assign.email.validate" />");
	        			    return false;
	        			}
	        		}else{
	        		    return true;
	        		}
        	    }else if(document.getElementById('viewType_byUser').checked){
        			var emailId = document.frm.elements["attrValByUserText_51.129fcb3f-baa7-43cd-ad36-36c0917d781c"].value;
        			//During update the user could have explicitly left the email id field empty
        			//Note : Have to check if isEmailAddress from dojo conforms to same standards as JavaMail InternetAddress
            	    if(emailId==null||emailId==""){ // No email id provided
            			return true;
            	    }else{ // Email Id is provided
            			var check = dojox.validate.isEmailAddress(emailId);
            			if(check){
    					    return true;
    					}else{
    					    alert("<bean:message key="cs_bulk_usr_attr_assign.email.validate" />");
    					    return false;
    					}
    				}
        	    }
        	}
        	function setViewByAttrVisibility(visible) {
                setDisplayVisible("viewByAttrContentId", visible);                
                setDisplayVisible("viewByUserContentId", !visible);
                
                var viewByAttrId = getHtmlElement("viewByAttrId");
                viewByAttrId.value = visible;
            }

            function enableUserSearchFilter() {
                var userFilterByAttr = getHtmlElement("userFilterByAttr");
                userFilterByAttr.readOnly = false;
                var userGroupFilter = getHtmlElement("userGroupFilter");
                userGroupFilter.readOnly = false;
                var selectedUserGroupButtonId = getHtmlElement("selectedUserGroupButtonId");
                selectedUserGroupButtonId.disabled = false;
            }
            
            function handleKeyPressed(oEvent, sName) {
                if (oEvent.keyCode == 13) { // Enter was pressed
                    getHtmlElement("selectedAttrTextboxId").value = sName;
                    getHtmlElement("thisFormId").submit();
                }
            }
            </script>
    </head>
    <body class="cswelcomebody">
        <form name="frm" id="thisFormId" action="cs_bulk_usr_attr_assign.lsw" method="post">

        <input type="hidden" id="viewByAttrId" name="viewByAttr" value="<%= byAttr %>" />
        <input type="hidden" id="searchButtonId" name="searchButton" value="<%= searchButton %>" />
        <input type="hidden" id="retrieveButtonId" name="retrieveButton" value="<%= retrieveButton %>" />
        <input type="hidden" id="assignButtonId" name="assignButton" value="<%= assignButton %>" />
        <input type="hidden" id="selectedAttrId" name="selectedAttr" />
        <input type="hidden" id="selectedAttrCheckboxId" name="selectedAttrCheckbox" />
        <input type="hidden" id="selectedAttrTextboxId" name="selectedAttrTextbox" />
        <input type="hidden" id="zSaveAllParamsId" name="zSaveAllParams" value="1"/>

        <table width="100%" valign="top" cellpadding="2" cellspacing="0" border="0" style="margin-top:0px">
            <tr><td id="content"><div class="heading"><h1><bean:message key="cs_bulk_usr_attr_assign.title" /></h1></div></tr>
            <tr>
                <td>
                    <table>
                        <tr>
                            <td>
                                <table>
                                    <tr>
                                        <td style="vertical-align:middle">
                                            <input type="radio" name="viewType" value="byAttribute" id="viewType_byAttribute"<%= byAttr ? " checked=\"true\"" : "" %> onclick="setViewByAttrVisibility(this.checked)" />
                                        </td>
                                        <td valign="middle">
                                            <span class="label"><bean:message key="cs_bulk_usr_attr_assign.radio.byAttribute" /></span>
                                        </td>
                                        <td style="vertical-align:middle">
                                            <input type="radio" name="viewType" value="byUser" id="viewType_byUser"<%= !byAttr ? " checked=\"true\"" : "" %> onclick="setViewByAttrVisibility(!this.checked)" />
                                        </td>
                                        <td valign="middle">
                                            <span class="label"><bean:message key="cs_bulk_usr_attr_assign.radio.byView" /></span>
                                        </td>
                                    </tr>
                                </table>
                            </td>
                        </tr>
                        <tr id="viewByAttrContentId">
                            <td>
                                <table cellspacing="0" cellpadding="2" style="margin-left:10px">
                                    <tr>
                                        <td nowrap="nowrap" valign="top">
                                            <table>
                                                <tr>
                                                    <td>
                                                        <div class="cslabel"><bean:message key="cs_bulk_usr_attr_assign.select_attribute" /></div>
                                                    </td>
                                                </tr>
                                                <tr>
                                                    <td nowrap="nowrap">
                                                        <div class="label"><bean:message key="cs_bulk_usr_attr_assign.select_attribute.desc" /></div>
                                                    </td>
                                                </tr>
                                                <tr>
                                                    <td valign="top">
                                                        <select name="attrDefs" id="attrDefsId" size="19" style="width:100%;" onchange="enableUserSearchFilter();this.form.submit()" >
                                                            <%for (Map.Entry<ID<POType.UserAttributeDefinition>, UserAttributeDefinition> entry : userAttrDefsMap.entrySet()) {
                                                                String key = ID.toExternalString(entry.getKey());
                                                            %>
                                                            <option value="<%= key %>"<%= key.equals(request.getParameter("attrDefs")) ? " selected=\"selected\"" : "" %>><%= resolvedNames.get(((UserAttributeDefinition) entry.getValue()).getGuid()) %></option>
                                                            <%}%>
                                                        </select>
                                                    </td>
                                                </tr>
                                            </table>
                                        </td>
                                        <td nowrap="nowrap" valign="top">
                                            <table>
                                                <tr>
                                                    <td>
                                                        <div class="cslabel"><bean:message key="cs_bulk_usr_attr_assign.select_user" /></div>
                                                    </td>
                                                </tr>
                                                <tr>
                                                    <td nowrap="nowrap">
                                                        <div class="label"><bean:message key="cs_bulk_usr_attr_assign.select_user.desc" /></div>
                                                    </td>
                                                </tr>
                                                <tr>
                                                    <td valign="top">
                                                        <table width="100%">
                                                            <tr>
                                                                <td align="right" nowrap="nowrap" width="5%">
                                                                    <div class="cslabel"><bean:message key="cs_bulk_usr_attr_assign.user" /></div>
                                                                </td>
                                                                <td style="width:100px;">
                                                                    <%String userFilterValue = (userFilterByAttr == null) ? "" : " value=\"" + userFilterByAttr + "\"";%>
                                                                    <input type="text" name="userFilterByAttr" id="userFilterByAttr"<%= userFilterValue %><%= attrDefId != null ? "" : " readonly=\"readonly\"" %> />
                                                                </td>
                                                                <td>
                                                                </td>
                                                            </tr>
                                                            <tr>
                                                                <td align="right" nowrap="nowrap">
                                                                    <div class="cslabel"><bean:message key="cs_bulk_usr_attr_assign.participantGroup" /></div>
                                                                </td>
                                                                <td nowrap="nowrap" style="width:100px;">
                                                                    <%String userGroupFilterValue = (userGroupFilter == null) ? "" :" value=\"" + userGroupFilter + "\"";  %>
                                                                    <input type="text" name="userGroupFilter" id="userGroupFilter"<%= userGroupFilterValue %><%= attrDefId != null ? "" : " readonly=\"readonly\"" %> />
                                                                </td>
                                                                <td nowrap="nowrap">
                                                                    <input type="submit" id="selectedUserGroupButtonId" name="selectedUserGroupButton" value='<bean:message key="cs_bulk_usr_attr_assign.button_search" />' class="button"<%= attrDefId != null ? "" : " disabled=\"disabled\"" %> onclick="getHtmlElement('searchButtonId').value='true'" />
                                                                </td>
                                                            </tr>
                                                        </table>
                                                        <div style="height:200px;width:315px;overflow:auto;border:1px solid #7F9DB9;">
                                                            <table width="100%" cellspacing="0" cellpadding="0" style="margin-top:5px">
                                                                <tr valign="top">
                                                                    <td><div class="cslabel"><bean:message key="cs_bulk_usr_attr_assign.user.text" /></div></td>
                                                                    <td><div class="cslabel"><bean:message key="cs_bulk_usr_attr_assign.user.current_attribute" /></div></td>
                                                                </tr>
                                                                <%if (usersListByAttr.size() > 0) {
                                                                    for (User user : usersListByAttr) {
                                                                        ID<POType.User> uid = ID.get(POType.User, new BigDecimal(user.getUserID()));
                                                                %>
                                                                <tr valign="top">
                                                                    <td valign="middle">
                                                                        <input type="checkbox" name="selectedUserByAttr" value="<%= ID.toExternalString(uid) %>"<%= selectedUserIds.contains(uid) ? " checked=\"true\"" : "" %> />
                                                                        <span class="label"><%= user.getUserName() %></span>
                                                                    </td>
                                                                    <td valign="middle">
                                                                    <%
                                                                        String uadv = user2AttrMap.get(uid);
                                                                        String attrValue = bundle.getMessage(currentLocale, "cs_bulk_usr_attr_assign.noAttributeValue");
                                                                        if (uadv != null) {
                                                                            attrValue = uadv;
                                                                        }
                                                                    %>
                                                                        <span class="label"><%= attrValue %></span>
                                                                    </td>
                                                                </tr>
                                                                    <%}%>
                                                                <%} else if (searchButton != null && searchButton.equalsIgnoreCase("true")) { %>
                                                                    <tr valign="top">
                                                                        <td colspan="2">
                                                                            <span class="label"><em><bean:message key="cs_bulk_usr_attr_assign.noUserFound" /></em></span>
                                                                        </td>
                                                                    </tr>
                                                                <%}%>
                                                            </table>
                                                        </div>
                                                    </td>
                                                </tr>
                                            </table>
                                        </td>
                                    </tr>
                                    <tr>
                                        <td>&nbsp;</td>
                                        <td>
                                            <table>
                                                <tr>
                                                    <td>
                                                        <div class="cslabel"><bean:message key="cs_bulk_usr_attr_assign.assign_value_to_user" /></div>
                                                    </td>
                                                </tr>
                                                <tr>
                                                    <td>
                                                        <div class="label"><bean:message key="cs_bulk_usr_attr_assign.assign_value_to_user.desc" /></div>
                                                    </td>
                                                </tr>
                                                <tr>
                                                    <td nowrap="nowrap">
                                                        <span class="label"><bean:message key="cs_bulk_usr_attr_assign.assign_value_to_user.value" /></span>
                                                        <%
                                                            if (attrDefId != null) {
                                                                // Figure out how control will be rendered
                                                                UserAttributeDefinition uad = userAttrDefsMap.get(attrDefId);
                                                        	try{
                                                                TWClass twClass = TWClassFactory.getInstance().findByPrimaryKey(uad.getVersioningContext(), uad.getClassRef());
															    long valuesSource = uad.getValuesSource().longValue();
                                                                if (valuesSource == UserAttributeDefinition.VALUES_SOURCE_ANY_ALLOWED) {
                                                                    // Render text box
                                                        %>
                                                        <input type="text" name="attrValText" style="width:150px" />
                                                        <%
                                                                } else if (twClass.isBaseTypeBoolean()) {
                                                                    // Render checkbox
                                                        %>
                                                        <input type="checkbox" name="attrValCheckbox" value="true" />
                                                        <%
                                                                } else if (valuesSource == UserAttributeDefinition.VALUES_SOURCE_LIST) {
                                                                    // Render list
                                                        %>
                                                        <select id="attrValsId" name="attrVals" style="width:150px">
                                                        <%
                                                                    for (UserAttributeDefValue attrDefValue : attrDefValues) {
                                                        %>
                                                            <option value="<%= ID.toExternalString(attrDefValue.getId()) %>"><%= attrDefValue.getValue() %></option>
                                                        <%
                                                                    }
                                                        %>
                                                        </select>
                                                        <%
                                                                }
                                                                }
                                                                catch(TeamWorksException twe){
                                                                   // twe.getMessageKey().equals("server.ejb.persistence.AbstractDAO.not_found");
                                                                   String selectedAttribute = new String(resolvedNames.get(uad.getGuid()));
                                                                   throw new TeamWorksException("'" + selectedAttribute + "'" + bundle.getMessage(currentLocale, "cs_bulk_usr_attr_assign.uad_ref_unresolved") );
                                                                }
                                                                
                                                            } else {
                                                        %>
                                                        <select id="attrValsId" name="attrVals" style="width:150px">
                                                            <option value="-1"><bean:message key="cs_bulk_usr_attr_assign.assign_value_to_user.attribute_select" /></option>
                                                        </select>
                                                        <%  } %>
                                                        <input type="submit" name="assignByAttribute" value="<bean:message key="cs_bulk_usr_attr_assign.assign" />" class="button" onclick="getHtmlElement('assignButtonId').value='true';return validateAndSubmit()" />
                                                    </td>
                                                </tr>
                                                <%
                                                    if (assignmentError != null) {
                                                %>
                                                <tr><td><div class="errortype"><%= assignmentError %></div></td></tr>
                                                <%
                                                    }
                                                %>
                                            </table>
                                        </td>
                                    </tr>
                                </table>
                            </td>
                        </tr>
                        <tr id="viewByUserContentId">
                            <td>
                                <table cellspacing="0" cellpadding="2" style="margin-left:10px">
                                    <tr>
                                        <td nowrap="nowrap" valign="top">
                                            <table>
                                                <tr>
                                                    <td>
                                                        <div class="cslabel"><bean:message key="cs_bulk_usr_attr_assign.select_a_user" /></div>
                                                    </td>
                                                </tr>
                                                <tr>
                                                    <td nowrap="nowrap">
                                                        <div class="label"><bean:message key="cs_bulk_usr_attr_assign.select_a_user.edit" /></div>
                                                    </td>
                                                </tr>
                                                <tr>
                                                    <td>
                                                        <table>
                                                            <tr>
                                                                <td nowrap="nowrap">
                                                                    <div class="cslabel"><bean:message key="cs_bulk_usr_attr_assign.select_a_user.user_filter" /></div>
                                                                </td>
                                                                <td style="width:100px">
                                                                    <%String userFilterByUserValue = (userFilterByUser == null) ? "" : " value=\"" + userFilterByUser + "\"";%>
                                                                    <input type="text" name="userFilterByUser" id="userFilterByUser"<%= userFilterByUserValue %> />
                                                                </td>
                                                                <td>
                                                                    <input type="submit" name="retrieveUsersButton" value="<bean:message key="cs_bulk_usr_attr_assign.select_a_user.retrieve" />" class="button" onclick="getHtmlElement('retrieveButtonId').value='true'" />
                                                                </td>
                                                            </tr>
                                                        </table>
                                                    </td>
                                                </tr>
                                                <tr>
                                                    <td valign="top">
                                                        <select name="usersList" id="usersListId" size="16" style="width:100%;" onchange="this.form.submit()" >
                                                            <%
                                                              for (User user : usersListByUser) {
                                                                  ID<POType.User> uid = ID.get(POType.User, new BigDecimal(user.getUserID()));
                                                            %>
                                                            <option value="<%= ID.toExternalString(uid) %>"<%= uid.equals(userId) ? " selected=\"selected\"" : "" %>><%= user.getUserName() %></option>
                                                            <%}%>
                                                        </select>
                                                    </td>
                                                </tr>
                                            </table>
                                        </td>
                                        <td nowrap="nowrap" valign="top">
                                            <table>
                                                <tr>
                                                    <td>
                                                        <div class="cslabel"><bean:message key="cs_bulk_usr_attr_assign.assign_atrribute_values" /></div>
                                                    </td>
                                                </tr>
                                                <tr>
                                                    <td nowrap="nowrap">
                                                        <div class="label"><bean:message key="cs_bulk_usr_attr_assign.assign_atrribute_values.edit" /></div>
                                                    </td>
                                                </tr>
                                                <tr>
                                                    <td valign="top">
                                                        <table width="100%">
                                                            <tr>
                                                                <%
                                                                  String userIdValue = "";
                                                                  String userNameValue = "";
                                                                  String fullNameValue = "";
                                                                  
                                                                  if (userId != null) {
                                                                      User user = userGroupDelegate.findUserById(ID.getBigDecimal(userId));
                                                                      userIdValue = ID.getBigDecimal(userId).toString();
                                                                      userNameValue = user.getUserName();
                                                                      fullNameValue = user.getFullName();
                                                                  }
                                                                %>
                                                                <td align="left" width="5%" nowrap="nowrap">
                                                                    <div class="cslabel"><bean:message key="cs_bulk_usr_attr_assign.assign_atrribute_values.edit.userId" /></div>
                                                                </td>
                                                                <td>
                                                                    <input type="text" name="userIdText" value="<%= userIdValue %>" readonly="readonly" style="width:100%" />
                                                                </td>
                                                            </tr>
                                                            <tr>
                                                                <td align="left" nowrap="nowrap">
                                                                    <div class="cslabel"><bean:message key="cs_bulk_usr_attr_assign.assign_atrribute_values.edit.userName" /></div>
                                                                </td>
                                                                <td>
                                                                    <input type="text" name="userNameText" value="<%= userNameValue %>" readonly="readonly" style="width:100%" />
                                                                </td>
                                                            </tr>
                                                            <tr>
                                                                <td align="left" nowrap="nowrap">
                                                                    <div class="cslabel"><bean:message key="cs_bulk_usr_attr_assign.assign_atrribute_values.edit.fullName" /></div>
                                                                </td>
                                                                <td>
                                                                    <input type="text" name="userFullNameText" value="<%= fullNameValue %>" readonly="readonly" style="width:100%" />
                                                                </td>
                                                            </tr>
                                                        </table>
                                                        <hr />
                                                        <div style="width:400px;overflow:auto;">
                                                            <table width="100%" cellspacing="0" cellpadding="2" style="margin-top:5px">
                                                                <tr valign="top">
                                                                    <td colspan="2"><div class="cslabel"><bean:message key="cs_bulk_usr_attr_assign.customAttributes" /></div></td>
                                                                </tr>
                                                                <% if (userId != null) {
                                                                    for (Map.Entry<ID<POType.UserAttributeDefinition>, UserAttributeDefinition> entry : userAttrDefsMap.entrySet()) {
                                                                        List<UserAttributeDefValue> attrValuesList = attrDef2ValuesMap.get(entry.getKey());
                                                                        UserAttributeDefinition uad = entry.getValue();
                                                                %>
                                                                <tr valign="top">
                                                                    <td valign="middle">
                                                                        <span class="label"><%= resolvedNames.get(uad.getGuid()) %></span>
                                                                    </td>
                                                                    <td valign="middle">
                                                                        <%
                                                                            // Figure out how control will be rendered
                                                                            TWClass twClass = TWClassFactory.getInstance().findByPrimaryKey(uad.getVersioningContext(), uad.getClassRef());

                                                                            if (uad.getValuesSource().longValue() == UserAttributeDefinition.VALUES_SOURCE_ANY_ALLOWED) {
                                                                                // Render text box
                                                                                String value = "";
                                                                                Collection<UserAttribute> attributes = userAttributeFactory.findByUser(userId);

                                                                                for (UserAttribute attr : attributes) {
                                                                                    if (attr.getUserAttrDefId().equals(uad.getId()) && attr.getAttrValue() != null) {
                                                                                        value = attr.getAttrValue(); // break intentionally is not provided
                                                                                    }
                                                                                }
                                                                        %>
                                                                        <input type="text" name="attrValByUserText_<%= ID.toExternalString(entry.getKey()) %>" value="<%= value %>" style="width:150px" />
                                                                        <%
                                                                        } else if (twClass.isBaseTypeBoolean()) {
                                                                            // Render checkbox
                                                                            // Need to get value
                                                                            boolean checked = false;
                                                                            Collection<UserAttribute> attributes = userAttributeFactory.findByUser(userId);
                                                                            
                                                                            for (UserAttribute attr : attributes) {
                                                                                if (attr.getUserAttrDefId().equals(uad.getId())) {                                                                                
                                                                                    checked = Boolean.parseBoolean(attr.getAttrValue());
                                                                                    // TODO: what about break here???
                                                                                }
                                                                            }
                                                                        %>
                                                                        <input type="hidden" name="attrValByUserCheckboxExpected_<%= ID.toExternalString(entry.getKey()) %>" value="1"/>
                                                                        <input type="checkbox" name="attrValByUserCheckbox_<%= ID.toExternalString(entry.getKey()) %>" value="true"<%= checked ? " checked=\"checked\"" : "" %> />
                                                                        <%
                                                                        } else if (uad.getValuesSource().longValue() == UserAttributeDefinition.VALUES_SOURCE_LIST) {
                                                                            // Render list
                                                                        %>
                                                                        <select name="attrValuesByUser_<%= ID.toExternalString(entry.getKey()) %>" style="width:150px">
                                                                            <% // Check if this list contains selected attribute value
                                                                               boolean containsSelected = false;
                                                                               for (UserAttributeDefValue value : attrValuesList) {
                                                                                   ID<POType.UserAttributeDefinitionValue> assignedValueId = attrDef2AssignedValIdMap.get(entry.getKey());
                                                                                   if (value.getId().equals(assignedValueId)) {
                                                                                       containsSelected = true;
                                                                                       break;
                                                                                   }
                                                                               }
                                                                               if (!containsSelected) {
                                                                            %>
                                                                            <option value="-1">-Select Attribute-</option>
                                                                             <%}%>
                                                                            <%for (UserAttributeDefValue value : attrValuesList) {
                                                                                ID<POType.UserAttributeDefinitionValue> assignedValueId = attrDef2AssignedValIdMap.get(entry.getKey());
                                                                            %>
                                                                            <option value="<%= ID.toExternalString(value.getId()) %>"<%= value.getId().equals(assignedValueId) ? " selected=\"selected\"" : "" %>><%= value.getValue() %></option>
                                                                            <%}%>
                                                                        </select>
                                                                        <%	
                                                                        }
                                                                        %>
                                                                    </td>
                                                                </tr>
                                                                  <%}%>
                                                                <tr><td colspan="2" align="center"><input type="submit" name="updateButton" value='<bean:message key="cs_bulk_usr_attr_assign.button_update"/>' onClick="return validateAndSubmit()"/></td></tr>
				                                                <%
				                                                    if (assignmentError != null) {
				                                                %>
				                                                <tr><td colspan="2" align="center"><div class="errortype"><%= assignmentError %></div></td></tr>
				                                                <%
				                                                    }
				                                                %>                                                                
                                                                <%}%>
                                                            </table>
                                                        </div>
                                                    </td>
                                                </tr>
                                            </table>
                                        </td>
                                    </tr>
                                </table>
                            </td>
                        </tr>
                    </table>
                </td>
            </tr>
        </table>
        </form>
    </body>
</html>
<script language="JavaScript">
    setDisplayVisible("viewByAttrContentId", <%= byAttr %>);
    setDisplayVisible("viewByUserContentId", <%= !byAttr %>);
</script>
