<%@ page language="java" pageEncoding="UTF-8" contentType="text/html; charset=UTF-8"%>
<%@ include file="/html/msgs-init.jsp" %>
<%@ include file="/html/common/prolog.jsp" %>
<html>
<head>
<title><bean:message key="cs_instrumentation.title" /></title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<script src="<lsw:ContextRoot zWebAppName='<%=com.ibm.bpm.crconfig.BPMContextRootConfigService.BPM_WARNAME_PROCESSPORTALSUPPORT%>'/>/js/dojo/1.6.1/dojo/dojo.js" type="text/javascript"></script>
<%@ include file="/script/instrumentation.jsp" %>
<script type="text/javascript">
var inst = new Instrumentation('inst', 'images/', 'instrumentations', 'documentationpopup', 'logfilepath',
        ['refresh.1', 'refresh.2'], ['reset.1', 'reset.2'], ['logging.1'],
        <%= !"false".equalsIgnoreCase(request.getParameter("userVisibleOnly")) %>, 'error');
		
function init() {
	document.getElementById('error').style.display = 'none';
	inst.init();
}
</script>
</head>
<LINK REL="stylesheet" HREF="./html/common/tw_console.css" TYPE="text/css">
<body onload="init();">
<table width="100%" valign="top" cellpadding="2" cellspacing="0" border="0" style="margin-top:0px">
<tr>
	<td id="content">
		<div class="heading"><h1><bean:message key="cs_instrumentation.title" /></h1></div>
	</td>
</tr>
    <form name="instrumentation0" action="cs_instrumentation.lsw" method="GET">
        <tr>
            <td class="instrumentation" >
                <button id="logging.1" onclick="inst.toggleLogging(); return false;"><bean:message key="cs_instrumentation.startLogging" /></button>
                <span id="logfilepath"></span> 
            </td>
        </tr>
        <tr>
            <td class="instrumentation" >
                <button id="refresh.1" class="button" onclick="inst.refresh(); return false;"><bean:message key="cs_instrumentation.button_refresh" /></button>
                <button id="reset.1" class="button" onclick="inst.reset(); return false;"><bean:message key="cs_instrumentation.button_reset" /></button>
                <bean:message key="cs_instrumentation.descSelete" />
                <select id="auto.1" onclick="inst.setAutoRefresh(this)">
                    <option value="0"><bean:message key="cs_instrumentation.select_option1" /></option>
                    <option value="30"><bean:message key="cs_instrumentation.select_option2" /></option>
                    <option value="60"><bean:message key="cs_instrumentation.select_option3" /></option>
                    <option value="300"><bean:message key="cs_instrumentation.select_option4" /></option>
                    <option value="600"><bean:message key="cs_instrumentation.select_option5" /></option>
                </select>
            </td>
        </tr>
    </form>
    <tr><td>
        <table width="100%" class="content-table" cellpadding="2">
            <thead><tr>
                <th><bean:message key="cs_instrumentation.table_th1" /></th>
                <th><bean:message key="cs_instrumentation.table_th2" /></th>
                <th><bean:message key="cs_instrumentation.table_th3" /></th>
                <th><bean:message key="cs_instrumentation.table_th4" /></th>
                <th><bean:message key="cs_instrumentation.table_th5" /></th>
                <th><bean:message key="cs_instrumentation.table_th6" /></th>
            </tr>
            </thead>
            <tbody id="instrumentations">
            </tbody>
        </table>

    </td></tr>
    <tr><td class="instrumentation" >
        <form name="instrumentation1" action="cs_instrumentation.lsw" method="GET">
            <button id="refresh.2" class="button" style="width:auto" onclick="inst.refresh(); return false;"><bean:message key="cs_instrumentation.button_refresh" /></button>
            <button id="reset.2" class="button" style="width:auto" onclick="inst.reset(); return false;"><bean:message key="cs_instrumentation.button_reset" /></button>
        </form>
		<div id="error" class="errortype" />
    </td></tr>
</table>
<div class="docpopup" id="documentationpopup"></div>
</body>
</html>
