<%@ page language="java" pageEncoding="UTF-8" contentType="text/html; charset=UTF-8"%>
<%@ include file="common/prolog.jsp" %>
<%@ include file="/html/msgs-init.jsp" %>
<%@ page import="java.util.*,
	com.lombardisoftware.client.delegate.SecurityDelegateFactory,
	com.lombardisoftware.servlet.util.*,
	com.lombardisoftware.core.*,
	com.lombardisoftware.client.persistence.*,
	com.lombardisoftware.client.persistence.common.ID,
	com.lombardisoftware.client.persistence.common.versioning.VersioningContext,
	java.math.BigDecimal" %>
<html>
<head>
<title><bean:message key="cs_m_uset.title" /></title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<script language="JavaScript">
<!--
function ListEntry(id, uname, fullname, calendar, attrs) {
this.id = id;
this.uname = uname;
this.fullname = fullname;
this.calendar = calendar;
this.attrs = attrs;
}

function AttributeEntry(name, value) {
this.name = name;
this.value = value;
}

function AttributeDefinition(id, name) {
this.id = id;
this.name = name;
}

function compareEntry(a, b) {
var na = a.name.toLowerCase();
var nb = b.name.toLowerCase();
if (na < nb)
  return -1;
else if (na > nb)
  return 1
else
  return 0;
}

var arrayAll = new Array();
var attrDefinitions = new Array();

<%
	List attrDefinitions = UserAttributeDefinitionFactory.getInstance().findAll(VersioningContext.invalid);
	if (attrDefinitions != null) {
	    Iterator iter = attrDefinitions.iterator();
	    while (iter.hasNext()) {
	        UserAttributeDefinition current = (UserAttributeDefinition) iter.next();
%>	       
attrDefinitions[attrDefinitions.length] = new AttributeDefinition("<%= current.getId() %>", "<%= current.getName() %>"); 
<%
	    }
	}
%>


<%
if ((request.getParameter("zRetDone") != null) && (request.getParameter("zFilter") != null) && (!request.getParameter("zFilter").equals(""))) {
 Collection users = SecurityDelegateFactory.getInstance().newInstance().listUsersWithFilter(request.getParameter("zFilter"));
 for(Iterator it = users.iterator(); it.hasNext();) {
   UserInfo user = (UserInfo)it.next();
   ID userId = user.getUserId();
   String userName = StringUtilities.replaceString(user.getQualifiedName(), "\"", "\\\"", false);
   userName = StringUtilities.replaceCharByString(userName, '\\', "\\\\");
   String fullName = StringUtilities.replaceString(user.getFullname(), "\"", "\\\"", false);
   fullName = StringUtilities.replaceCharByString(fullName, '\\', "\\\\");
   ID calendarId = user.getCalendarId();

%>
arrayAttrs = new Array();
<%
   Map attrMap = SecurityDelegateFactory.getInstance().newInstance().getUserAttributes(userId);
   for(Iterator it2 = attrMap.keySet().iterator(); it2.hasNext();) {
     String name = (String)it2.next();
     String value = (String)attrMap.get(name);
     // Ignore special attributes
     if (!UserAttribute.isSpecial(name)) {
%>
arrayAttrs[arrayAttrs.length] = new AttributeEntry("<%= name %>", "<%= value %>");
<%
      }
    }
%>
arrayAttrs.sort(compareEntry);
arrayAll[arrayAll.length] = new ListEntry(<%= ID.getBigDecimal(userId) %>,"<%= userName %>", "<%= fullName %>", "<%= ID.getBigDecimal(calendarId) %>", arrayAttrs);
<%
  }
}
%>

function doFillDetails(obj) {
 var id = 0;
 if (obj != null) {
   id = obj.options[obj.selectedIndex].value;;
 }
 for(i = 0; i < arrayAll.length; i++) {
  var user = arrayAll[i];
  if (user.id == id) {
    document.frm.zUserId.value = user.id;
    document.frm.zUserName.value = user.uname;
    document.frm.zFullName.value = user.fullname;
    document.frm.updateB.disabled = false;
    if (document.frm.zCalendar != null) {
	   var calobj = document.frm.zCalendar;
	   calobj.selectedIndex = 0;
	   for(j = (calobj.options.length - 1); j >= 0; j--) {
		if (calobj.options[j].value == user.calendar)
		 calobj.options[j].selected = true;
	   }
    }
    document.frm.updateB.disabled = false;
    setupAttributes(user.attrs);
    return;
   }
 }
}

function doOnLoad(){
document.frm.Userlist.selectedIndex = -1;
 if (document.frm.zCalendar != null) {
	 var pCalendar = "<%= request.getParameter("zCalendar") %>";
	 var calobj = document.frm.zCalendar;
	 for(i = (calobj.options.length - 1); i >= 0; i--) {
	   if (calobj.options[i].value == pCalendar)
		 calobj.options[i].selected = true;
	 }
 }
<% if(request.getParameter("zMessage") == null) { %>
  doClean();
 <%}else{%>
 <%}%>
 document.frm.zFilter.focus();
}

function doClean() {
document.frm.zUserId.readOnly = true;
document.frm.zUserId.style.backgroundColor = "silver";
document.frm.zUserName.readOnly = true;
document.frm.zUserName.style.backgroundColor = "silver";
document.frm.zFullName.readOnly = true;
document.frm.zFullName.style.backgroundColor = "silver";
document.frm.zUserId.value = "";
document.frm.zUserName.value = "";
document.frm.zFullName.value = "";
if (document.frm.zCalendar != null) document.frm.zCalendar.selectedIndex = 0;
document.frm.updateB.disabled = true;
document.frm.Userlist.selectedIndex = -1;
}

function doRet() {
 document.location.href = "cs_m_uset.lsw?zRetDone=1&zFilter=" +
   escape(document.frm.zFilter.value);
 return false;
}

function doProfile() {
// document.frm.retB.focus();
}
function checkEnter(e){ //e is event object passed from function invocation
var characterCode;
if (e && e.which){ //if which property of event object is supported (NN4)
  e = e;
  characterCode = e.which //character code is contained in NN4's which property
} else {
	e = event;
	characterCode = e.keyCode; //character code is contained in IE's keyCode property
}

if (characterCode == 13){ //if generated character code is equal to ascii 13 (if enter key)
	return doRet(); // Retrieve data
} else {
	return true;
}
}

var numRows = 0;

function createAttributeRow(attrDefinition, value) {
numRows++;

var v = document.createElement("input");
v.setAttribute("id","zAttrName_" + attrDefinition.id);
v.setAttribute("name","zAttrName_" + attrDefinition.id);
if (value != null) v.setAttribute("value",value);

var tr = document.createElement("tr");
var td2 = document.createElement("td");
td2.setAttribute("valign","top");
td2.innerHTML = "<div class='cslabel'>" + attrDefinition.name + "</div>";

var td3 = document.createElement("td");
td3.appendChild(v);
td3.setAttribute("valign","top");
tr.appendChild(td2);
tr.appendChild(td3);

  return tr;
}

function getTBody() {
var t = document.getElementById("attrs");
var tb = t.getElementsByTagName("tbody").item(0);
// Netscape6 usually has this as null, so let's create a TBODY...
if (tb == null) {
  tb = document.createElement("tbody");
  t.appendChild(tb);
}
return tb;
}

function addAttribute() {
var tb = getTBody();
tb.appendChild(createAttributeRow());
}

function removeAttributes() {
var removeNodes = new Array();
var tb = getTBody();
var rows = tb.childNodes;
// First row is <TH>
for(i = 1; i < rows.length; i++) {
  var cb = rows[i].firstChild.firstChild;
  if (cb.checked) {
    removeNodes[removeNodes.length] = rows[i];
  }
}
for(i = 0; i < removeNodes.length; i++) {
  tb.removeChild(removeNodes[i]);
}
}

function getAttributeValue(attrs, attrName) {
   for(var jj = 0; jj < attrs.length; jj++) {
      if (attrName == attrs[jj].name) {
         return attrs[jj].value;
      }
   }
   
   return null;
}

function setupAttributes(attrs) {
var tb = getTBody();
// Remove current rows
while (tb.childNodes.length > 0) {
  tb.removeChild(tb.lastChild);
}

for(i = 0; i < attrDefinitions.length; i++) {
   tb.appendChild(createAttributeRow(attrDefinitions[i], getAttributeValue(attrs, attrDefinitions[i].name)));
}

var image = getAttributeValue(attrs, "Image");
if (image == null || image == "") {
	document.getElementById("personImage").src = "images/blank.gif";
} else {
	document.getElementById("personImage").src = image;
}
}
-->
</script>
</head>
<LINK REL="stylesheet" HREF="<%= com.lombardisoftware.core.PortalSkinUtilities.getPortalSkinPath(request) %>/tw_console.css" TYPE="text/css">
<body class="cswelcomebody" onload='doOnLoad();'>
<form name="frm" method=post action='cs_m_uset.lsw'>
<input type="hidden" name="zObject" value="UserSetting">
<input type="hidden" name="zType" value="1">
<input type="hidden" name="zActivity" value="Change">
<input type="hidden" name="zRetDone" value='<%= request.getParameter("zRetDone")%>'>
<input type="hidden" name="zPost" value="1">
<input type="hidden" name="zAction" value="add">
<table width="100%" valign="top" cellpadding="2" cellspacing="0" border="0" style="margin-top:0px">
<tr><td id="content"><div class="heading"><h1><bean:message key="cs_m_uset.title" /></h1></div></tr>
<tr><td>
<table style="margin-left:5" cellpadding="2" cellspacing="0" border="0">
 <tr><td valign="bottom" height="25"><div class="cslabel">&nbsp;<bean:message key="cs_m_uset.retrieveProfile" /></div><tr>
 <tr><td><input style="width:168" type="text" name="zFilter" value='<%= (request.getParameter("zFilter") == null ? "" : request.getParameter("zFilter")) %>' onblur="return  doProfile();"  onKeyPress="return checkEnter(event);"><input name="retB" class="button" type="button" value='<bean:message key="cs_m_uset.button_retrieve" />' onClick="doRet()"></TD><tr>
  <td valign="top"><div class="cslabel">&nbsp;<bean:message key="cs_m_uset.users" /><br></div>
  <table><tr><td>
   <select size="<lsw:hasMultiCalendar><lsw:True>32</lsw:True><lsw:False>30</lsw:False></lsw:hasMultiCalendar>" style="width:260" name="Userlist" onChange="return doFillDetails(this);">
<script>
 var zUserId = "<%= request.getParameter("zUserId")%>";
 for(i = 0; i < arrayAll.length; i++) {
   document.write("<OPTION VALUE='" + arrayAll[i].id +"'");
   if (arrayAll[i].id == zUserId)
     document.write(" SELECTED");
   document.write(">" + arrayAll[i].uname + "</OPTION>\n");
 }
</script>
   </select>
   </td></tr></table>
   <br></div>
 </td>
<td valign="top"><div class="cslabel">&nbsp;&nbsp;<bean:message key="cs_m_uset.userDetails" /></div>
 <table cellpadding="2" cellspacing="0" border="0" style="border:solid gray 1px;margin:5px;width:355px">
  <tr><td colspan="2" align="right"><img id="personImage" src="images/blank.gif" /></td></tr>  
  <tr><td width="120"><div class="cslabel"><bean:message key="cs_m_uset.userID" /></div></td><td align="right"><input style="width:260;background-color:silver" type="text" readOnly name="zUserId" value='<%= (request.getParameter("zUserId") == null ? "" : request.getParameter("zUserId")) %>'></td></tr>
  <tr><td><div class="cslabel"><bean:message key="cs_m_uset.userName" /></div></td><td align="right"><input style="width:260;background-color:silver" type="text" readOnly  name="zUserName" value='<%= (request.getParameter("zUserName") == null ? "" : request.getParameter("zUserName")) %>'></td></tr>
  <tr><td><div class="cslabel"><bean:message key="cs_m_uset.fullName" /></div></td><td align="right"><input style="width:260;background-color:silver" type="text" readOnly name="zFullName" value='<%= (request.getParameter("zFullName") == null ? "" : request.getParameter("zFullName")) %>'></td></tr>
<lsw:hasMultiCalendar>
<lsw:True>
<tr><td><div class="cslabel"><bean:message key="cs_m_uset.calendar" /></div></td><td align="right">
<select style="width:260" name="zCalendar">
 <option value='-1'><bean:message key="cs_m_uset.no_calendar_desc" /></option>
 <lsw:CalendarList>
 <option value="<lsw:CalendarId/>"><lsw:CalendarName/></option>
 </lsw:CalendarList>
</select></td></tr>
</lsw:True>
</lsw:hasMultiCalendar>

<tr><td colspan=2>
<hr/>
<p></p>
<div class="cslabel"><bean:message key="cs_m_uset.customAttributes" /></div>
<div style="margin:2px; height:255px; overflow:scroll">
<table cellspacing="2" cellpadding="0" id="attrs" width="100%">
</table>
</div>


</td></tr>
</table>
</td></tr>
<tr><td></td><td align=center><input name="updateB" class="button"
 <%if(request.getParameter("zUpdate") == null) {%>
 disabled
 <%}%>
 type="submit" value='<bean:message key="cs_m_uset.button_update" />'>
 </td></tr>
 </table>
<div style="position:absolute;left:181px;top:61px"></div>
</form>
<lsw:ErrorMessage><lsw:True><div id="error" class="errortype">&nbsp;<bean:message key="process_server.error.desc" /><span class="errmsg">&nbsp;&nbsp;<lsw:Text/></span></div></lsw:True><lsw:False></lsw:False></lsw:ErrorMessage>
</td></tr>
<tr><td>
<table class=cshlp cellpadding=2 cellspacing="0">
<tr><td class=cshlp><div class="lbl"><bean:message key="cs_m_uset.lbl" /></div></td></tr>
<tr><td class=cshlptxt><div class="info1"><bean:message key="cs_m_uset.info_desc" /><br>
<li><bean:message key="cs_m_uset.info_li1" /></li>
<li><bean:message key="cs_m_uset.info_li2" /></li>
</td></tr>
</div></table>
</table>
</body></html>