<%@ page language="java" pageEncoding="UTF-8" contentType="text/html; charset=UTF-8"%>
<%@ page import="com.lombardisoftware.server.scheduler.SchedulerStatus"%>
<%@ include file="/html/common/prolog.jsp" %>
<%@ include file="/html/msgs-init.jsp" %>
<lsw:ShowXMLMetaData zType="em-status-report" />
<lsw:SetContext zPath="em-status-report">
<html>
<head>
<title><bean:message key="cs_monitor.title" /></title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
</head>
<LINK REL="stylesheet" HREF="./html/common/tw_console.css" TYPE="text/css">
<LINK REL="stylesheet" HREF="./html/common/table.css" TYPE="text/css">
<body class="cswelcomebody">
<table width="100%" valign="top" cellpadding="2" cellspacing="0" border="0" style="margin-top:0px">
<tr><td id="content"><div class="heading"><h1><bean:message key="cs_monitor.title" /></h1></div></tr>
<tr><td>
<lsw:Equal zPath="./status-code" zValue="0">
<lsw:False><%-- The Scheduler is starting up so is not ready to accept status requests --%>
<form name="monitor1" action="cs_monitor.lsw" method="POST">
<input type="hidden" name="zObject" value="Event">
<input type="hidden" name="zActivity" value="Monitor">
<input type="hidden" name="zPost" value="1"> 
<center>
<table class='content-table' cellspacing=0>
<thead><tr><th><bean:message key="cs_monitor.table_th_schedulerID" /></th><th><bean:message key="cs_monitor.table_th_status" /></th><th><bean:message key="cs_monitor.table_th_jobsExec" /></th></tr></thead><tbody>
<tr>
<td><bean:message key="cs_monitor.table_td_unknown" /></td>
<td align="center">
<img src="<lsw:ImagePrefix/>images/EventManagerMonitor/sched_stopped.gif">
</td>
<td align="center">&nbsp;</td>
<td align="center">&nbsp;</td>
</tr>
<tr><td colspan="5" style="border-width:0px">&nbsp;<br></td></tr>
<td colspan="5" align="center" style="border-width:0px"><input name="zRefresh" class="button" style="width:60" type="submit" value='<bean:message key="cs_monitor.button_refresh" />'></td>
</tr>
</tbody></table></center></form>
</lsw:False>
<lsw:True>
<form name="monitor1" action="cs_monitor.lsw" method="POST">
<input type="hidden" name="zObject" value="Event">
<input type="hidden" name="zActivity" value="Monitor">
<input type="hidden" name="zPost" value="1">
<center>
<table border="0" class="content-table">
<thead><tr><td style="border-width:0px">&nbsp;</td><td><bean:message key="cs_monitor.table_th_schedulerID" /></td><td><bean:message key="cs_monitor.table_th_status" /></td><td><bean:message key="cs_monitor.table_th_connectExpiration" /></td><td><bean:message key="cs_monitor.table_th_jobsExec" /></td></tr></thead>
<tbody><lsw:SetContext zPath="./event-manager">
<tr>
<lsw:Equal zPath="./status-code" zValue="0">  <%-- disabled, values from SchedulerStatus --%>
<lsw:True><td align="center" style="border-width:0px"><bean:message key="cs_monitor.table_td_unabled" /></td></lsw:True>
<lsw:False><td align="center" style="border-width:0px"><input type="checkbox" name="zScheduler" value="<lsw:String zPath="./@id"/>" CHECKED></td></lsw:False>
</lsw:Equal><td><lsw:String zPath="./@name"/></td><td align="center">
<lsw:Equal zPath="./status-code" zValue="1">  <%-- active --%>
 <lsw:True><img src="<lsw:ImagePrefix/>images/EventManagerMonitor/sched_started.gif" alt="Running" title='<bean:message key="cs_monitor.image_running.title" />'></lsw:True>
 <lsw:False>
  <lsw:Equal zPath="./status-code" zValue="2">
   <lsw:True><img src="<lsw:ImagePrefix/>images/EventManagerMonitor/sched_stopped.gif" alt="Paused" title='<bean:message key="cs_monitor.image_paused.title" />'></lsw:True>
    <lsw:False>
     <lsw:Equal zPath="./status-code" zValue="3">
      <lsw:True><img src="<lsw:ImagePrefix/>images/EventManagerMonitor/sched_stopped.gif" alt="Disconnected" title='<bean:message key="cs_monitor.image_disconnected.title" />'></lsw:True>
      <lsw:False><img src="<lsw:ImagePrefix/>images/EventManagerMonitor/sched_stopped.gif" alt="Unknown" title='<bean:message key="cs_monitor.image_unknown.title" />'></lsw:False>
     </lsw:Equal>
    </lsw:False>
  </lsw:Equal>
 </lsw:False>
</lsw:Equal>
</td>
<td align="center"><lsw:Date zPath="./expiration" zDateStyle="medium" zTimeStyle="medium" zLocal="true"/></td>
<td align="center"><lsw:Null zPath="./num-jobs-executing"><lsw:False><lsw:String zPath="./num-jobs-executing"/></lsw:False><lsw:True>&nbsp;</lsw:True></lsw:Null></td>
</lsw:SetContext>
</tr>
<tr><td class="special" colspan="6" align="center" style="border-width:0px"><br>
<b><bean:message key="cs_monitor.totalJobsExecuting" /></b> <lsw:String zPath="./total-num-jobs-executing"/>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<b><bean:message key="cs_monitor.totalJobs" /></b> <lsw:String zPath="./total-num-jobs"/></b><br>
<input name="zRefresh" class="button" type="submit" value='<bean:message key="cs_monitor.button_refresh" />'>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
<input name="zPause" class="button" type="submit" value='<bean:message key="cs_monitor.button_pause" />'>
<input name="zResume" class="button" type="submit" value='<bean:message key="cs_monitor.button_resume" />'>&nbsp;&nbsp;&nbsp;
<input name="zPauseAll" class="button" type="submit" value='<bean:message key="cs_monitor.button_pauseAll" />'>
<input name="zResumeAll" class="button" type="submit" value='<bean:message key="cs_monitor.button_resumeAll" />'>
</td></tr></table></center>
</form>
<table width="100%" class="content-table" cell-padding="2">
<thead><tr>
<th><bean:message key="cs_monitor.table_th1" /></th>
<th><bean:message key="cs_monitor.table_th2" /></th>
<th><bean:message key="cs_monitor.table_th3" /></th>
<th><bean:message key="cs_monitor.table_th4" /></th>
<th><bean:message key="cs_monitor.table_th5" /></th>
<th><bean:message key="cs_monitor.table_th6" /></th>
<th><bean:message key="cs_monitor.table_th7" /></th>
<th><bean:message key="cs_monitor.table_th8" /></th>
<th><bean:message key="cs_monitor.table_th9" /></th>
<th><bean:message key="cs_monitor.table_th10" /></th>
</tr><tbody>
<lsw:SetContext zPath="./job-status/job"><tr>
<td><lsw:String zPath="./job-owner"/></td>
<td><lsw:String zPath="./project-name"/></td>
<td><lsw:String zPath="./snapshot-name"/></td>
<td><lsw:String zPath="./job-name"/></td>
<td><lsw:String zPath="./job-queue"/></td>
<td><lsw:Date zPath="./scheduled-time" zDateStyle="short" zTimeStyle="medium" zLocal="true"/></td>
<td><lsw:Date zPath="./last-scheduled-time" zDateStyle="short" zTimeStyle="medium" zLocal="true"/></td>
<td><lsw:Date zPath="./last-execution-time" zDateStyle="short" zTimeStyle="medium" zLocal="true"/></td>
<td><lsw:Date zPath="./next-scheduled-time" zDateStyle="short" zTimeStyle="medium" zLocal="true"/></td>
<td><lsw:String zPath="./job-status"/></td>
</tr></lsw:SetContext></table>
</lsw:True></lsw:Equal>
</body></html></lsw:SetContext>