<%@ page language="java" pageEncoding="UTF-8" contentType="text/html; charset=UTF-8"%>
<%@ include file="/html/common/prolog.jsp"%>
<%@ include file="/html/msgs-init.jsp" %>
<%
response.setDateHeader("Expires", 0);
response.setHeader("Cache-Control", "no-store"); //HTTP 1.1
response.addHeader("Cache-Control", "no-cache");
response.addHeader("Cache-Control", "must-revalidate");
response.addHeader("Cache-Control", "post-check=0, pre-check=0");
response.setHeader("Pragma", "no-cache"); //HTTP 1.0
response.addHeader("Pragma", "no-store");
%>
<%
/**
 * Common header included on all pages
 * the li with id="current" will be the current page
 */
String jspPage = request.getRequestURI();
String pageName = "";
if (jspPage != null) {
	if (jspPage.matches(".*summary.*")) { 
		pageName = " Summary";
		}
	else if (jspPage.matches(".*processes.*")) {
		pageName = " Processes";
		}
	else if (jspPage.matches(".*services.*")) {
		pageName = " Services";
		}
	else if (jspPage.matches(".*processDetail.*")) {
		pageName = " Process Details";
		}
	else if (jspPage.matches(".*serviceDetail.*")) {
		pageName = " Service Details";
		} 
	else {
		pageName = "";
	}
} else {
	jspPage = "";
}
%>
<html>
<head>
<title><bean:message key="cs_processmonitor.header.title" /></title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<script type="text/javascript">
	function doRefresh(url) {
		window.location=url;
	}
</script>
</head>
<LINK REL="stylesheet" HREF="../html/common/tw_console.css" TYPE="text/css">
<LINK REL="stylesheet" HREF="<lsw:ContextRoot zWebAppName='<%=com.ibm.bpm.crconfig.BPMContextRootConfigService.BPM_WARNAME_TEAMWORKS%>'/>/html/cs_processmonitor/procmon.css" TYPE="text/css">
<body>
<%
	String referralURL = request.getHeader("Referer");
	if (referralURL != null) {
		referralURL = referralURL.replaceAll("\\.jsp","\\.lsw");
		referralURL = referralURL.replaceAll("/html","");
		if (!referralURL.matches(".*\\/cs_processmonitor\\/.*")) {
			// we came from the teamworks nav bar, no back needed
			referralURL = null;
		}
	}
 %>
 <div id="tabhead">
  <h1></h1>
	<div id="tabmenu">
	    <ul>
	      <li <%if (jspPage.matches(".*summary.*")) { %>id="current"<%} %>>
		<a href="summary.lsw"><bean:message key="cs_processmonitor.header.link.summary" /></a>
	      </li>
	      <li <%if (jspPage.matches(".*processes.*") || (jspPage.matches(".*processDetail.*"))) { %>id="current"<%} %>>
		<a href="processes.lsw"><bean:message key="cs_processmonitor.header.link.processes" /></a>
	      </li>
	      <li <%if (jspPage.matches(".*services.*") || (jspPage.matches(".*serviceDetail.*"))) { %>id="current"<%} %>>
		<a href="services.lsw"><bean:message key="cs_processmonitor.header.link.services" /></a>
	      </li>
	    </ul>
	</div>
</div>

<div id="navButtons">
        <input type="button" 
               name="refresh" 
               value='<bean:message key="cs_processmonitor.header.button_refresh" />'
               class="button" 
               onclick="javascript:window.location.reload()"
         >
<% if (referralURL != null) {
%>
        <input type="button" 
               name="back" 
               value='<bean:message key="cs_processmonitor.header.button_back" />'
               class="button" 
               onclick="javascript:window.history.back()"
         >
<%
} 
%>
</div>
