<%@page language="java" pageEncoding="UTF-8" contentType="text/html; charset=UTF-8"%>
<%@page import="java.util.Collection"%>
<%@page import="java.util.List"%>
<%@page import="java.util.ArrayList"%>
<%@page import="java.util.Map"%>
<%@page import="java.math.BigDecimal"%>
<%@page import="javax.servlet.jsp.JspWriter"%>
<%@page import="com.lombardisoftware.core.TeamWorksException"%>
<%@page import="com.lombardisoftware.server.processmonitor.data.Process"%>
<%@page import="com.lombardisoftware.server.processmonitor.data.Service"%>
<%@page import="com.lombardisoftware.server.processmonitor.data.WorkflowUnit"%>
<%@page import="com.lombardisoftware.server.processmonitor.jsp.ProcessMonitorHelper"%>
<%@page import="com.lombardisoftware.server.processmonitor.jsp.FormatHelper"%>
<%@page import="com.lombardisoftware.server.processmonitor.jsp.AbstractProcessEntry"%>
<%@page import="com.lombardisoftware.server.processmonitor.jsp.ProcessEntry"%>
<%@page import="com.lombardisoftware.server.processmonitor.jsp.ServiceEntry"%>
<%@page import="com.lombardisoftware.server.processmonitor.jsp.WorkflowUnitEntry"%>
<%@page import="com.lombardisoftware.server.processmonitor.jsp.bean.TableState"%>
<%@page import="com.lombardisoftware.server.processmonitor.tuple.Tuples"%>
<%@page import="com.lombardisoftware.server.processmonitor.tuple.TupleComparator"%>
<%@page import="com.lombardisoftware.bpd.model.runtime.BPDBusinessProcessDiagram"%>
<%@page import="org.apache.struts.util.MessageResources" %>
<%@page import="org.apache.struts.Globals" %>
<%@page import="org.apache.struts.taglib.TagUtils" %>
<%@ include file="/html/msgs-init.jsp" %>
<jsp:include page="header.jsp"/>
<%
ProcessMonitorHelper pmHelper = ProcessMonitorHelper.getInstance();

String errorCode = (String)pageContext.getSession().getAttribute("service.detail.error.code");
pageContext.getSession().removeAttribute("service.detail.error.code");

String id = request.getParameter("id");

if (id == null) {
    %>
    <p class="failureMessage">
    <bean:message key="cs_processmonitor.serviceDetail.noService" />
    </p>
</body>
</html>
	<%
    return;
}

String serviceId = id;

Service s = pmHelper.getService(id);
if (s == null) {
    %>
    <p class="failureMessage">
    <bean:message key="cs_processmonitor.serviceDetail.noDataAvailable" />
    </p>
</body>
</html>
    <%
    return;
}

FormatHelper formatHelper = new FormatHelper();

ServiceEntry entry = pmHelper.getServiceEntry(s);
%>
	<div class="details">
	<%
	if ("haltTimedOut".equals(errorCode)) {
	    %>
	    <div class="message">
	    <p class="failureMessage">
	    <bean:message key="cs_processmonitor.serviceDetail.fail_haltTimeOut" />
	    </p>
	    </div>
	    <%
	}
	%>
	<h2 class="title"><bean:message key="cs_processmonitor.serviceDetail.serviceDetails" arg0="<%=entry.getDiagramName()%>" /></h2>
	</div>
	<div class="tablediv">
	<table class="name-value" width="100%">
		<tbody>
		<tr>
			<th width="200"><bean:message key="cs_processmonitor.processDetail.serviceName" /></th>
			<td>
				<%=entry.getDiagramName()%>
			</td>
		</tr>
		<tr>
			<th width="200"><bean:message key="cs_processmonitor.serviceDetail.name" /></th>
			<td>
				<%=entry.getProcessAppName()%>
			</td>
		</tr>
		<tr>
			<th><bean:message key="cs_processmonitor.serviceDetail.instanceID" /></th>
			<td>
				<%=entry.getContextGuid()%>
			</td>
		</tr>
		<%
		if (entry.getParentProcessId() != null) {
			Process p = pmHelper.getProcess(entry.getParentProcessId());
			if (p != null) {
				ProcessEntry processEntry = pmHelper.getProcessEntry(p);
			%>
			<tr>
				<th><bean:message key="cs_processmonitor.serviceDetail.parentProcess" /></th>
				<td>
					<a href="processDetail.lsw?id=<%=p.getProcessId()%>"><%=processEntry.getDiagramName()%> (<%=p.getProcessId()%>)</a>
				</td>
			</tr>
		<% }
		}
		%>
		<%
		if (entry.getState() == AbstractProcessEntry.STATE_ACTIVE) {
		%>
		<tr>
			<th><bean:message key="cs_processmonitor.serviceDetail.enterTime" /></th>
			<td>
				<%=formatHelper.formatTimestamp((Long)s.getLastEnterTimestamp())%>
			</td>
		</tr>
		<tr>
			<th><bean:message key="cs_processmonitor.serviceDetail.duration" /></th>
			<td>
				<%=formatHelper.formatDuration((Long)entry.getDuration())%>
			</td>
		</tr>
		<% } else { %>
		<tr>
			<th><bean:message key="cs_processmonitor.serviceDetail.lastEnterTime" /></th>
			<td>
				<%=formatHelper.formatTimestamp((Long)entry.getLastEnterTimestamp())%>
			</td>
		</tr>
		<tr>
			<th><bean:message key="cs_processmonitor.serviceDetail.lastDuration" /></th>
			<td>
				<%=formatHelper.formatDuration((Long)entry.getLastDuration())%>
			</td>
		</tr>
		<% } %>
		<tr>
			<th><bean:message key="cs_processmonitor.serviceDetail.state" /></th>
			<td>
			<%
			if (entry.getState() == AbstractProcessEntry.STATE_ACTIVE) {
		    %>
		    	<bean:message key="cs_processmonitor.serviceDetail.activeCurrentlyExecuting" />
		    <%    
			} else {
		    %>
		    	<bean:message key="cs_processmonitor.serviceDetail.activeNotCurrently.executing_completed" />
		    <%
			}
			%>
			</td>
		</tr>
		<tr>
			<th><bean:message key="cs_processmonitor.serviceDetail.totalStepsCompleted" /></th>
			<td>
				<%=formatHelper.formatInteger(entry.getWorkflowUnitTotalCount())%>
			</td>
		</tr>
		</tbody>
	</table>
	<%
	if (entry.getState() == AbstractProcessEntry.STATE_ACTIVE) {
	%>
	<p>
	<form action="serviceHalt.lsw">
		<input type="hidden" name="id" value="<%=entry.getContextGuid()%>"/>
		<input type="submit" value='<bean:message key="cs_processmonitor.serviceDetail.button_haltService" />'/>
	</form>
	</p>
	<% } %>
	</div>
	<p/>
	<hr width="100%"/>
	<%
	int expensiveStepMaxTheshold = 5000;
	
	if (entry.getActiveWorkflowUnitGuid() != null) {
		String guid = entry.getActiveWorkflowUnitGuid();
		WorkflowUnitEntry wfuEntry = entry.getWorkflowUnits().get(guid);
	%>
		<div class="tablediv">
		<h2><bean:message key="cs_processmonitor.serviceDetail.activeStep" /></h2>
		<table class="sortable" id="activeUnits">
			<thead>
				<tr>
					<th class="name" width="10%"><bean:message key="cs_processmonitor.serviceDetail.processApp" /></th>
					<th class="name" width="30%"><bean:message key="cs_processmonitor.serviceDetail.sub_serviceName" /></th>
					<th class="name" width="30%"><bean:message key="cs_processmonitor.serviceDetail.stepName" /></th>
					<th class="date-time" width="15%"><bean:message key="cs_processmonitor.serviceDetail.enterTime" /></th>
					<th class="duration" width="15%"><bean:message key="cs_processmonitor.serviceDetail.duration" /></th>
				</tr>
			</thead>
			<tbody>
				<tr class="<%=(wfuEntry.getDuration() > expensiveStepMaxTheshold ? "flag" : "normal")%>">
					<td class="name">
						<%=entry.getProcessAppName()%>
					</td>
					<td class="name">
						<%=(!entry.getDiagramId().equals(wfuEntry.getDiagramId())) ? wfuEntry.getDiagramName() : ""%>
					</td>
					<td class="name">
						<%=wfuEntry.getName() != null ? wfuEntry.getName() : ""%>
					</td>
					<td class="date-time">
						<%=formatHelper.formatTimestamp((Long)wfuEntry.getLastEnterTimestamp())%>
					</td>
					<td class="duration">
						<%=formatHelper.formatDuration((Long)wfuEntry.getDuration())%>
					</td>
				</tr>
			</tbody>
		</table>
		</div>
	<% } %>
	
	<div class="tablediv">
	<h2><bean:message key="cs_processmonitor.serviceDetail.completedSteps" /></h2>
	
	<%
	TableState inactiveWorkflowUnitsTable = (TableState)pageContext.getSession().getAttribute(
		"service.detail.inactiveWorkflowUnitsTable");
	if (inactiveWorkflowUnitsTable == null) {
	inactiveWorkflowUnitsTable = new TableState();
	inactiveWorkflowUnitsTable.setParamPrefix("inactiveWorkflowUnits.");
	inactiveWorkflowUnitsTable.setSortFieldKey("lastEnterTimestamp");
	inactiveWorkflowUnitsTable.setSortOrder(false);
	pageContext.getSession().setAttribute(
			"service.detail.inactiveWorkflowUnitsTable", inactiveWorkflowUnitsTable);
	}
	
	// Sorting should be applied before generation of table columns
	inactiveWorkflowUnitsTable.applySortingFromParams(request.getParameterMap());
	%>
	
	<table class="sortable" id="completedUnits">
		<thead>
			<tr>
				<th class="name sortheader" width="10%">
					<% renderTableSortHeaderCell(out, serviceId, inactiveWorkflowUnitsTable,
							TagUtils.getInstance().message(pageContext, null, Globals.LOCALE_KEY,"cs_processmonitor.serviceDetail.processApp"), "processAppName"); %>
				</th>
				<th class="name sortheader" width="25%">
					<% renderTableSortHeaderCell(out, serviceId, inactiveWorkflowUnitsTable,
					        TagUtils.getInstance().message(pageContext, null, Globals.LOCALE_KEY,"cs_processmonitor.serviceDetail.sub_serviceName"), "diagramName"); %>
				</th>
				<th class="name sortheader" width="20%">
					<% renderTableSortHeaderCell(out, serviceId, inactiveWorkflowUnitsTable,
					        TagUtils.getInstance().message(pageContext, null, Globals.LOCALE_KEY,"cs_processmonitor.serviceDetail.stepName"), "name"); %>
				</th>
				<th class="date-time sortheader" width="15%">
					<% renderTableSortHeaderCell(out, serviceId, inactiveWorkflowUnitsTable,
					        TagUtils.getInstance().message(pageContext, null, Globals.LOCALE_KEY,"cs_processmonitor.serviceDetail.lastEnterTime"), "lastEnterTimestamp"); %>
				</th>
				<th class="duration sortheader" width="15%">
					<% renderTableSortHeaderCell(out, serviceId, inactiveWorkflowUnitsTable,
					        TagUtils.getInstance().message(pageContext, null, Globals.LOCALE_KEY,"cs_processmonitor.serviceDetail.totalDuration"), "totalDuration"); %>
				</th>
				<th class="number sortheader" width="15%">
					<% renderTableSortHeaderCell(out, serviceId, inactiveWorkflowUnitsTable,
					        TagUtils.getInstance().message(pageContext, null, Globals.LOCALE_KEY,"cs_processmonitor.serviceDetail.totalInstances"), "count"); %>
				</th>
			</tr>
		</thead>
		<tbody>
		<%
		Map<String, WorkflowUnitEntry<ServiceEntry>> wfuEntries = entry.getWorkflowUnits();
		if (wfuEntries != null) {
			List<WorkflowUnitEntry<ServiceEntry>> records =
				new ArrayList<WorkflowUnitEntry<ServiceEntry>>(wfuEntries.values());

			records = Tuples.sort(records, new TupleComparator(
					inactiveWorkflowUnitsTable.getSortFieldKey(),
					inactiveWorkflowUnitsTable.getSortOrder()));

			String paramInactiveWorkflowUnitsPageIndex = request.getParameter(
					inactiveWorkflowUnitsTable.getParamPrefix() + "pageIndex");

			int inactiveWorkflowUnitsPageIndex = (paramInactiveWorkflowUnitsPageIndex != null ?
					Integer.parseInt(paramInactiveWorkflowUnitsPageIndex) : 0);
			int inactiveWorkflowUnitsPageCount = pmHelper.getPageCount(records,
					inactiveWorkflowUnitsTable.getPageSize());

			records = pmHelper.getPage(records,
					inactiveWorkflowUnitsTable.getPageSize(), inactiveWorkflowUnitsPageIndex);
			
			for (WorkflowUnitEntry<ServiceEntry> wfuEntry : records) { %>
			<tr>
				<td class="name">
					<%=wfuEntry.getProcessAppName()%>
				</td>
				<td>
					<%=(!wfuEntry.getDiagramId().equals(wfuEntry.getDiagramId())) ? wfuEntry.getDiagramName() : ""%>
				</td>
				<td>
					<%=wfuEntry.getName() != null ? wfuEntry.getName() : ""%>
				</td>
				<td class="date-time">
					<%=formatHelper.formatTimestamp((Long)wfuEntry.getLastEnterTimestamp())%>
				</td>
				<td class="duration">
					<%=formatHelper.formatDuration((Long)wfuEntry.getTotalDuration())%>
				</td>
				<td class="number">
					<%=formatHelper.formatInteger(wfuEntry.getCount())%>
				</td>
			</tr>
		<% }
		} %>
		</tbody>
	</table>
	</div>
</body>
</html>

<%!
private void renderTableSortHeaderCell(JspWriter out, String serviceId,
		TableState table, String text, String key) throws java.io.IOException {
	com.ibm.bpm.crconfig.BPMContextRootConfigService ctxRootService = com.ibm.bpm.crconfig.BPMContextRootConfigServiceFactory.getInstance().getContextRootConfigService();	
	boolean order = table.getSortOrder();
	if (!key.equals(table.getSortFieldKey())) {
		order = true;
	} else {
		order = !order;
	}
	out.print("<a class='sortheader' href='serviceDetail.lsw?id=" + serviceId);
	out.print("&" + table.getParamPrefix() + "sort.key=" + key);
	out.print("&" + table.getParamPrefix() + "sort.order=" + order);
	out.print("'>");
	out.print(text);
	if (key.equals(table.getSortFieldKey())) {
		out.print("<img src='"+ctxRootService.getContextRoot(com.ibm.bpm.crconfig.BPMContextRootConfigService.BPM_WARNAME_TEAMWORKS)+"/images/" +
				(table.getSortOrder() ? "sort_asc.gif" : "sort_desc.gif") + "' alt='' border='0'/>");
	}
	out.print("</a>");
}

private void renderTablePaginationBar(JspWriter out, String serviceId,
		TableState table, int pageCount, int pageIndex) throws java.io.IOException {
 	if (pageCount > 1) {
		out.println("<p>");
 		for (int i = 0; i < pageCount; i++) {
 			out.print("<a href='serviceDetail.lsw?id=" + serviceId);
 			out.print("&" + table.getParamPrefix() + "pageIndex=" + i + "' ");
 			out.print("class='" + (i == pageIndex ? "curr-page-number" : "page-number") + "'>");
 			out.print(i + 1);
 			out.print("</a>");
 		}
		out.println("</p>");
 	}
}
%>