<%@ page language="java" pageEncoding="UTF-8" contentType="text/html; charset=UTF-8"%>
<%@ include file="common/prolog.jsp" %>
<%@ include file="/html/msgs-init.jsp" %>
<html>
<head>
<title><bean:message key="cs_syncorg.title" /></title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<script language="JavaScript">
function doOnLoad(){
}
var numRows = 0;
function createAttributeRow(name, value) {
  numRows++;
  var c = document.createElement("input");
  c.setAttribute("id","zUserCheck" + numRows);
  c.setAttribute("type", "checkbox");

  var n = document.createElement("input");
  n.setAttribute("id","zUserName" + numRows);
  n.setAttribute("name","zUserName" + numRows);
  if (name != null) n.setAttribute("value",name);
  n.setAttribute("size","48");

  var tr = document.createElement("tr");
  var td1 = document.createElement("td");
  td1.setAttribute("valign","top");
  td1.appendChild(c);
  var td2 = document.createElement("td");
  td2.setAttribute("valign","top");
  td2.appendChild(n);
  tr.appendChild(td1);
  tr.appendChild(td2);

  return tr;
}

function getTBody() {
  var t = document.getElementById("attrs");
  var tb = t.getElementsByTagName("tbody").item(0);
  // Netscape6 usually has this as null, so let's create a TBODY...
  if (tb == null) {
    tb = document.createElement("tbody");
    t.appendChild(tb);
  }

  return tb;
}

function addAttribute() {
  var tb = getTBody();
  tb.appendChild(createAttributeRow());
}

function removeAttributes() {

  var removeNodes = new Array();

  var tb = getTBody();
  var rows = tb.childNodes;
  // First row is <TH>
  for(i = 1; i < rows.length; i++) {
    var cb = rows[i].firstChild.firstChild;
    if (cb.checked) {
      removeNodes[removeNodes.length] = rows[i];
    }
  }
  for(i = 0; i < removeNodes.length; i++) {
    tb.removeChild(removeNodes[i]);
  }
}

function setupAttributes(attrs) {

  var tb = getTBody();
  // Remove current rows
  while (tb.childNodes.length > 1) {
    tb.removeChild(tb.lastChild);
  }

  for(i = 0; i < attrs.length; i++)
    tb.appendChild(createAttributeRow(attrs[i].name, attrs[i].value));
}
</script>
</head>
<LINK REL="stylesheet" HREF="./html/common/tw_console.css" TYPE="text/css">
<body class="cswelcomebody" style="width:95%" onload='doOnLoad();'>
<table width="100%" valign="top" cellpadding="2" cellspacing="0" border="0" style="margin-top:0px">
<tr><td id="content"><div class="heading"><h1><bean:message key="cs_syncorg.desc" /></h1></div>
</tr>
<tr><td>
<form name="frm" method=post action='cs_syncorg.lsw'>
<input type="hidden" name="zObject" value="UserOrg">
<input type="hidden" name="zType" value="1">
<input type="hidden" name="zActivity" value="Sync">
<input type="hidden" name="zPost" value="1">
<table style="margin:5" cellpadding="2" cellspacing="0" border="0">
<tr><td><div class="cslabel"><bean:message key="cs_syncorg.syncSpecificUsers" /></div></td></tr>
<tr>
<table width="400px" height="160px" cellpadding="0" cellspacing="0" border="0" style="border:solid gray 1px;margin:5px">
<tr height="100%"><td>
<div style="margin:1px; height:240px; overflow:scroll">
<table cellspacing="2" cellpadding="0" id="attrs" width="100%">
  <th width="10%">&nbsp;</th><th align="left" valign="top"><div class="cslabel"><bean:message key="cs_syncorg.userName" /></div></th>
</table>
</div>
</td></tr>
<tr><td align="center"><input class="button" type="button" value='<bean:message key="cs_syncorg.button_add" />' onClick="addAttribute()">&nbsp;<input class="button" type="button" value='<bean:message key="cs_syncorg.button_remove" />' onClick="removeAttributes()"> <input name="zUserSync" class="button" type="submit" value='<bean:message key="cs_syncorg.button_sync" />'></td></tr>
 </table>
</td>
</tr>
<tr><td align="center"><hr></td></tr>
</table>
<p>
<div class="cslabel" style="margin:10px"><input name="zFullSync" type="submit" value=" &nbsp; <bean:message key="cs_syncorg.fullSync" /> &nbsp;"></div>
</form>
<lsw:ErrorMessage><lsw:True><div id="error" class="errortype">&nbsp;<bean:message key="process_server.error.desc" /><span class="errmsg">&nbsp;&nbsp;<lsw:Text/></span></div></lsw:True><lsw:False><div id="error"></div><BR></div></lsw:False></lsw:ErrorMessage>
</td></tr>
<tr><td>
<br/>
<table class="cshlp" cellpadding="2" cellspacing="0">
<tr><td class="cshlp"><div class="lbl"><bean:message key="cs_syncorg.lbl" /></div></td></tr>
<tr><td class="cshlptxt"><div class="info1"><bean:message key="cs_syncorg.info_desc" /><br>
<li><bean:message key="cs_syncorg.info_li1" /></li>
<li><bean:message key="cs_syncorg.info_li2" /></li>
</td></tr>
</div></table>
</table></body></html>
